C     Display the summary information.
C
      SUBROUTINE DISPLY ( FMTPIC, TDSP,   GDSP, OBNAM, OBJLIS,
     .                    WINSYM, WINPTR, WINVAL )
      IMPLICIT NONE
      INCLUDE              'brief.inc'
 
      INTEGER               LBCELL
      PARAMETER           ( LBCELL = -5 )
 
      CHARACTER*(*)         FMTPIC
      LOGICAL               TDSP
      LOGICAL               GDSP
      LOGICAL               OBNAM
      INTEGER               OBJLIS ( LBCELL : * )
 
      CHARACTER*(*)         WINSYM ( LBCELL : * )
      INTEGER               WINPTR ( LBCELL : * )
      DOUBLE PRECISION      WINVAL ( LBCELL : * )
 
C
C     Functions.
C
      INTEGER               CARDC
      INTEGER               OBJACT
      INTEGER               OBJSIZ
      INTEGER               RTRIM
 
C
C     Parameters
C
      INTEGER               LNSIZE
      PARAMETER           ( LNSIZE = 132 )
 
      INTEGER               SMWDSZ
      PARAMETER           ( SMWDSZ = 8 )
 
 
      INTEGER               WDSIZE
      PARAMETER           ( WDSIZE = 64 )
 
C
C     Local Variables.
C
      CHARACTER*(LNSIZE)    HEADER ( 2 )
      CHARACTER*(LNSIZE)    LINE
      CHARACTER*(LNSIZE)    REST
      CHARACTER*(SMWDSZ)    P1
      CHARACTER*(SMWDSZ)    P2
      CHARACTER*(SMWDSZ)    WD
      CHARACTER*(WDSIZE)    NAME
      CHARACTER*(WDSIZE)    NAMES  ( LBCELL : MAXBOD )
 
      DOUBLE PRECISION      FILWIN ( LBCELL : LRGWIN )
      DOUBLE PRECISION      LSTWIN ( LBCELL : LRGWIN )
 
      INTEGER               B
      INTEGER               E
      INTEGER               I
      INTEGER               J
      INTEGER               N1
      INTEGER               N2
      INTEGER               NGROUP
      INTEGER               NLINES
      INTEGER               NOBJ
      INTEGER               NPLINE
      INTEGER               OBJ    ( 2 )
      INTEGER               OBJECT ( 3 )
      INTEGER               OBJN   ( 2 )
      INTEGER               REMAIN
      INTEGER               S
      INTEGER               SIZE
      INTEGER               SOBJ
      INTEGER               START
      INTEGER               WIDEST
 
      LOGICAL               FND
      LOGICAL               FOUND
      LOGICAL               GROUP
      LOGICAL               SAME

C
C     Saved variables
C
C     The SAVE statement that appears here causes f2c to create
C     local variables with static duration.  This enables the CSPICE 
C     version of brief to run under cygwin.
C
      SAVE


 
      GROUP = .NOT. TDSP .OR. GDSP
C
C     First take apart the format picture to see what
C     the various components are.
C
      CALL NEXTWD ( FMTPIC, P1, REST )
      CALL NEXTWD ( REST,   WD, REST )
      CALL NEXTWD ( REST,   P2, REST )
 
      SIZE = 1
      IF ( P2 .NE. ' ' ) THEN
         SIZE = 3
      END IF
 
 
 
 
 
C
C     Find out the width of the widest name.
C
      NOBJ = OBJACT(OBJLIS)
      SOBJ = OBJSIZ(OBJLIS)
C
C     If we don't have any objects to display then
C     we just return.
C
      IF ( NOBJ .EQ. 0 ) THEN
         RETURN
      END IF
 
 
      CALL OBJNTH ( OBJLIS, 1, OBJ, FOUND )
 
      WIDEST = 0
      DO WHILE ( FOUND )
 
         CALL OBJGET ( OBJ,    OBJLIS,   OBJECT              )
         CALL OBJNXT ( OBJ,    OBJLIS,   OBJN,         FOUND )
         CALL PRNAME ( OBJECT, SOBJ, P1, WD, P2, SIZE, NAME  )
 
         WIDEST = MAX ( WIDEST, RTRIM(NAME))
         OBJ(1) = OBJN( 1 )
         OBJ(2) = OBJN( 2 )
 
      END DO
 
C
C     Are we going to group by window?  If not, this is pretty
C     easy.  Just display stuff.
C
 
      IF ( TDSP .AND. .NOT. GDSP ) THEN
 
         S = WIDEST + 3
         E = S + 32
 
         LINE(1:) = 'Bodies'
         LINE(S:) = 'Start of Interval (ET)'
         LINE(E:) = 'End of Interval (ET) '
 
         CALL WRITIT ( LINE )
 
         LINE(1:) = '-------'
         LINE(S:) = '-----------------------------'
         LINE(E:) = '-----------------------------'
 
         CALL WRITIT ( LINE )
 
         CALL OBJNTH ( OBJLIS, 1, OBJ, FOUND )
 
         N1 = 0
 
         DO WHILE ( FOUND )
 
            LINE = ' '
            CALL OBJGET ( OBJ,    OBJLIS,   OBJECT              )
            CALL PRNAME ( OBJECT, SOBJ, P1, WD, P2, SIZE, LINE  )
            CALL MAKNAM ( OBJECT, SOBJ, OBNAM,            NAME  )
            CALL SYGETD ( NAME,   WINSYM,
     .                            WINPTR,
     .                            WINVAL, N2,   FILWIN(1), FOUND )
 
            IF ( N2 .EQ. N1 ) THEN
 
               SAME = .TRUE.
               I    =  1
               DO WHILE ( SAME .AND. I .LE. N1 )
                  SAME = FILWIN(I) .EQ. LSTWIN(I)
                  I    = I + 1
               END DO
 
            ELSE
               SAME = .FALSE.
            END IF
 
 
            IF ( .NOT. SAME ) THEN
 
               DO I = 1, N2, 2
                  CALL ETCAL ( FILWIN(I  ), LINE(S:) )
                  CALL ETCAL ( FILWIN(I+1), LINE(E:) )
                  CALL WRITIT ( LINE )
                  LINE = ' '
                  LSTWIN(I)   = FILWIN(I)
                  LSTWIN(I+1) = FILWIN(I+1)
                  N1          = N2
               END DO
 
            ELSE
 
               LINE(S+12:) = 'Same coverage as previous object '
               CALL WRITIT ( LINE )
 
            END IF
 
            CALL OBJNXT ( OBJ, OBJLIS, OBJ, FOUND )
 
         END DO
 
      ELSE IF ( TDSP .AND. GDSP ) THEN
 
         S = WIDEST + 3
         E = S + 32
 
         LINE(1:) = 'Bodies'
         LINE(S:) = 'Start of Interval (ET)'
         LINE(E:) = 'End of Interval (ET) '
 
         CALL WRITIT ( LINE )
 
         LINE(1:) = '-------'
         LINE(S:) = '-----------------------------'
         LINE(E:) = '-----------------------------'
 
         CALL WRITIT ( LINE )
 
         CALL OBJNTH ( OBJLIS, 1, OBJ, FOUND )
 
 
         DO WHILE ( FOUND )
 
            LINE = ' '
            CALL OBJGET ( OBJ,    OBJLIS,   OBJECT              )
            CALL PRNAME ( OBJECT, SOBJ, P1, WD, P2, SIZE, LINE  )
            CALL MAKNAM ( OBJECT, SOBJ, OBNAM,            NAME  )
            CALL SYGETD ( NAME,   WINSYM,
     .                            WINPTR,
     .                            WINVAL, N1,   FILWIN(1), FOUND )
 
            DO I = 1, N1, 2
               CALL ETCAL ( FILWIN(I  ), LINE(S:) )
               CALL ETCAL ( FILWIN(I+1), LINE(E:) )
               CALL WRITIT ( LINE )
               LINE = ' '
               LSTWIN(I)   = FILWIN(I)
               LSTWIN(I+1) = FILWIN(I+1)
            END DO
 
            CALL OBJNXT ( OBJ, OBJLIS, OBJN, FND )
            CALL OBJREM ( OBJ, OBJLIS )
            OBJ(1) = OBJN(1)
            OBJ(2) = OBJN(2)
 
            DO WHILE ( FND )
 
               LINE = ' '
               CALL OBJGET ( OBJ,    OBJLIS,   OBJECT              )
               CALL PRNAME ( OBJECT, SOBJ, P1, WD, P2, SIZE, LINE  )
               CALL MAKNAM ( OBJECT, SOBJ, OBNAM,            NAME  )
               CALL SYGETD ( NAME,   WINSYM,
     .                               WINPTR,
     .                               WINVAL, N2,   FILWIN(1), FOUND )
 
               IF ( N2 .EQ. N1 ) THEN
 
                  SAME = .TRUE.
                  I    =  1
                  DO WHILE ( SAME .AND. I .LE. N1 )
                     SAME = FILWIN(I) .EQ. LSTWIN(I)
                     I    = I + 1
                  END DO
 
               ELSE
                  SAME = .FALSE.
               END IF
 
 
               IF ( SAME ) THEN
 
                  LINE(S+12:) = 'Same coverage as previous object '
                  CALL WRITIT ( LINE )
 
               END IF
 
               CALL OBJNXT ( OBJ, OBJLIS, OBJN, FND )
 
               IF ( SAME ) THEN
                  CALL OBJREM ( OBJ, OBJLIS )
               END IF
 
               OBJ(1) = OBJN(1)
               OBJ(2) = OBJN(2)
 
            END DO
 
            CALL OBJNTH ( OBJLIS, 1, OBJ, FOUND )
 
         END DO
 
 
      ELSE
 
         CALL OBJNTH ( OBJLIS, 1, OBJ, FOUND )
 
         DO WHILE ( FOUND )
 
            CALL SSIZEC ( MAXBOD, NAMES )
            CALL OBJGET ( OBJ,    OBJLIS,   OBJECT )
            CALL PRNAME ( OBJECT, SOBJ, P1, WD, P2, SIZE, NAME )
            CALL APPNDC ( NAME,   NAMES )
C
C           Look up the window associated with this object.
C
            CALL MAKNAM ( OBJECT, SOBJ, OBNAM,            NAME  )
            CALL SYGETD ( NAME,   WINSYM,
     .                            WINPTR,
     .                            WINVAL, N1,   LSTWIN(1), FND   )
C
C           Fetch the next object.
C
            CALL OBJNXT ( OBJ, OBJLIS, OBJN, FND )
            CALL OBJREM ( OBJ, OBJLIS )
 
            OBJ(1) = OBJN(1)
            OBJ(2) = OBJN(2)
 
            DO WHILE ( FND )
 
               CALL OBJGET ( OBJ,    OBJLIS, OBJECT )
 
               CALL MAKNAM ( OBJECT, SOBJ,   OBNAM, NAME  )
               CALL SYGETD ( NAME,   WINSYM,
     .                               WINPTR,
     .                               WINVAL, N2,   FILWIN(1),   FND   )
C
C              See if this window is the same as the current
C              window under considerations.
C
               IF ( N1 .EQ. N2 ) THEN
                  SAME = .TRUE.
                  I    =  1
 
                  DO WHILE ( SAME .AND. I .LE. N1 )
                     SAME = FILWIN(I) .EQ. LSTWIN(I)
                     I    = I+1
                  END DO
               ELSE
                  SAME = .FALSE.
               END IF
 
               CALL OBJNXT ( OBJ, OBJLIS, OBJN, FND )
 
               IF ( SAME ) THEN
                  CALL OBJREM ( OBJ,    OBJLIS )
                  CALL PRNAME ( OBJECT, SOBJ, P1, WD, P2, SIZE, NAME )
                  CALL APPNDC ( NAME,   NAMES )
               END IF
 
               OBJ(1) = OBJN(1)
               OBJ(2) = OBJN(2)
 
            END DO
 
            NGROUP = CARDC ( NAMES )
 
            IF ( NGROUP .EQ. 1 ) THEN
               LINE  = 'Body: '
               START =  7
            ELSE
               LINE  = 'Bodies: '
               START =  9
            END IF
 
            NPLINE = 1 + (( 80 - WIDEST - START )/( WIDEST + 2 ))
 
            CALL RMAINI  ( NGROUP, NPLINE, NLINES, REMAIN )
 
            IF ( REMAIN .NE. 0 ) THEN
               NLINES = NLINES + 1
            END IF
 
            DO J = 1, NLINES
 
               B = START
 
               DO I = J, NGROUP, NLINES
                  LINE(B:) = NAMES(I)
                  B        = B + WIDEST + 2
               END DO
 
               CALL WRITIT ( LINE )
               LINE = ' '
 
            END DO
 
            HEADER(1) = ' '
            HEADER(2) = ' '
            HEADER(1)(START:) = 'Start of Interval (ET)   '
     .      //                  '           End of Inter'
     .      //                  'val (ET)'
            HEADER(2)(START:) = '-------------------------'
     .      //                  '-------    --------------'
     .      //                  '------------------'
 
            S = START
            E = START + 36
 
            CALL WRITIT ( HEADER(1) )
            CALL WRITIT ( HEADER(2) )
 
            DO I = 1, N1, 2
               LINE = ' '
               CALL ETCAL ( LSTWIN(I),   LINE(S:) )
               CALL ETCAL ( LSTWIN(I+1), LINE(E:) )
               CALL WRITIT ( LINE )
            END DO
 
            CALL WRITIT ( ' ' )
 
            CALL OBJNTH ( OBJLIS, 1, OBJ, FOUND )
 
         END DO
 
      END IF
 
      RETURN
      END
