C$ Abstract
C
C    Constants required by the family of "object" routines.
C
C$ Copyright
C
C     Copyright (1995), California Institute of Technology.
C     U.S. Government sponsorship acknowledged.
C
C$ Required_Reading
C
C     None.
C
C$ Keywords
C
C     OBJECTS
C
C$ Parameters
C
C     LBCELL   is the lower bound for all cells used throughout
C              the SPICE library..
C
C     NULL     is a constant used to indicate that a particular
C              object in a list is unused.
C
C     RMPOBJ   is the slot in the object list that tells how
C              many values are stored for each object.  I.E.
C              the number of values stored for each object
C              in an object list OBJLIS is OBJLIS(RMPOBJ).
C
C     NACTIV   is the slot in an object list that tells hows
C              many objects in the list are currently active.
C              In otherwords the number of active objects
C              in the object list OBJLIS is OBJLIS(NACTIV)
C
C     LSTID    is the slot in an object list that gives the
C              last object unique ID that was assigned.
C              In otherwords, the value of the last unique
C              object ID code in the object list OBJLIS
C              is OBJLIS(LSTID).
C
C$ Files
C
C     None.
C
C$ Exceptions
C
C     Not Applicable
C
C$ Particulars
C
C     This include file contains the parameters used by the
C     family of object routines.
C
C$ Author_and_Institution
C
C     W.L. Taber      (JPL)
C
C$ Literature_References
C
C     None.
C
C$ Version
C
C-    SPICELIB Version 1.0.0, 23-FEB-1996 (WLT)
C
C
C-&
      INTEGER               LBCELL
      PARAMETER           ( LBCELL = -5 )
 
      INTEGER               NULL
      PARAMETER           ( NULL   = 0 )
 
      INTEGER               RMPOBJ
      PARAMETER           ( RMPOBJ = -2 )
 
      INTEGER               NACTIV
      PARAMETER           ( NACTIV = -3 )
 
      INTEGER               LSTID
      PARAMETER           ( LSTID  = -4 )
