C
C     Initialize an object list.
C
      SUBROUTINE OBJINL ( OBJSIZ, NOBJ, OBJLIS )
      IMPLICIT NONE
 
      INCLUDE              'object.inc'
 
      INTEGER               OBJLIS ( LBCELL : * )
      INTEGER               OBJSIZ
      INTEGER               NOBJ
 
C
C     Each object has an extra space that specifies
C     the objects id-code and status.  The object
C     is "active" if the extra-space has a non-null
C     value.
C
      INTEGER               ROOM
      INTEGER               MTASIZ
      INTEGER               I
      INTEGER               J
C
C     Compute the number of slots required to store NOBJ objects
C     each of size OBJSIZ.  Recall that each object has an
C     extra "ID" slot.
C
      ROOM   = ( OBJSIZ + 1 ) * NOBJ
      MTASIZ =   OBJSIZ + 1
C
C     Set the size of the cell
C
      CALL SSIZEI ( ROOM, OBJLIS )
C
C     Fill in the extra slots of the cell used by the objects.
C
      OBJLIS ( RMPOBJ ) = MTASIZ
      OBJLIS ( NACTIV ) = 0
      OBJLIS ( LSTID  ) = 0
C
C     Set each object to have a NULL ID code.
C
      DO I = 1, NOBJ
         J         = (I-1)*MTASIZ + 1
         OBJLIS(J) =  NULL
      END DO
 
      RETURN
      END
