C     Modify a component of an active object.
C
      SUBROUTINE OBJMOD ( OBJ, COMP, VALUE, OBJLIS )
 
      IMPLICIT NONE
      INCLUDE              'object.inc'
 
      INTEGER               OBJ    ( 2 )
      INTEGER               COMP
      INTEGER               VALUE
      INTEGER               OBJLIS ( LBCELL: * )
C
C     Local Variables
C
      INTEGER               I
      INTEGER               OBJSIZ
      LOGICAL               OK
 
      CALL OBJCHK ( 'OBJMOD', OBJ, OBJLIS, OK )
 
      IF ( .NOT. OK ) THEN
         RETURN
      END IF
 
      IF ( OBJ(2) .EQ. NULL ) THEN
         CALL CHKIN ( 'OBJMOD' )
         CALL SETMSG('You are attempting to modify the value of an '
     .   //          'inactive object.  You can only modify the '
     .   //          'value of an active object.  The object '
     .   //          'pointer has value #. ' )
         CALL ERRINT( '#', OBJ(1) )
         CALL SIGERR( 'SPICE(INACTIVEOBJECT)'  )
         CALL CHKOUT( 'OBJMOD' )
         RETURN
      END IF
 
      OBJSIZ = OBJLIS(RMPOBJ) - 1
 
      IF ( COMP .LT. 1 .OR. COMP .GT. OBJSIZ ) THEN
         CALL CHKIN ( 'OBJMOD' )
         CALL SETMSG( 'Objects in the list supplied have # '
     .   //           'components. You are attempting to modify '
     .   //           'component # of the object. ' )
         CALL ERRINT( '#', OBJSIZ )
         CALL ERRINT( '#', COMP   )
         CALL SIGERR( 'SPICE(BADCOMPNUMBER)'  )
         CALL CHKOUT( 'OBJMOD' )
         RETURN
      END IF
 
      I         = OBJ(1) + COMP
      OBJLIS(I) = VALUE
 
      RETURN
      END
