C     Return the N'th object from an object list.
C
      SUBROUTINE OBJNTH ( OBJLIS, N, OBJ, FOUND )
 
      IMPLICIT NONE
      INCLUDE              'object.inc'
 
      INTEGER               OBJLIS ( LBCELL: * )
      INTEGER               N
      INTEGER               OBJ    ( 2 )
      LOGICAL               FOUND
 
C
C     SPICELIB Functions
C
      INTEGER               CARDI
C
C     Local Variables
C
      INTEGER               MTASIZ
      INTEGER               NOBJ
      INTEGER               SIZE
      INTEGER               USED
      INTEGER               PTR
      INTEGER               I
 
 
      NOBJ   = OBJLIS ( NACTIV )
      MTASIZ = OBJLIS ( RMPOBJ )
      SIZE   = CARDI  ( OBJLIS )
      USED   = NOBJ * MTASIZ
 
      IF ( N .LE. 0 ) THEN
         OBJ(1) = 0
         OBJ(2) = NULL
         FOUND  = .FALSE.
         RETURN
      END IF
 
      IF ( N .GT. NOBJ ) THEN
         OBJ(1) = 0
         OBJ(2) = NULL
         FOUND  = .FALSE.
         RETURN
      END IF
C
C     The easy case is the one in which all objects are packed
C     together with no null objects between them.
C
      IF ( USED .EQ. SIZE ) THEN
         PTR    = (N-1)*MTASIZ + 1
         OBJ(1) = PTR
         OBJ(2) = OBJLIS(PTR)
         FOUND  = .TRUE.
         RETURN
      END IF
C
C     Hmmmm.  Well we don't have the easy case.  Look through
C     the objects until we find the n'th non-null object.
C
      PTR = 1 - MTASIZ
 
      DO I = 1, N
 
         PTR = PTR + MTASIZ
 
         DO WHILE ( OBJLIS(PTR) .EQ. NULL )
            PTR = PTR + MTASIZ
         END DO
 
      END DO
 
      OBJ(1) = PTR
      OBJ(2) = OBJLIS(PTR)
      RETURN
 
      END
