C     Get the id of the next object in the list.
C
      SUBROUTINE OBJNXT ( OBJ, OBJLIS, OBJN, FOUND )
 
      IMPLICIT NONE
      INCLUDE              'object.inc'
 
      INTEGER               OBJ    ( 2 )
      INTEGER               OBJLIS ( LBCELL : * )
      INTEGER               OBJN   ( 2 )
      LOGICAL               FOUND
 
C
C     Spicelib Function
C
      INTEGER               CARDI
 
C
C     Local Variables
C
      INTEGER               I
      INTEGER               MTASIZ
      INTEGER               SIZE
      INTEGER               PTR
 
      LOGICAL               OK
 
C
C     Perform some sanity checks on the OBJ. Note OBJCHK
C     does all the required checking in and checking out.
C
      CALL OBJCHK ( 'OBJNXT', OBJ, OBJLIS, OK )
 
      SIZE   = CARDI ( OBJLIS )
      MTASIZ = OBJLIS( RMPOBJ )
 
      IF ( .NOT. OK ) THEN
         RETURN
      END IF
 
      PTR  = OBJ ( 1 )
 
      IF ( PTR .EQ. 0 ) THEN
         PTR = 1
      END IF
 
      I = PTR + MTASIZ
 
      DO WHILE ( I .LT. SIZE )
C
C        If this object is a non-null object, then we're done
C        looking.
C
         IF ( OBJLIS(I) .NE. NULL ) THEN
            OBJN(1) = I
            OBJN(2) = OBJLIS(I)
            FOUND   = .TRUE.
            RETURN
         END IF
C
C        Not done yet.  Look at the next object.
C
         I = I + MTASIZ
 
      END DO
 
C
C     If you get to this point, there wasn't a next object.
C     point at the next "available" slot and set the identifier
C     to null.
C
      FOUND     = .FALSE.
      OBJN(1) =  I
      OBJN(2) =  NULL
 
      RETURN
      END
