C     Object Search By Function
C
C     Find the first object for which F(OBJECT) is TRUE.
C
      SUBROUTINE OBJSBF ( F, START, OBJLIS, OBJ, FOUND )
 
      IMPLICIT NONE
      INCLUDE              'object.inc'
      EXTERNAL              F
      LOGICAL               F
      INTEGER               START
      INTEGER               OBJLIS ( LBCELL : * )
      INTEGER               OBJ    ( 2 )
      LOGICAL               FOUND
 
C
C     Local Variables.
C
      INTEGER               PTR
      INTEGER               LAST
      INTEGER               SIZE
      INTEGER               MYBEG
      INTEGER               I
 
C
C     Since we may have to do a lot of lookups, we first
C     compress the object list to improve search performance.
C
      CALL OBJCMP ( OBJLIS )
 
 
 
      LAST  = OBJLIS ( NACTIV ) + 1
      SIZE  = OBJLIS ( RMPOBJ ) - 1
      MYBEG = MIN    ( MAX ( START, 1 ), LAST )
 
      DO I = MYBEG, LAST
 
         CALL OBJNTH ( OBJLIS, I, OBJ, FOUND )
 
         PTR = OBJ(1) + 1
C
C        If this object matches the selection criteria, we
C        can simply return it.
C
         IF ( FOUND ) THEN
            IF ( F( OBJLIS(PTR), SIZE ) ) THEN
               RETURN
            END IF
         END IF
 
      END DO
 
      FOUND  = .FALSE.
      OBJ(1) = NULL
      OBJ(2) = 0
 
      RETURN
      END
