C$Procedure      FIXUNI ( Temporary fix for UNITIM bug. )
 
      SUBROUTINE  FIXUNI

C$ Abstract
C
C     This routine sets POOL watch for LSK variables that is not 
C     set by UNITIM when it fails the first time it's called.
C     This (or equivalent) fix will be made in UNITIM for N0049
C     delivery.
C
C$ Copyright
C
C     Copyright (1999), California Institute of Technology.
C     U.S. Government sponsorship acknowledged.
C
C$ Author_and_Institution
C
C     B.V. Semenov     (NAIF)      
C
C$ Version
C
C-    CKBRIEF Beta Version 1.0.0, 11-AUG-1998 (BVS)
C
C-&

C
C     All variables, parameters and actual code in this routine 
C     were "borrowed" from SPICELIB's UNITIM.
C

C
C     NEEDED is the number of kernel pool variables needed by this
C     routine.
C
      INTEGER               NEEDED
      PARAMETER           ( NEEDED = 4 )
 
C
C     VARS holds names of these variables. VARS are to be saved.
C
      CHARACTER*(32)        VARS   ( NEEDED )
      
      SAVE                  VARS
      
C
C     Initial values of VARS correspond to those in UNITIM.
C
      DATA                  VARS     / 'DELTET/DELTA_T_A',
     .                                 'DELTET/K',
     .                                 'DELTET/EB',
     .                                 'DELTET/M'              /

C
C     The only thing this routine has to do is to set watchers 
C     to fix the problem in UNITIM.
C
      CALL SWPOOL ( 'UNITIM', NEEDED, VARS )
      
C
C     All done. Bye-bye.
C
      RETURN
      END
