 
C$Procedure      SUBTEX ( Subset TeX )
 
      SUBROUTINE SUBTEX ( BUFFER )
 
C$ Abstract
C
C     Convert a buffer containing TeX source lines to an equivalent
C     buffer containing ASCII text.
C
C$ Declarations
 
      INTEGER               LBCELL
      PARAMETER           ( LBCELL = -5 )
 
      CHARACTER*(*)         BUFFER ( LBCELL:* )
 
C$ Author_and_Institution
C
C     I.M. Underwood (JPL)
C
C$ Version
C
C     Beta Version 1.0.0, 11-JUN-1988 (IMU)
C
C-&
 
 
C
C     SPICELIB functions
C
      INTEGER               CARDC
      LOGICAL               RETURN
 
C
C     Local variables
C
      INTEGER               CARD
      INTEGER               FIRST
      INTEGER               LAST
 
 
C
C     Standard SPICE error handling
C
      IF ( RETURN() ) THEN
         RETURN
      ELSE
         CALL CHKIN ( 'SUBTEX' )
      END IF
 
C
C     Expand @input commands.
C
      CALL EXPAND ( BUFFER )
 
C
C     Preprocess the original buffer (to remove TABs and other
C     odd characters).
C
      CALL PREP ( BUFFER )
 
C
C     Chunks are processed sequentially. PROC writes to standard
C     output, instead of returning the buffer.
C
      CARD  = CARDC ( BUFFER )
      FIRST = 1
 
      DO WHILE ( FIRST .LE. CARD )
 
         CALL CHUNK ( BUFFER, FIRST, LAST )
 
         IF ( BUFFER(FIRST) .NE. ' ' ) THEN
            CALL PROC ( BUFFER, FIRST, LAST )
         END IF
 
         FIRST = LAST + 1
 
      END DO
 
      CALL CHKOUT ( 'SUBTEX' )
      RETURN
      END
 
