C$Procedure      CLEARD ( Clear a double precision array )
 
      SUBROUTINE CLEARD ( NDIM, ARRAY )
 
C$ Abstract
C
C      Fill a double precision array with zeros.
C
C$ Copyright
C
C     Copyright (1995), California Institute of Technology.
C     U.S. Government sponsorship acknowledged.
C
C$ Required_Reading
C
C     None.
C
C$ Keywords
C
C      ARRAY,  ASSIGNMENT
C
C$ Declarations
 
      INTEGER            NDIM
      DOUBLE PRECISION   ARRAY ( * )
 
C$ Brief_I/O
C
C      VARIABLE  I/O   DESCRIPTION
C      --------  ---  ---------------------------------------
C       NDIM      I    The number of elements of ARRAY which are to be
C                      set to zero.
C       ARRAY     O    Double precision array to be filled.
C
C$ Detailed_Input
C
C      NDIM       is the number of elements in ARRAY which are to be
C                 set to zero.
C
C$ Detailed_Output
C
C      ARRAY      is the double precision array which it to be filled
C                 with zeros.
C
C$ Parameters
C
C      None.
C
C$ Particulars
C
C      None.
C
C$ Examples
C
C      If NDIM = 4, then the contents of ARRAY are:
C
C      ARRAY (1) = 0.0D0
C      ARRAY (2) = 0.0D0
C      ARRAY (3) = 0.0D0
C      ARRAY (4) = 0.0D0
C
C$ Restrictions
C
C      None.
C
C$ Exceptions
C
C     Error free.
C
C     1) If NDIM < 1, the array is not modified.
C
C$ Files
C
C      None.
C
C$ Author_and_Institution
C
C      W.M. Owen       (JPL)
C
C$ Literature_References
C
C      None.
C
C$ Version
C
C-    SPICELIB Version 1.0.1, 10-MAR-1992 (WLT)
C
C        Comment section for permuted index source lines was added
C        following the header.
C
C-    SPICELIB Version 1.0.0, 31-JAN-1990 (WMO)
C
C-&
 
C$ Index_Entries
C
C     clear a d.p. array
C
C-&
 
 
 
C
C     Local variables
C
      INTEGER I
 
 
      DO I = 1, NDIM
        ARRAY(I) = 0.D0
      END DO
 
 
      RETURN
      END
