C
C     Include Section:  EK Join Row Set Parameters
C
C        ekjrs.inc  Version 1    07-FEB-1995 (NJB)
C
C
C     Maximum number of join row sets in a join row set union:
C
      INTEGER               MXJRS
      PARAMETER           ( MXJRS  = 200 )
 
 
C
C     The layout of a join row set in the EK scratch area is shown
C     below:
C
C        +--------------------------------------------+
C        |              join row set size             |  1 element
C        +--------------------------------------------+
C        |    number of row vectors in join row set   |  1 element
C        +--------------------------------------------+
C        |               table count (TC)             |  1 element
C        +--------------------------------------------+
C        |          segment vector count (SVC)        |  1 element
C        +--------------------------------------------+
C        |               segment vector 1             |  TC elements
C        +--------------------------------------------+
C                              .
C                              .
C                              .
C        +--------------------------------------------+
C        |               segment vector SVC           |  TC elements
C        +--------------------------------------------+
C        |   segment vector 1 row set base address    |  1 element
C        +--------------------------------------------+
C        |      segment vector 1 row count (RC_1)     |  1 element
C        +--------------------------------------------+
C                              .
C                              .
C                              .
C        +--------------------------------------------+
C        |  segment vector SVC row set base address   |  1 element
C        +--------------------------------------------+
C        |   segment vector SVC row count (RC_SVC)    |  1 element
C        +--------------------------------------------+
C        | Augmented row vectors for segment vector 1 |  (TC+1)*RC_1
C        +--------------------------------------------+  elements
C                              .
C                              .
C                              .
C        +--------------------------------------------+
C        |Augmented row vectors for segment vector SVC|  (TC+1)*RC_SVC1
C        +--------------------------------------------+  elements
C
C
C     The following parameters indicate positions of elements in the
C     join row set structure:
C
C
C     Base-relative index of join row set size
C
      INTEGER               JSZIDX
      PARAMETER           ( JSZIDX = 1 )
 
C
C     Index of row vector count
C
      INTEGER               JRCIDX
      PARAMETER           ( JRCIDX = 2 )
 
C
C     Index of table count
C
      INTEGER               JTCIDX
      PARAMETER           ( JTCIDX = 3 )
 
C
C     Index of segment vector count
C
      INTEGER               JSCIDX
      PARAMETER           ( JSCIDX = 4 )
 
C
C     Base address of first segment vector
C
      INTEGER               JSVBAS
      PARAMETER           ( JSVBAS = 4 )
C
C
C     End Include Section:  EK Join Row Set Parameters
C
