C
C     Include Section:  EK Das Paging Parameters
C
C        ekpage.inc  Version 4    25-AUG-1995 (NJB)
C
C
C
C     The EK DAS paging system makes use of the integer portion
C     of an EK file's DAS address space to store the few numbers
C     required to describe the system's state.  The allocation
C     of DAS integer addresses is shown below.
C
C
C                       DAS integer array
C
C        +--------------------------------------------+
C        |            EK architecture code            |  Address = 1
C        +--------------------------------------------+
C        |      Character page size (in DAS words)    |
C        +--------------------------------------------+
C        |        Character page base address         |
C        +--------------------------------------------+
C        |      Number of character pages in file     |
C        +--------------------------------------------+
C        |   Number of character pages on free list   |
C        +--------------------------------------------+
C        |      Character free list head pointer      |  Address = 6
C        +--------------------------------------------+
C        |                                            |  Addresses =
C        |           Metadata for d.p. pages          |    7--11
C        |                                            |
C        +--------------------------------------------+
C        |                                            |  Addresses =
C        |         Metadata for integer pages         |    12--16
C        |                                            |
C        +--------------------------------------------+
C                              .
C                              .
C                              .
C        +--------------------------------------------+
C        |                                            |  End Address =
C        |                Unused space                |  integer page
C        |                                            |  end
C        +--------------------------------------------+
C        |                                            |  Start Address =
C        |             First integer page             |  integer page
C        |                                            |  base
C        +--------------------------------------------+
C                              .
C                              .
C                              .
C        +--------------------------------------------+
C        |                                            |
C        |              Last integer page             |
C        |                                            |
C        +--------------------------------------------+
C
C     The following parameters indicate positions of elements in the
C     paging system metadata array:
C
C
      INTEGER               EPARCH
      PARAMETER           ( EPARCH = 1 )
 
C
C     Number of metadata items per data type:
C
      INTEGER               EPNIPT
      PARAMETER           ( EPNIPT = 5 )
 
C
C     Character metadata indices:
C
      INTEGER               EPPSZC
      PARAMETER           ( EPPSZC = EPARCH + 1 )
 
      INTEGER               EPBASC
      PARAMETER           ( EPBASC = EPPSZC + 1 )
 
      INTEGER               EPNPC
      PARAMETER           ( EPNPC  = EPBASC + 1 )
 
      INTEGER               EPNFPC
      PARAMETER           ( EPNFPC = EPNPC  + 1 )
 
      INTEGER               EPFPC
      PARAMETER           ( EPFPC  = EPNFPC + 1 )
 
C
C     Double precision metadata indices:
C
      INTEGER               EPPSZD
      PARAMETER           ( EPPSZD = EPPSZC + EPNIPT )
 
      INTEGER               EPBASD
      PARAMETER           ( EPBASD = EPPSZD + 1 )
 
      INTEGER               EPNPD
      PARAMETER           ( EPNPD  = EPBASD + 1 )
 
      INTEGER               EPNFPD
      PARAMETER           ( EPNFPD = EPNPD  + 1 )
 
      INTEGER               EPFPD
      PARAMETER           ( EPFPD  = EPNFPD + 1 )
 
C
C     Integer metadata indices:
C
      INTEGER               EPPSZI
      PARAMETER           ( EPPSZI = EPPSZD + EPNIPT )
 
      INTEGER               EPBASI
      PARAMETER           ( EPBASI = EPPSZI + 1 )
 
      INTEGER               EPNPI
      PARAMETER           ( EPNPI  = EPBASI + 1 )
 
      INTEGER               EPNFPI
      PARAMETER           ( EPNFPI = EPNPI  + 1 )
 
      INTEGER               EPFPI
      PARAMETER           ( EPFPI  = EPNFPI + 1 )
 
C
C     Size of metadata area:
C
      INTEGER               EPMDSZ
      PARAMETER           ( EPMDSZ = 1 + 3*EPNIPT )
 
C
C     Page sizes, in units of DAS words of the appropriate type:
C
      INTEGER               PGSIZC
      PARAMETER           ( PGSIZC = 1024 )
 
      INTEGER               PGSIZD
      PARAMETER           ( PGSIZD = 128 )
 
      INTEGER               PGSIZI
      PARAMETER           ( PGSIZI = 256 )
 
C
C     Default page base addresses:
C
      INTEGER               PGBASC
      PARAMETER           ( PGBASC = 0 )
 
      INTEGER               PGBASD
      PARAMETER           ( PGBASD = 0 )
 
      INTEGER               PGBASI
      PARAMETER           ( PGBASI = 256 )
 
 
C
C     End Include Section:  EK Das Paging Parameters
C
