C$Procedure            EVEN  ( Is an integer even? )
 
      LOGICAL FUNCTION EVEN ( I )
 
C$ Abstract
C
C      Determine whether an integer is even.
C
C$ Copyright
C
C     Copyright (1995), California Institute of Technology.
C     U.S. Government sponsorship acknowledged.
C
C$ Required_Reading
C
C     None.
C
C$ Keywords
C
C      NUMBERS
C
C$ Declarations
 
      INTEGER          I
 
C$ Brief_I/O
C
C      VARIABLE  I/O  DESCRIPTION
C      --------  ---  --------------------------------------------------
C      I          I   The integer in question.
C      EVEN       O   True if I is even, otherwise false.
C
C$ Detailed_Input
C
C      I           is the integer to be tested for evenness.
C
C$ Detailed_Output
C
C      EVEN        is true if I is even, false if I is odd.
C
C$ Parameters
C
C      None.
C
C$ Particulars
C
C      None.
C
C$ Examples
C
C      Let ENDPTS contain a series of endpoints,
C
C         a , b , ..., a , b
C          1   1        n   n
C
C      representing an ordered collection of disjoint intervals,
C
C         a   <  b   < a
C          i  -   i     i+1
C
C      The following code fragment uses EVEN to determine whether
C      an arbitrary value X is contained in any of the intervals.
C
C         CONTAINED = .FALSE.
C
C         DO I = 1, N-1
C            IF ( X .GE. ENDPTS(I)  .AND.  X .LE. ENDPTS(I+1) ) THEN
C               CONTAINED = ( .NOT. EVEN ( I ) )
C            END IF
C         END DO
C
C$ Restrictions
C
C      None.
C
C$ Exceptions
C
C     Error free.
C
C$ Files
C
C      None.
C
C$ Author_and_Institution
C
C      I.M. Underwood  (JPL)
C
C$ Literature_References
C
C      None.
C
C$ Version
C
C-    SPICELIB Version 1.0.1, 10-MAR-1992 (WLT)
C
C        Comment section for permuted index source lines was added
C        following the header.
C
C-    SPICELIB Version 1.0.0, 31-JAN-1990 (IMU)
C
C-&
 
C$ Index_Entries
C
C     test whether an integer is even
C
C-&
 
 
 
 
C$ Revisions
C
C-    Beta Version 1.0.1, 27-JAN-1989 (IMU)
C
C        Examples section completed.
C
C-&
 
 
 
C
C     Self-explanatory.
C
      EVEN = ( MOD (I,2) .EQ. 0 )
 
      RETURN
      END
 
