C$Procedure      FILLI ( Fill an integer array )
 
      SUBROUTINE FILLI ( VALUE, NDIM, ARRAY )
 
C$ Abstract
C
C      Fill an integer array with a specified value.
C
C$ Copyright
C
C     Copyright (1995), California Institute of Technology.
C     U.S. Government sponsorship acknowledged.
C
C$ Required_Reading
C
C     None.
C
C$ Keywords
C
C      ARRAY,  ASSIGNMENT
C
C$ Declarations
 
      INTEGER    VALUE
      INTEGER    NDIM
      INTEGER    ARRAY ( * )
 
C$ Brief_I/O
C
C  VARIABLE  I/O              DESCRIPTION
C  --------  ---  ------------------------------------------------------
C   VALUE     I     Integer value to be placed in all the elements of
C                   ARRAY.
C   NDIM      I     The number of elements in ARRAY.
C   ARRAY     O     Integer array which is to be filled.
C
C$ Detailed_Input
C
C      VALUE     is the value to be assigned to the array elements
C                1 through NDIM.
C
C      NDIM      is the number of elements in the array.
C
C$ Detailed_Output
C
C      ARRAY     is a integer array whose elements are to be set
C                to VALUE.
C
C$ Parameters
C
C      None.
C
C$ Particulars
C
C      None.
C
C$ Examples
C
C       Let  VALUE = 1
C            NDIM  = 4
C
C       then the contents of ARRAY are:
C
C            ARRAY (1) = 1
C            ARRAY (2) = 1
C            ARRAY (3) = 1
C            ARRAY (4) = 1
C
C$ Restrictions
C
C     None.
C
C$ Exceptions
C
C     Error free.
C
C     1) If NDIM < 1 the array is not modified.
C
C$ Files
C
C      None.
C
C$ Author_and_Institution
C
C      W.M. Owen       (JPL)
C
C$ Literature_References
C
C      None.
C
C$ Version
C
C-    SPICELIB Version 1.0.1, 10-MAR-1992 (WLT)
C
C        Comment section for permuted index source lines was added
C        following the header.
C
C-    SPICELIB Version 1.0.0, 31-JAN-1990 (WMO)
C
C-&
 
C$ Index_Entries
C
C     fill an integer array
C
C-&
 
 
 
C
C     Local variables
C
      INTEGER I
 
 
      DO I = 1, NDIM
        ARRAY(I) = VALUE
      END DO
 
 
      RETURN
      END
