C$Procedure                     J2100 ( Julian Date of 2100 JAN 1.5 )
 
      DOUBLE PRECISION FUNCTION J2100 ( )
 
C$ Abstract
C
C     Return the Julian Date of 2100 JAN 01 12:00:00 (2100 JAN 1.5).
C
C$ Copyright
C
C     Copyright (1995), California Institute of Technology.
C     U.S. Government sponsorship acknowledged.
C
C$ Required_Reading
C
C     None.
C
C$ Keywords
C
C     CONSTANTS
C
C$ Declarations
C
C     None.
C
C$ Brief_I/O
C
C     The function returns the Julian Date of 2100 JAN 01 12:00:00
C     (2100 JAN 1.5).
C
C$ Detailed_Input
C
C     None.
C
C$ Detailed_Output
C
C     The function returns 2488070.0, the Julian Date corresponding
C     to 2100 JAN 01 12:00:00 (2100 JAN 1.5).
C
C$ Parameters
C
C     None.
C
C$ Exceptions
C
C      Error free.
C
C$ Files
C
C     None.
C
C$ Particulars
C
C     The function always returns the constant value shown above.
C
C$ Examples
C
C     The following code fragment illustrates the use of J2100.
C
C        C
C        C     Convert Julian Date to UTC seconds past the reference
C        C     epoch (J2100).
C        C
C              SPREF = ( JD - J2100() ) * SPD()
C
C$ Restrictions
C
C     None.
C
C$ Literature_References
C
C     None.
C
C$ Author_and_Institution
C
C     W.L. Taber      (JPL)
C     I.M. Underwood  (JPL)
C
C$ Version
C
C-     SPICELIB Version 1.0.1, 10-MAR-1992 (WLT)
C
C         Comment section for permuted index source lines was added
C         following the header.
C
C-     SPICELIB Version 1.0.0, 31-JAN-1990 (WLT) (IMU)
C
C-&
 
C$ Index_Entries
C
C     julian date of 2100 jan 1.5
C
C-&
 
 
      J2100 = 2488070.0D0
 
      RETURN
      END
