C$Procedure      MEQU  ( Matrix equal to another, 3x3 )
 
      SUBROUTINE MEQU ( M1, MOUT )
 
C$ Abstract
C
C      Set one double precision 3x3 matrix equal to another.
C
C$ Copyright
C
C     Copyright (1995), California Institute of Technology.
C     U.S. Government sponsorship acknowledged.
C
C$ Required_Reading
C
C     None.
C
C$ Keywords
C
C      ASSIGNMENT,  MATRIX
C
C$ Declarations
 
      DOUBLE PRECISION   M1   ( 3,3 )
      DOUBLE PRECISION   MOUT ( 3,3 )
 
C$ Brief_I/O
C
C      VARIABLE  I/O  DESCRIPTION
C      --------  ---  --------------------------------------------------
C      M1         I     Input matrix.
C      MOUT       O     Output matrix equal to M1.
C
C$ Detailed_Input
C
C      M1      This is an arbitrary input 3x3 matrix.  There are no
C              restrictions on what it may contain.
C
C$ Detailed_Output
C
C      MOUT    This 3x3 matrix is set to be equal to M1.
C
C$ Parameters
C
C      None.
C
C$ Particulars
C
C      None.
C
C$ Examples
C
C      If  M1 = | 1.0D0   0.0D0   0.0D0 |
C               |                       |
C               | 0.0D0   1.0D0   0.0D0 |
C               |                       |
C               | 0.0D0   0.0D0   1.0D0 |
C
C      the call
C
C      CALL MEQU ( M1, MOUT )
C
C      produces the matrix
C
C       MOUT =  | 1.0D0   0.0D0   0.0D0 |
C               |                       |
C               | 0.0D0   1.0D0   0.0D0 |
C               |                       |
C               | 0.0D0   0.0D0   1.0D0 |
C
C
C$ Restrictions
C
C      None.
C
C$ Exceptions
C
C     Error free.
C
C$ Files
C
C      None.
C
C$ Author_and_Institution
C
C      W.M. Owen       (JPL)
C
C$ Literature_References
C
C      None.
C
C$ Version
C
C-    SPICELIB Version 1.0.1, 10-MAR-1992 (WLT)
C
C        Comment section for permuted index source lines was added
C        following the header.
C
C-    SPICELIB Version 1.0.0, 31-JAN-1990 (WMO)
C
C-&
 
C$ Index_Entries
C
C     equal to another 3x3_matrix
C
C-&
 
 
      CALL MOVED (M1, 9, MOUT)
C
      RETURN
      END
