C$ Abstract
C
C     This file contains the number of non-inertial reference
C     frames that are currently built into the SPICE toolkit
C     software.
C
C
C$ Copyright
C
C     Copyright (1995), California Institute of Technology.
C     U.S. Government sponsorship acknowledged.
C
C$ Required_Reading
C
C     None.
C
C$ Keywords
C
C     FRAMES
C
C$ Declarations
 
      INTEGER               NNINRT
      PARAMETER           ( NNINRT = 96 )
 
 
C$ Brief_I/O
C
C     VARIABLE  I/O  DESCRIPTION
C     --------  ---  --------------------------------------------------
C     NINERT     P   Number of built-in non-inertial reference frames.
C
C$ Parameters
C
C     NINERT     is the number of built-in non-inertial reference
C                frames.  This value is needed by both  ZZFDAT, and
C                FRAMEX.
C
C$ Author_and_Institution
C
C     B.V. Semenov    (JPL)
C     W.L. Taber      (JPL)
C     F.S. Turner     (JPL)
C
C$ Literature_References
C
C     None.
C
C$ Version
C
C-    SPICELIB Version 1.3.0, 12-DEC-2002 (BVS)
C
C        Increased the number of non-inertial frames from 85 to 96
C        in order to accomodate the following PCK based frames:
C
C           IAU_CALLIRRHOE
C           IAU_THEMISTO
C           IAU_MAGACLITE
C           IAU_TAYGETE
C           IAU_CHALDENE
C           IAU_HARPALYKE
C           IAU_KALYKE
C           IAU_IOCASTE
C           IAU_ERINOME
C           IAU_ISONOE
C           IAU_PRAXIDIKE
C
C-    SPICELIB Version 1.2.0, 02-AUG-2002 (FST)
C
C        Increased the number of non-inertial frames from 81 to 85
C        in order to accomodate the following PCK based frames:
C
C           IAU_PAN
C           IAU_GASPRA
C           IAU_IDA
C           IAU_EROS
C
C-    SPICELIB Version 1.1.0, 20-FEB-1997 (WLT)
C
C        Increased the number of non-inertial frames from 79 to 81
C        in order to accomodate the following earth rotation
C        models:
C
C           ITRF93
C           EARTH_FIXED
C
C-    SPICELIB Version 1.0.0, 10-OCT-1996 (WLT)
C
C-&
