C$Procedure      SWAPD ( Swap double precision values )
 
      SUBROUTINE SWAPD ( A, B )
 
C$ Abstract
C
C      Swap the contents of two double precision variables.
C
C$ Copyright
C
C     Copyright (1995), California Institute of Technology.
C     U.S. Government sponsorship acknowledged.
C
C$ Required_Reading
C
C     None.
C
C$ Keywords
C
C      UTILITY
C
C$ Declarations
 
      DOUBLE PRECISION   A
      DOUBLE PRECISION   B
 
C$ Brief_I/O
C
C      VARIABLE  I/O  DESCRIPTION
C      --------  ---  --------------------------------------------------
C      A         I/O  First variable.
C      B         I/O  Second variable.
C
C$ Detailed_Input
C
C      A,
C      B           are two variables, the contents of which are to
C                  be swapped (exchanged).
C
C$ Detailed_Output
C
C      A,
C      B           are the same two variables, after their contents
C                  have been exchanged.
C
C$ Parameters
C
C     None.
C
C$ Particulars
C
C      This is just shorthand notation for the code fragment
C
C            TEMP = A
C            A    = B
C            B    = TEMP
C
C$ Examples
C
C      Let
C            A = 11.D0
C            B = 22.D0
C
C      Then after calling SWAPD (A,B),
C
C            A = 22.D0
C            B = 11.D0
C
C$ Restrictions
C
C      None.
C
C$ Exceptions
C
C     Error free.
C
C$ Files
C
C      None.
C
C$ Author_and_Institution
C
C      I.M. Underwood  (JPL)
C
C$ Literature_References
C
C      None.
C
C$ Version
C
C-    SPICELIB Version 1.0.1, 10-MAR-1992 (WLT)
C
C        Comment section for permuted index source lines was added
C        following the header.
C
C-    SPICELIB Version 1.0.0, 31-JAN-1990 (IMU)
C
C-&
 
C$ Index_Entries
C
C     swap d.p. values
C
C-&
 
 
 
 
C
C     Local variables
C
      DOUBLE PRECISION TEMP
 
 
 
C
C     What is there to say?
C
      TEMP = A
      A    = B
      B    = TEMP
 
      RETURN
      END
