C$Procedure      TOSTDO ( To Standard Output)
 
      SUBROUTINE TOSTDO ( LINE )
 
C$ Abstract
C
C    Write a line of text to standard output.
C
C$ Copyright
C
C     Copyright (1997), California Institute of Technology.
C     U.S. Government sponsorship acknowledged.
C
C$ Required_Reading
C
C     None.
C
C$ Keywords
C
C     UTILITY
C
C$ Declarations
 
      IMPLICIT NONE
      CHARACTER*(*)         LINE
 
C$ Brief_I/O
C
C     VARIABLE  I/O  DESCRIPTION
C     --------  ---  --------------------------------------------------
C     LINE       I   is a line of text to be written to standard output
C
C$ Detailed_Input
C
C     LINE       is a character string containing text to be written
C                to standard output.
C
C$ Detailed_Output
C
C     None.
C
C$ Parameters
C
C     None.
C
C$ Files
C
C     None.
C
C$ Exceptions
C
C     None.
C
C$ Particulars
C
C     This routine is a macro for the subroutine call
C
C        CALL WRITLN ( LINE, STDOUT )
C
C     Where STDOUT is the logical unit connected to standard output.
C
C$ Examples
C
C     Suppose you need to create a message to be printed on the
C     user's terminal.  Here is how to use TOSTDO to handle this
C     task.
C
C        CALL TOSTDO ( 'Hello. '         )
C        CALL TOSTDO ( 'My Name is HAL.' )
C        CALL TOSTDO ( 'I became operational January 12, 1997 on the ' )
C        CALL TOSTDO ( 'campus of the University of Illinois in '      )
C        CALL TOSTDO ( 'Urbana, Illinois.' )
C
C$ Restrictions
C
C     None.
C
C$ Author_and_Institution
C
C     W.L. Taber      (JPL)
C
C$ Literature_References
C
C     None.
C
C$ Version
C
C-    SPICELIB Version 1.0.0, 18-SEP-1996 (WLT)
C
C
C-&
 
C$ Index_Entries
C
C     Write a line of text to standard output.
C
C-&
 
      INTEGER               STDOUT
      LOGICAL               FIRST
      SAVE
 
      DATA                  FIRST  / .TRUE. /
 
 
      IF ( FIRST ) THEN
         CALL STDIO ( 'STDOUT', STDOUT )
         FIRST = .FALSE.
      END IF
 
      CALL WRITLN ( LINE, STDOUT )
      RETURN
 
      END
