C$Procedure ZZDDHCLU ( Private --- DDH Count Locks )
 
      INTEGER FUNCTION ZZDDHCLU ( UTLCK, NUT )
 
C$ Abstract
C
C     SPICE Private routine intended solely for the support of SPICE
C     routines.  Users should not call this routine directly due
C     to the volatile nature of this routine.
C
C     Retrieve the number of locked units in the unit table.
C
C$ Copyright
C
C     Copyright (2001), California Institute of Technology.
C     U.S. Government sponsorship acknowledged.
C
C$ Required_Reading
C
C     None.
C
C$ Keywords
C
C     PRIVATE
C
C$ Declarations
 
      IMPLICIT NONE
 
      LOGICAL               UTLCK ( * )
      INTEGER               NUT
 
 
C$ Brief_I/O
C
C     VARIABLE  I/O  DESCRIPTION
C     --------  ---  --------------------------------------------------
C     UTLCK      I   Lock column of the unit table.
C     NUT        I   Number of entries in the unit table.
C
C     This function return the number of locked units in the unit table.
C
C$ Detailed_Input
C
C     UTLCK      is the lock column of the unit table.  TRUE entries in
C                this column indicate a handle is locked to a particular
C                unit.
C
C     NUT        is the number of entries in the unit table.
C
C$ Detailed_Output
C
C     The function returns the number of locked units in the unit table.
C
C$ Parameters
C
C     None.
C
C$ Files
C
C     None.
C
C$ Exceptions
C
C     Error free.
C
C$ Particulars
C
C     This routine simply encapsulates some logic used in several
C     places in ZZDDHMAN.
C
C$ Examples
C
C     See ZZDDHMAN for sample usage.
C
C$ Restrictions
C
C     None.
C
C$ Author_and_Institution
C
C     F.S. Turner     (JPL)
C
C$ Literature_References
C
C     None.
C
C$ Version
C
C-    SPICELIB Version 1.0.0, 04-OCT-2001 (FST)
C
C
C-&
 
C
C     Local Variables
C
      INTEGER               I
 
C
C     Loop through UTLCK counting the number of TRUE values.
C
      ZZDDHCLU = 0
 
      DO I = 1, NUT
 
         IF ( UTLCK(I) ) THEN
            ZZDDHCLU = ZZDDHCLU + 1
         END IF
 
      END DO
 
      RETURN
      END
