C$Procedure      ZZEKCNAM ( EK, get column name )
 
      SUBROUTINE ZZEKCNAM ( HANDLE, COLDSC, COLUMN )
 
C$ Abstract
C
C     Look up the name of a column, given the column's descriptor.
C
C$ Copyright
C
C     Copyright (1995), California Institute of Technology.
C     U.S. Government sponsorship acknowledged.
C
C$ Required_Reading
C
C     EK
C
C$ Keywords
C
C     EK
C     PRIVATE
C
C$ Declarations
 
      INCLUDE 'ekcnamsz.inc'
      INCLUDE 'ekcoldsc.inc'
      INCLUDE 'eksegdsc.inc'
 
      INTEGER               HANDLE
      INTEGER               COLDSC ( CDSCSZ )
      CHARACTER*(*)         COLUMN
 
C$ Brief_I/O
C
C     Variable  I/O  Description
C     --------  ---  --------------------------------------------------
C     HANDLE     I   EK file handle.
C     COLDSC     I   Column descriptor.
C     COLUMN     O   Column name.
C
C$ Detailed_Input
C
C     HANDLE         is a file handle of an EK open for read or write
C                    access.
C
C     COLDSC         is the column descriptor of a column whose name is
C                    desired.
C
C$ Detailed_Output
C
C     COLNAM         is the name of the specified column.
C
C$ Parameters
C
C     None.
C
C$ Exceptions
C
C     1)  If HANDLE is invalid, the error will be diagnosed by routines
C         called by this routine.
C
C     2)  If an I/O error occurs while reading the indicated file,
C         the error will be diagnosed by routines called by this
C         routine.
C
C$ Files
C
C     See the EK Required Reading for a discussion of the EK file
C     format.
C
C$ Particulars
C
C     This routine centralizes the coded needed to look up the
C     name of a specified column.  This is a frequently
C     performed function.
C
C$ Examples
C
C     See EKDELR.
C
C$ Restrictions
C
C     None.
C
C$ Literature_References
C
C     None.
C
C$ Author_and_Institution
C
C     N.J. Bachman   (JPL)
C
C$ Version
C
C-    Beta Version 1.0.0, 10-OCT-1995 (NJB)
C
C-&
 
 
 
C
C     Local variables
C
      INTEGER               NAMBAS
 
C
C     Use discovery check-in.
C
C
C     Look up the name.
C
      NAMBAS = COLDSC( NAMIDX )
 
      CALL DASRDC ( HANDLE,  NAMBAS+1,  NAMBAS+CNAMSZ,
     .              1,       CNAMSZ,    COLUMN         )
 
 
      END
