C$Procedure      ZZEKGRS ( EK, get record status )
 
      SUBROUTINE ZZEKGRS ( HANDLE, RECPTR, STATUS )
 
C$ Abstract
C
C     Return the status of a specified EK record.
C
C$ Copyright
C
C     Copyright (1995), California Institute of Technology.
C     U.S. Government sponsorship acknowledged.
C
C$ Required_Reading
C
C     EK
C
C$ Keywords
C
C     EK
C     PRIVATE
C
C$ Declarations
 
      INCLUDE 'ekrecptr.inc'
 
      INTEGER               HANDLE
      INTEGER               RECPTR
      INTEGER               STATUS
 
C$ Brief_I/O
C
C     Variable  I/O  Description
C     --------  ---  --------------------------------------------------
C     HANDLE     I   File handle.
C     RECPTR     I   Record pointer.
C     STATUS     O   Status of specified EK record.
C
C$ Detailed_Input
C
C     HANDLE         is a file handle of an EK open for read or write
C                    access.
C
C     RECPTR         is a pointer to the record whose status is desired.
C
C$ Detailed_Output
C
C     STATUS         is the status word of the specified record.  See
C                    the include file ekrecptr.inc for values and
C                    meanings.
C
C$ Parameters
C
C     None.
C
C$ Exceptions
C
C     1)  If HANDLE is invalid, the error will be diagnosed by routines
C         called by this routine.
C
C     2)  If an I/O error occurs while reading the indicated file, the
C         error will be diagnosed by routines called by this routine.
C
C$ Files
C
C     See the EK Required Reading for a discussion of the EK file
C     format.
C
C$ Particulars
C
C     This routine hides details of status word access.
C
C$ Examples
C
C     See EKCOMM.
C
C$ Restrictions
C
C     None.
C
C$ Literature_References
C
C     None.
C
C$ Author_and_Institution
C
C     N.J. Bachman   (JPL)
C
C$ Version
C
C-    Beta Version 1.0.0, 10-OCT-1995 (NJB)
C
C-&
 
C
C     Local variables
C
      INTEGER               LOC
 
C
C     Use discovery check-in.
C
C
C     Compute the status word location, and read the status.
C
      LOC  =  RECPTR + STAIDX
 
      CALL DASRDI ( HANDLE, LOC, LOC, STATUS )
 
      RETURN
      END
