C$Procedure      ZZEKSDSC ( EK, get segment descriptor )
 
      SUBROUTINE ZZEKSDSC ( HANDLE, SEGNO, SEGDSC )
 
C$ Abstract
C
C     Look up the descriptor of a specified EK segment.
C
C$ Copyright
C
C     Copyright (1995), California Institute of Technology.
C     U.S. Government sponsorship acknowledged.
C
C$ Required_Reading
C
C     EK
C
C$ Keywords
C
C     PRIVATE
C     UTILITY
C
C$ Declarations
 
 
      INCLUDE 'eksegdsc.inc'
 
      INTEGER               HANDLE
      INTEGER               SEGNO
      INTEGER               SEGDSC ( SDSCSZ )
 
C$ Brief_I/O
C
C     Variable  I/O  Description
C     --------  ---  --------------------------------------------------
C     HANDLE     I   File handle.
C     SEGNO      I   Segment number.
C     SEGDSC     O   Segment descriptor.
C
C$ Detailed_Input
C
C     HANDLE         is a file handle of an EK open for read or write
C                    access.
C
C     SEGNO          is the number of a segment whose descriptor is
C                    desired.  A segment number is simply the ordinal
C                    position of the segment in its parent EK.
C
C$ Detailed_Output
C
C     SEGDSC         is the descriptor of the specified segment.
C
C$ Parameters
C
C     None.
C
C$ Exceptions
C
C     1)  If HANDLE is invalid, the error will be diagnosed by routines
C         called by this routine.
C
C     2)  If SEGNO is invalid, the error will be diagnosed by routines
C         called by this routine.
C
C     3)  If an I/O error occurs while reading the indicated file,
C         the error will be diagnosed by routines called by this
C         routine.
C
C$ Files
C
C     See the EK Required Reading for a discussion of the EK file
C     format.
C
C$ Particulars
C
C     This routine centralizes the coded needed to look up the
C     descriptor of a specified segment.  This is a frequently
C     performed function.
C
C$ Examples
C
C     See EKACEC.
C
C$ Restrictions
C
C     None.
C
C$ Literature_References
C
C     None.
C
C$ Author_and_Institution
C
C     N.J. Bachman   (JPL)
C
C$ Version
C
C-    Beta Version 1.0.0, 10-OCT-1995 (NJB)
C
C-&
 
C
C     Local variables
C
      INTEGER               MP
      INTEGER               MBASE
 
C
C     Use discovery check-in.
C
      CALL ZZEKMLOC (  HANDLE,  SEGNO,    MP,            MBASE   )
      CALL DASRDI   (  HANDLE,  MBASE+1,  MBASE+SDSCSZ,  SEGDSC  )
 
      RETURN
      END
