C$Procedure      ZZEKTRBS ( EK tree, base address )
 
      INTEGER FUNCTION ZZEKTRBS ( NODE )
 
C$ Abstract
C
C     Map a node in a tree to its DAS base integer address.
C
C$ Copyright
C
C     Copyright (1995), California Institute of Technology.
C     U.S. Government sponsorship acknowledged.
C
C$ Required_Reading
C
C     EK
C
C$ Keywords
C
C     EK
C     PRIVATE
C
C$ Declarations
 
      INCLUDE 'ektype.inc'
 
      INTEGER               NODE
 
C$ Brief_I/O
C
C     Variable  I/O  Description
C     --------  ---  --------------------------------------------------
C     NODE       I   Node number.
C
C     The function returns the DAS integer base address of the
C     specified node.
C
C$ Detailed_Input
C
C     NODE           is the number of a node in an EK tree.
C
C$ Detailed_Output
C
C     The function returns the DAS integer base address of the
C     specified node.  This address is the predecessor of the first
C     DAS integer word occupied by the node.
C
C$ Parameters
C
C     None.
C
C$ Exceptions
C
C     1)  No error checking is done on the input node number.
C
C$ Files
C
C     See the EK Required Reading for a discussion of the EK file
C     format.
C
C$ Particulars
C
C     This routine is a utility that allows callers to locate a node
C     of a tree in the DAS integer address space.  Most commonly, this
C     routine is used to locate the root of a tree.
C
C$ Examples
C
C     See EKNSEG.
C
C$ Restrictions
C
C     None.
C
C$ Literature_References
C
C     None.
C
C$ Author_and_Institution
C
C     N.J. Bachman   (JPL)
C
C$ Version
C
C-    Beta Version 1.0.0, 20-OCT-1995 (NJB)
C
C-&
 
C
C     Just use the mapping supplied by the paging system.
C
      CALL ZZEKPGBS ( INT, NODE, ZZEKTRBS )
 
      RETURN
      END
