C$Procedure      ZZEKTRSZ ( EK, tree size )
 
      INTEGER FUNCTION ZZEKTRSZ ( HANDLE, TREE )
 
C$ Abstract
C
C     Return the number of keys in a tree.
C
C$ Copyright
C
C     Copyright (1995), California Institute of Technology.
C     U.S. Government sponsorship acknowledged.
C
C$ Required_Reading
C
C     EK
C
C$ Keywords
C
C     EK
C     PRIVATE
C
C$ Declarations
 
      INCLUDE 'ektree.inc'
 
      INTEGER               HANDLE
      INTEGER               TREE
 
C$ Brief_I/O
C
C     Variable  I/O  Description
C     --------  ---  --------------------------------------------------
C     HANDLE     I   File handle.
C     TREE       I   Root of tree.
C
C     The function returns the total number of keys in the specified
C     EK tree.
C
C$ Detailed_Input
C
C     HANDLE         is a file handle of an EK open for read or write
C                    access.
C
C     TREE           is the root node number of the tree of interest.
C
C$ Detailed_Output
C
C     The function returns the total number of keys in the specified
C     EK tree.
C
C$ Parameters
C
C     None.
C
C$ Exceptions
C
C     1)  If HANDLE is invalid, the error will be diagnosed by routines
C         called by this routine.  The file will not be modified.
C
C     2)  If an I/O error occurs while reading the indicated file, the
C         error will be diagnosed by routines called by this routine.
C
C$ Files
C
C     See the EK Required Reading for a discussion of the EK file
C     format.
C
C$ Particulars
C
C     This routine should be used to determine the current size of an
C     EK tree; the tree's metadata should not be accessed directly to
C     extract this information.
C
C$ Examples
C
C     See EKNSEG.
C
C$ Restrictions
C
C     None.
C
C$ Literature_References
C
C     None.
C
C$ Author_and_Institution
C
C     N.J. Bachman   (JPL)
C
C$ Version
C
C-    Beta Version 1.0.0, 20-OCT-1995 (NJB)
C
C-&
 
 
 
C
C     Non-SPICELIB functions
C
      INTEGER               ZZEKTRBS
 
C
C     Local variables
C
      INTEGER               ADDRSS
 
C
C     Go straight to the address at which the key count is stored.
C
      ADDRSS  =  ZZEKTRBS ( TREE )  +  TRNKEY
 
      CALL DASRDI ( HANDLE, ADDRSS, ADDRSS, ZZEKTRSZ )
 
      RETURN
      END
