C$Procedure      BATCH (Tell whether or not a program is in batch mode)
 
      LOGICAL FUNCTION      BATCH ()
      IMPLICIT NONE
 
C$ Abstract
C
C     This function returns information regarding the interactive
C     status of a program.  If BATCH is TRUE the function is considered
C     to be in background mode.  If BATCH is FALSE the function is
C     considered to be in interactive mode.
C
C     To set a program in batch mode call the entry point SETBAT.
C     To set a program in interactive mode call SETMOD
C
C$ Version
C
C-     Command Loop Configured Version 1.0.0, 20-NOV-1995 (WLT)
C
C         This is the configured version of the Command Loop
C         software as of May 4, 1994
C
C     Entry points.
C
C
C     Local Variable
C
      LOGICAL               INBTCH
 
      SAVE                  INBTCH
 
      LOGICAL               SETBAT
      LOGICAL               SETMOD
 
      DATA                  INBTCH / .FALSE. /
 
      BATCH = INBTCH
      RETURN
 
 
C$Procedure SETMOD (Set the reader to interative mode.)
 
      ENTRY SETMOD ()
 
C$ Abstact
 
C     Set NXTCOM to interactive mode.  In puts that are expected to
C     come from the keyboard generate an result in a prompt for input
 
C$ Version
C
C-     Command Loop Configured Version 1.0.0, 3-MAY-1994 (WLT)
C
C         This is the configured version of the Command Loop
C         software as of May 4, 1994
C
      INBTCH = .FALSE.
      SETMOD = .TRUE.
      RETURN
 
 
C$Procedure SETBAT (Set the reader to interative mode.)
 
      ENTRY SETBAT ()
 
C$ Abstact
 
C     Set NXTCOM to interactive mode.  In puts that are expected to
C     come from the keyboard generate an result in a prompt for input
 
C$ Version
C
C-     Command Loop Configured Version 1.0.0, 3-MAY-1994 (WLT)
C
C         This is the configured version of the Command Loop
C         software as of May 4, 1994
C
      INBTCH = .TRUE.
      SETBAT = .TRUE.
      RETURN
 
      END
