 
      SUBROUTINE RDSTMT (PRMPT, DELIM, STMT)
      IMPLICIT NONE
 
      CHARACTER*(*)      PRMPT
      CHARACTER*(1)      DELIM
      CHARACTER*(*)      STMT
 
C
C  Read a statement entered on one or more lines.
C
C  VARIABLE      I/O            DESCRIPTION
C   PRMPT        I      Prompt for input. If PRMPT is not blank,
C                          the cursor is positioned one space after the
C                          last non-blank character. Successive lines
C                          are indented by the length of PRMPT.
C   DELIM         I      Statement delimiter. RDSTMT will continue
C                          to read until the either the delimiter or
C                          a blank line is entered.
C   STMT          O      The statement entered, up to but not
C                          including the delimiter. If RDSTMT is
C                          terminated by the entry of a blank line,
C                          STMT is blank.
C
C$ Version
C
C-     Command Loop Configured Version 1.0.0, 3-MAY-1994 (WLT)
C
C         This is the configured version of the Command Loop
C         software as of May 4, 1994
C
 
C
C  7 February 1986, I.M. Underwood
C
C-
 
 
 
C
C     SPICELIB functions
C
      INTEGER               RTRIM
 
C
C     Local variables
C
      CHARACTER*(1)         SPACE
      CHARACTER*(1)         TAB
      CHARACTER*(132)       BLANK
      SAVE                  BLANK
       
      INTEGER               PRLEN
      CHARACTER*(132)       LINE
      CHARACTER*(132)       MYPRM
      INTEGER               END

      DATA                  BLANK / ' ' /
 
 
C
C     Read the first statement. Use the prompt. Return immediately
C     if a blank line or an error is encountered.
C
      PRLEN  = RTRIM (PRMPT) + 1
      MYPRM  = PRMPT
      LINE   = ' '
      SPACE  = ' '
      TAB    = CHAR(9)
C
C     Set up the white-space/line-break accountant.
C
 
      CALL PROMPT ( MYPRM(1:PRLEN), LINE )
 
      IF ( LINE .EQ. ' ' ) THEN
         STMT = ' '
         RETURN
      ELSE
         STMT = LINE
      END IF
 
C
C     Record the size of the white-space and line-break fields.
C
      CALL RSTBUF ()
      CALL REPLCH ( LINE, TAB, SPACE, LINE )
      CALL PUTBUF ( LINE )
 
 
C
C     Read succeeding lines. Indent to the length of the original
C     prompt. Add the input line to the current statement. Quit when:
C
C            - A delimiter is encountered. (Return the statement
C              up to the delimiter.)
C
C            - A blank line or an error is encountered. (Return
C              a blank statement.)
C
      DO WHILE ( INDEX ( STMT, DELIM ) .EQ. 0 )
 
         CALL PROMPT ( BLANK(1:PRLEN),   LINE )
         CALL REPLCH ( LINE, TAB, SPACE, LINE )
         CALL PUTBUF (                   LINE )
 
         IF ( LINE .EQ. ' ' ) THEN
            CALL DMPBUF ()
            STMT = ' '
            RETURN
         ELSE
            CALL SUFFIX ( LINE, 1, STMT )
         END IF
 
      END DO
 
C
C     If we made it to here, we encountered a delimiter. Take the
C     entire statement up to the character before the delimiter.
C
      END        = INDEX ( STMT, DELIM )
      STMT(END:) = ' '
 
      RETURN
      END
