      SUBROUTINE RPTSYM ( ID, COMP, STRING, WDTH, NAME, DEF, VALUE )
 
      IMPLICIT NONE
 
      INTEGER               ID
      INTEGER               COMP
      CHARACTER*(*)         STRING
      INTEGER               WDTH
      CHARACTER*(*)         NAME
      CHARACTER*(*)         DEF
      CHARACTER*(*)         VALUE
 
C
C     This routine is a utility for setting and retrieving symbol
C     names, definitions and expanded values.  It is intended that
C     this be used by a higher level routine that fetches symbol
C     definitions one at a time, puts the definition here and
C     passes the routine RETSYM to a formatting routine.
C
C     The ENTRY point SETSYM allows you to set the symbol and its
C     values.
C
C     The ENTRY point RETSYM returns the last set values.  To
C     request a portion of a symbol you supply the following
C     values for ID and COMP
C
C        1,1 for the symbol name
C        2,1 for the symbol definition
C        2,2 or 3,1 for the symbol expanded value.
C
C     If used with the routine TABRPT you can then easily display
C     symbols as:
C
C        name    definition    fully_expanded_value
C
C     or
C
C        name    definition
C                fully_expanded_value.
C
 
      INTEGER               RTRIM
 
      INTEGER               WDSIZE
      PARAMETER           ( WDSIZE = 32 )
 
      INTEGER               LNSIZE
      PARAMETER           ( LNSIZE = 1000 )
 
 
 
      CHARACTER*(WDSIZE)    SYMNAM
      CHARACTER*(LNSIZE)    SYMDEF
      CHARACTER*(LNSIZE)    SYMVAL
      SAVE
 
      RETURN
 
      ENTRY SETSYM ( NAME, DEF, VALUE )
 
         SYMNAM = NAME
         SYMDEF = DEF
         SYMVAL = VALUE
 
         RETURN
 
 
      ENTRY RETSYM ( ID, COMP, STRING, WDTH )
 
         IF      ( ID .EQ. 1 ) THEN
 
            IF ( COMP .NE. 1 ) THEN
               STRING = ' '
            ELSE
               STRING = SYMNAM
            END IF
 
         ELSE IF ( ID .EQ. 2 ) THEN
 
            IF ( COMP .EQ. 1 ) THEN
               STRING = SYMDEF
            ELSE IF ( COMP .EQ. 2 ) THEN
               STRING = SYMVAL
            ELSE
               STRING = ' '
            END IF
 
         ELSE IF ( ID .EQ. 3 ) THEN
 
            IF ( COMP .EQ. 1 ) THEN
               STRING = SYMVAL
            ELSE
               STRING = ' '
            END IF
 
         END IF
 
         WDTH = RTRIM ( STRING )
 
         RETURN
 
 
 
 
      END
