C
C     IO Manager.
C
      SUBROUTINE TSTIO ( LINE, NAME, PORT, OK, STATUS )
C
C$ Version
C
C-     Testing Utilities Version 1.2.0, 9-MAY-2002 (EDW)
C
C         Added the LCKOUT entry mode. Routine inhibits
C         all output to the specified port. Primary use
C         prevents tspice from printing to the screen -
C         a quiet mode.        
C     
C-     Testing Utilities Version 1.1.0, 18-JUN-1999 (WLT)
C
C         Added a RETURN before the first entry point.
C
C-     Testing Utilities Version 1.0.0, 3-NOV-1994 (WLT)
C
C         This is the configured version of the Test Utility
C         software as of Nov 3, 1994
C



      IMPLICIT NONE

      CHARACTER*(*)         LINE
      CHARACTER*(*)         NAME
      CHARACTER*(*)         PORT
      LOGICAL               OK
      LOGICAL               STATUS ( 3 )

C     
C     Below are the various types of output files that
C     might be open.
C
      INTEGER               NPORTS
      PARAMETER           ( NPORTS = 4 )

      INTEGER               SCREEN
      PARAMETER           ( SCREEN = 6 )

      INTEGER               FILSIZ
      PARAMETER           ( FILSIZ = 127 )

      INTEGER               LOG
      PARAMETER           ( LOG    = 1 )

      INTEGER               STDOUT
      PARAMETER           ( STDOUT = 2 )

      INTEGER               SPOOL
      PARAMETER           ( SPOOL  = 3 )

C
C     SPICELIB functions
C
      LOGICAL               FAILED
      INTEGER               ISRCHC
      INTEGER               RTRIM

      INTEGER               ID
      INTEGER               IOSTAT
      INTEGER               R
      INTEGER               TO

      INTEGER               WDSIZE
      PARAMETER           ( WDSIZE  = 32 )

      INTEGER               MSGSIZ
      PARAMETER           ( MSGSIZ = 400 )

      CHARACTER*(MSGSIZ)    MESSGE
      CHARACTER*(WDSIZE)    PORTS  ( NPORTS )
      CHARACTER*(FILSIZ)    FILES  ( NPORTS )
      INTEGER               UNITS  ( NPORTS )
      LOGICAL               ACTIVE ( NPORTS )
      LOGICAL               OPEN   ( NPORTS )
      LOGICAL               SUSPND ( NPORTS )
      LOGICAL               LKPORT ( NPORTS )

      SAVE

      DATA PORTS   / 'LOG',   'SCREEN', 'SAVE',  'UTILITY'     /
      DATA FILES   / ' ',     ' ',      ' ',     ' '           /
      DATA UNITS   /  0,       SCREEN,   0,       0            /
      DATA ACTIVE  / .FALSE., .TRUE.,   .FALSE., .FALSE.       /
      DATA OPEN    / .FALSE., .TRUE.,   .FALSE., .FALSE.       /
      DATA SUSPND  / .FALSE., .FALSE.,  .FALSE., .FALSE.       /
      DATA LKPORT  / .FALSE., .FALSE.,  .FALSE., .FALSE.       /
      RETURN



C     
C     Open a new port
C
      ENTRY TSTOPN ( PORT, NAME )

C$ Version
C
C-     Testing Utilities Version 1.0.0, 3-NOV-1994 (WLT)
C
C         This is the configured version of the Test Utility
C         software as of Nov 3, 1994
C


         ID = ISRCHC ( PORT, NPORTS, PORTS )

         IF ( ID .EQ. 0 ) THEN
            WRITE (6,*) 'Unrecognized port: '
            WRITE (6,*)  PORT
            RETURN
         END IF

         IF( LKPORT(ID) ) THEN
            RETURN
         END IF

         R = RTRIM(NAME)

         CALL TXTOPN ( NAME(1:R), UNITS(ID) )

         IF ( FAILED() ) THEN
            OPEN  (ID) = .FALSE.
            ACTIVE(ID) = .FALSE.
            SUSPND(ID) = .FALSE.
            FILES (ID) =  ' '
            RETURN
         END IF

         OPEN  (ID) = .TRUE.
         ACTIVE(ID) = .TRUE.
         SUSPND(ID) = .FALSE.
         FILES (ID) =  NAME

         RETURN


C        
C     Inhibit outout to a port.
C
      ENTRY TSTIOH ( PORT )

C$ Version
C
C-     Testing Utilities Version 1.0.0, 3-NOV-1994 (WLT)
C
C         This is the configured version of the Test Utility
C         software as of Nov 3, 1994
C

         ID = ISRCHC ( PORT, NPORTS, PORTS )

         IF ( ID .EQ. 0 ) THEN
            WRITE (6,*) 'Unrecognized port: '
            WRITE (6,*)  PORT
            RETURN
         END IF

         ACTIVE(ID) = .FALSE.
         RETURN


C        
C     Activate a port
C
      ENTRY TSTIOA ( PORT )

C$ Version
C
C-     Testing Utilities Version 1.0.0, 3-NOV-1994 (WLT)
C
C         This is the configured version of the Test Utility
C         software as of Nov 3, 1994
C


         ID = ISRCHC ( PORT, NPORTS, PORTS )

         IF ( ID .EQ. 0 ) THEN
            WRITE (6,*) 'Unrecognized port: '
            WRITE (6,*)  PORT
            RETURN
         END IF

         IF( LKPORT(ID) ) THEN
            RETURN
         END IF

         ACTIVE(ID) = .TRUE.
         RETURN


C
C     Get the current status of a port.
C

       ENTRY TSTGST ( PORT, STATUS )

C$ Version
C
C-     Testing Utilities Version 1.0.0, 3-NOV-1994 (WLT)
C
C         This is the configured version of the Test Utility
C         software as of Nov 3, 1994
C


         ID = ISRCHC ( PORT, NPORTS, PORTS )

         IF ( ID .EQ. 0 ) THEN
            WRITE (6,*) 'Unrecognized port: '
            WRITE (6,*)  PORT
            RETURN
         END IF


         STATUS(1) = ACTIVE(ID)
         STATUS(2) = OPEN  (ID)
         STATUS(3) = SUSPND(ID)

         RETURN




C
C     Put the status of a port.
C
      ENTRY TSTPST ( PORT, STATUS )
C
C$ Version
C
C-     Testing Utilities Version 1.0.0, 3-NOV-1994 (WLT)
C
C         This is the configured version of the Test Utility
C         software as of Nov 3, 1994
C


         ID = ISRCHC ( PORT, NPORTS, PORTS )

         IF ( ID .EQ. 0 ) THEN
            WRITE (6,*) 'Unrecognized port: '
            WRITE (6,*)  PORT
            RETURN
         END IF


         ACTIVE(ID) = STATUS(1)
         OPEN  (ID) = STATUS(2)
         SUSPND(ID) = STATUS(3)

         RETURN


C        
C     Close a port.
C
      ENTRY TSTIOC ( PORT )
C
C$ Version
C
C-     Testing Utilities Version 1.0.0, 3-NOV-1994 (WLT)
C
C         This is the configured version of the Test Utility
C         software as of Nov 3, 1994
C

         ID = ISRCHC ( PORT, NPORTS, PORTS )

         IF ( ID .EQ. 0 ) THEN
            WRITE (6,*) 'Unrecognized port: '
            WRITE (6,*)  PORT
            RETURN
         END IF

         CLOSE ( UNITS(ID) )

         ACTIVE(ID) = .FALSE.
         OPEN  (ID) = .FALSE.
         FILES (ID) = ' '
         SUSPND(ID) = .FALSE.
         RETURN




C
C     Suspend a port (possibly to be reopened later)
C
      ENTRY TSTIOS ( PORT )
C
C$ Version
C
C-     Testing Utilities Version 1.0.0, 3-NOV-1994 (WLT)
C
C         This is the configured version of the Test Utility
C         software as of Nov 3, 1994
C


         ID = ISRCHC ( PORT, NPORTS, PORTS )

         IF ( ID .EQ. 0 ) THEN
            WRITE (6,*) 'Unrecognized port: '
            WRITE (6,*)  PORT
            RETURN
         END IF

         IF( LKPORT(ID) ) THEN
            RETURN
         END IF


C
C        close ( units(id) )
C
         OPEN  ( ID ) = .FALSE.
         SUSPND( ID ) = .TRUE.

         RETURN


C
C     Reopen a suspended port.
C
      ENTRY TSTIOR ( PORT, OK )
C
C$ Version
C
C-     Testing Utilities Version 1.0.0, 3-NOV-1994 (WLT)
C
C         This is the configured version of the Test Utility
C         software as of Nov 3, 1994
C

         ID = ISRCHC ( PORT, NPORTS, PORTS )

         IF ( ID .EQ. 0 ) THEN
            WRITE (6,*) 'Unrecognized port: '
            WRITE (6,*)  PORT
            RETURN
         END IF

         IF( LKPORT(ID) ) THEN
            RETURN
         END IF    

         IF ( .NOT. SUSPND(ID) ) THEN
            OK = .FALSE.
            RETURN
         END IF

         OPEN  (ID) = .TRUE.
         SUSPND(ID) = .FALSE.
         OK         = .TRUE.

         RETURN


C
C     Write a line to all open and active ports.
C
      ENTRY TSTWLN ( LINE )
C
C$ Version
C
C-     Testing Utilities Version 1.0.0, 3-NOV-1994 (WLT)
C
C         This is the configured version of the Test Utility
C         software as of Nov 3, 1994
C

         DO ID = 1, NPORTS

            IF ( ACTIVE(ID) .AND. OPEN(ID) ) THEN

               TO  =   UNITS(ID)
               CALL WRITLN ( LINE(1:RTRIM(LINE)), TO )

               IF (      ID .NE. STDOUT
     .             .AND. FAILED()     ) THEN

                   R =  RTRIM   ( FILES(ID) )

                   MESSGE = 'I was unable to write to the file '
     .             //       '#.  The value of IOSTAT returned '
     .             //       'was #. '

                   CALL REPMC   ( MESSGE, '#', FILES(ID)(1:R), MESSGE )
                   CALL REPMI   ( MESSGE, '#', IOSTAT,         MESSGE )

                   WRITE (6,*)
                   CALL NICEIO_3( MESSGE,  6,
     .                           'LEFT 1 RIGHT 78 NEWLINE /cr' )
                   WRITE (6,*)

                  CLOSE ( UNITS(ID) )

                  ACTIVE( ID )  = .FALSE.
                  OPEN  ( ID )  = .FALSE.
                  SUSPND( ID )  = .FALSE.
                  FILES ( ID )  = ' '

               END IF

            END IF

         END DO

         RETURN


C
C     The final entry point handles closing files and informing the
C     user of the location of these files.
C

       ENTRY FINISH

C$ Version
C
C-     Testing Utilities Version 1.0.0, 3-NOV-1994 (WLT)
C
C         This is the configured version of the Test Utility
C         software as of Nov 3, 1994
C

C       
C        Obtain the port ID for the SCREEN.
C
         ID = ISRCHC ( 'SCREEN', NPORTS, PORTS )

         IF ( OPEN(LOG) ) THEN

C
C           Output to standard out if no SCREEN lockout exists
C            
            IF ( ACTIVE(ID) .AND. OPEN(ID) ) THEN
               MESSGE = 'The log file was written to: '
               CALL TOSTDO ( MESSGE(1:RTRIM(MESSGE))          )
               CALL TOSTDO ( FILES(LOG)(1:RTRIM(FILES(LOG)))  )
               CALL TOSTDO ( ' ' )
            END IF

            CLOSE ( UNITS(LOG)   )
         END IF


         IF ( OPEN(SPOOL) ) THEN

C
C           Output to standard out if no SCREEN lockout exists
C         
            IF ( ACTIVE(ID) .AND. OPEN(ID) ) THEN
               MESSGE = 'The list of test failures was written to: '
               CALL TOSTDO (  MESSGE(1:RTRIM(MESSGE))             )
               CALL TOSTDO (  FILES(SPOOL)(1:RTRIM(FILES(SPOOL))) )
               CALL TOSTDO ( ' ' )
            END IF

            CLOSE ( UNITS(SPOOL) )
         END IF


         RETURN

         
C
C        Lock out a port from use.
C
         ENTRY LCKOUT ( PORT )

C$ Version
C
C-     Testing Utilities Version 1.0.0, 9-MAY-2002 (EDW)
C
         
C
C        Get the port ID.
C         
         ID = ISRCHC ( PORT, NPORTS, PORTS )

         IF ( ID .EQ. 0 ) THEN
            WRITE (6,*) 'Unrecognized port: '
            WRITE (6,*)  PORT
            RETURN
         END IF

C        
C        Close everything.      
C
         ACTIVE (ID) = .FALSE.
         OPEN   (ID) = .FALSE.
         SUSPND (ID) = .FALSE.
         LKPORT (ID) = .TRUE.

      END
