      SUBROUTINE TSTLGR  ( MESSGE, ERRLOG, GSTYLE, FSTYLE,
     .                     MARKER, INT,    DP )
C
C$ Version
C
C-     Test Utilities Version 1.2.1, 30-DEC-2002 (EDW)
C
C         Corrected several spelling errors.
C
C-     Test Utilities Version 1.2.0, 19-JUN-2001 (WLT)
C
C         Added an entry point that turns off the test message.  This
C         should be called only by TCASE.
C
C-     Test Utilities Version 1.1.0, 18-JUN-1999 (WLT)
C
C         Added a return before the first entry point.
C
C-     Test Utilities Version 1.0.0, 3-NOV-1994 (WLT)
C
C
 
C
C     Save the contents of the command to a log file and any save
C     file that might be open and active.
C
      IMPLICIT NONE
 
      CHARACTER*(*)         MESSGE
      LOGICAL               ERRLOG
      CHARACTER*(*)         GSTYLE
      CHARACTER*(*)         FSTYLE
      CHARACTER*(1)         MARKER
      INTEGER               INT
      DOUBLE PRECISION      DP
 
      EXTERNAL              TSTWLN
C
C     Test Utility Functions.
C
      LOGICAL               VERBOS
C
C     SPICELIB Functions
C
      INTEGER               RTRIM
C
C     Local Variables
C
      INTEGER               STYSIZ
      PARAMETER           ( STYSIZ = 128 )
 
      INTEGER               LNSIZE
      PARAMETER           ( LNSIZE = 80 )
 
      INTEGER               WDSIZE
      PARAMETER           ( WDSIZE = 32 )
 
      INTEGER               FILSIZ
      PARAMETER           ( FILSIZ = 255 )
 
      INTEGER               LNGSIZ
      PARAMETER           ( LNGSIZ = 520 )
 
 
      CHARACTER*(1)         MYMARK
 
      CHARACTER*(STYSIZ)    SEEN
      CHARACTER*(STYSIZ)    HIDE
 
      CHARACTER*(WDSIZE)    NAME
      CHARACTER*(LNGSIZ)    CNAME
      CHARACTER*(LNGSIZ)    EXTRA
      CHARACTER*(LNSIZE)    ENV
      CHARACTER*(LNSIZE)    TIME
      CHARACTER*(LNSIZE)    VERSN
      CHARACTER*(FILSIZ)    ERRFIL
 
      INTEGER               PNUM
      INTEGER               FNUM
      INTEGER               R
 
 
      LOGICAL               OPNERR
      LOGICAL               SHOW
 
      SAVE
 
      DATA   OPNERR / .TRUE. /
      DATA   SHOW   / .FALSE. /
      DATA   EXTRA  / ' '     /
      DATA   SEEN   / 'LEFT 1 RIGHT 78' /
      DATA   HIDE   / 'LEFT 1 RIGHT 78' /
      DATA   MYMARK / '#'               /
 
      RETURN
 
C
C     This entry point handles the logging of commands.
C
      ENTRY TSTLOG ( MESSGE, ERRLOG )
C
C$ Version
C
C-     Test Utilities Version 1.0.0, 3-NOV-1994 (WLT)
C
 
 
      IF ( ERRLOG ) THEN
C
C        We need to possibly open a log file and write some
C        special additional information if this is the first
C        message for this test case.
C
 
         CALL T_NAME  ( NAME   )
         CALL T_CNAME ( CNAME  )
         CALL T_FCOUNT( PNUM   )
         CALL T_CFAIL ( )
         CALL T_FCOUNT( FNUM   )
 
         IF ( OPNERR ) THEN
 
            OPNERR = .FALSE.
 
            CALL TSTFIL ( 'ERR{0-9}{0-9}{0-9}{0-9}.LOG', 'SAVE', ERRFIL)
 
            CALL TSTGET (  ENV, VERSN, TIME )
            CALL TSTIOA ( 'SAVE'   )
            CALL TSTIOH ( 'SCREEN' )
            CALL TSTIOH ( 'LOG'    )
 
            CALL TSTWLN ( ENV   )
            CALL TSTWLN ( VERSN )
            CALL TSTWLN ( TIME  )
 
         END IF
C
C        Activate the port for reporting errors, inhibit writing to the
C        screen or log file.
C
         CALL TSTIOA ( 'SAVE' )
         CALL TSTIOA ( 'SCREEN' )
         CALL TSTIOA ( 'LOG'    )
C
C        If there had been no previous errors reported for this
C        family of errors, we create a special message concerning
C        this family and case.
C
         IF ( PNUM .EQ. 0 ) THEN
 
            CALL TSTWLN( ' ' )
            CALL TSTWLN('A test failure occurred in the test family:')
            CALL TSTWLN( ' ' )
            CALL TSTWLN( 'Family : ' // NAME  )
            CALL NICEPR_1( CNAME,
     .                  'LEFT 1 RIGHT 78 HARDSPACE ^ FLAG CASE^^^:',
     .                   TSTWLN )
            CALL TSTWLN( ' ' )
C
C        If this is the first error message to be reported for this
C        test case we note the failure for this test case.
C
         ELSE IF ( PNUM .NE. FNUM ) THEN
 
            CALL TSTWLN( ' '                   )
            CALL TSTWLN( 'Test Case FAILURE. ' )
            CALL NICEPR_1( CNAME,
     .                  'LEFT 1 RIGHT 78 HARDSPACE ^ FLAG CASE^^^:',
     .                   TSTWLN )
            CALL TSTWLN( ' '                   )
 
         END IF
C
C        Reactivate the screen and log file.
C
         CALL TSTIOA  ( 'SCREEN' )
         CALL TSTIOA  ( 'LOG'    )
 
 
      END IF
 
 
      IF ( ERRLOG ) THEN
 
         IF ( MESSGE .EQ. ' ' ) THEN
            CALL TSTWLN ( ' ' )
         ELSE
 
            IF ( SHOW ) THEN
               CALL NICEPR_1 ( EXTRA, HIDE, TSTWLN )
               SHOW = .FALSE.
               CALL TSTWLN   ( ' ' )
            END IF
 
            CALL NICEPR_1 ( MESSGE,  HIDE, TSTWLN )
 
         END IF
 
      ELSE
 
         IF ( MESSGE .EQ. ' ' ) THEN
            CALL TSTWLN ( ' ' )
         ELSE
            CALL NICEPR_1 ( MESSGE,  SEEN, TSTWLN )
         END IF
 
      END IF
C
C     Inhibit writing to the error log.
C
 
      CALL TSTIOH ( 'SAVE' )
 
      RETURN
 
C
C     This entry point allows users to set the style used for
C     logging failure and non-failure and visible commands.
C
      ENTRY TSTLGS ( GSTYLE, FSTYLE )
C
C$ Version
C
C-     Test Utilities Version 1.0.0, 3-NOV-1994 (WLT)
C
C
 
 
      SEEN  = GSTYLE
      HIDE  = FSTYLE
 
      RETURN
 
C
C     This entry point allows users to get the style used for
C     logging failure and non-failure and visible commands.
C
      ENTRY TSTSTY ( GSTYLE, FSTYLE )
C
C$ Version
C
C-     Test Utilities Version 1.0.0, 3-NOV-1994 (WLT)
C
C
      GSTYLE = SEEN
      FSTYLE = HIDE
 
      RETURN
 
 
C
C     This entry point handles the logging of commands when we want
C     only verbose logging.
C
      ENTRY VRBLOG ( MESSGE, ERRLOG )
C
C$ Version
C
C-     Test Utilities Version 1.0.0, 3-NOV-1994 (WLT)
C
 
 
      IF ( ERRLOG ) THEN
C
C        We need to possibly open a log file and write some
C        special additional information if this is the first
C        message for this test case.
C
 
         CALL T_NAME  ( NAME   )
         CALL T_CNAME ( CNAME  )
         CALL T_FCOUNT( PNUM   )
         CALL T_CFAIL ( )
         CALL T_FCOUNT( FNUM   )
 
         IF ( OPNERR ) THEN
 
            OPNERR = .FALSE.
 
            CALL TSTFIL ( 'ERR{0-9}{0-9}{0-9}{0-9}.LOG', 'SAVE', ERRFIL)
 
            CALL TSTGET (  ENV, VERSN, TIME )
            CALL TSTIOA ( 'SAVE'   )
            CALL TSTIOH ( 'SCREEN' )
            CALL TSTIOH ( 'LOG'    )
 
            CALL TSTWLN ( ENV   )
            CALL TSTWLN ( VERSN )
            CALL TSTWLN ( TIME  )
 
         END IF
C
C        Activate the port for reporting errors, inhibit writing to the
C        screen or log file.
C
         CALL TSTIOA ( 'SAVE' )
         CALL TSTIOA ( 'SCREEN' )
         CALL TSTIOA ( 'LOG'    )
C
C        If there had been no previous errors reported for this
C        family of errors, we create a special message concerning
C        this family and case.
C
         IF ( PNUM .EQ. 0 ) THEN
 
            CALL TSTWLN( ' ' )
            CALL TSTWLN('A test failure occurred in the test family:')
            CALL TSTWLN( ' ' )
            CALL TSTWLN( 'Family : ' // NAME  )
            CALL NICEPR_1( CNAME,
     .                  'LEFT 1 RIGHT 78 HARDSPACE ^ FLAG CASE^^^:',
     .                   TSTWLN )
            CALL TSTWLN( ' ' )
C
C        If this is the first error message to be reported for this
C        test case we note the failure for this test case.
C
         ELSE IF ( PNUM .NE. FNUM ) THEN
 
            CALL TSTWLN( ' '                   )
            CALL TSTWLN( 'Test Case FAILURE. ' )
            CALL NICEPR_1( CNAME,
     .                  'LEFT 1 RIGHT 78 HARDSPACE ^ FLAG CASE^^^:',
     .                   TSTWLN )
            CALL TSTWLN( ' '                   )
 
         END IF
C
C        Reactivate the screen and log file.
C
         CALL TSTIOA  ( 'SCREEN' )
         CALL TSTIOA  ( 'LOG'    )
 
      END IF
C
C     If there is an error, write to every place.
C
      IF ( ERRLOG ) THEN
 
         IF ( MESSGE .EQ. ' ' ) THEN
            CALL TSTWLN ( ' ' )
         ELSE
 
            IF ( SHOW ) THEN
               CALL NICEPR_1 ( EXTRA, HIDE, TSTWLN )
               CALL TSTWLN ( ' ' )
               SHOW = .FALSE.
            END IF
 
            CALL NICEPR_1 ( MESSGE,  HIDE, TSTWLN )
         END IF
C
C     Otherwise we write out the message only if in verbose mode.
C
      ELSE IF ( VERBOS() ) THEN
 
         IF ( MESSGE .EQ. ' ' ) THEN
            CALL TSTWLN ( ' ' )
         ELSE
            CALL NICEPR_1 ( MESSGE,  SEEN, TSTWLN )
         END IF
 
      END IF
C
C     Inhibit writing to the error log.
C
 
      CALL TSTIOH ( 'SAVE' )
 
      RETURN
 
C
C     Establish a special message to be printed if an error is
C     detected.
C
      ENTRY TSTMSG ( MARKER, MESSGE )
 
         MYMARK = MARKER
         EXTRA =  MESSGE
         SHOW  = .TRUE.
         RETURN
 
C
C     Fill in the next marker with the string representing INT.
C
      ENTRY TSTMSI ( INT )
 
         CALL REPMI ( EXTRA, MYMARK, INT, EXTRA )
         RETURN
C
C     Fill in the next marker with the string representing DP
C
      ENTRY TSTMSD ( DP  )
 
         CALL REPMD ( EXTRA, MYMARK, DP, 14, EXTRA )
         RETURN
 
      ENTRY TSTMSF ( DP  )
 
         CALL REPMF ( EXTRA, MYMARK, DP, 14, 'F', EXTRA )
         RETURN
C
C     Fill in the next marker with the character string MESSGE.
C
      ENTRY TSTMSC ( MESSGE )
 
         R = RTRIM(MESSGE)
 
         CALL REPMC ( EXTRA, MYMARK, MESSGE(1:R), EXTRA )
         RETURN
 
C
C     Fill in the next marker with an ordinal
C
      ENTRY TSTMSO ( INT, MARKER )
 
         IF  (       ( MARKER .NE. 'C' )
     .         .AND. ( MARKER .NE. 'c' )
     .         .AND. ( MARKER .NE. 'l' )
     .         .AND. ( MARKER .NE. 'u' )
     .         .AND. ( MARKER .NE. 'L' )
     .         .AND. ( MARKER .NE. 'U' ) ) THEN
 
            CALL REPMOT ( EXTRA, MYMARK, INT, 'l',    EXTRA )
 
         ELSE
 
            CALL REPMOT ( EXTRA, MYMARK, INT, MARKER, EXTRA )
 
         END IF
         RETURN
 
 
      ENTRY TSTMST ( INT, MARKER )
 
 
         IF  (       ( MARKER .NE. 'C' )
     .         .AND. ( MARKER .NE. 'c' )
     .         .AND. ( MARKER .NE. 'l' )
     .         .AND. ( MARKER .NE. 'u' )
     .         .AND. ( MARKER .NE. 'L' )
     .         .AND. ( MARKER .NE. 'U' ) ) THEN
 
            CALL REPMCT ( EXTRA, MYMARK, INT, 'l',    EXTRA )
 
         ELSE
 
            CALL REPMCT ( EXTRA, MYMARK, INT, MARKER, EXTRA )
 
         END IF
         RETURN
 
C
C    Turn off the test message so that it will not be shown.
C
      ENTRY TSTMOF
 
         SHOW = .FALSE.
 
      END
