C$Procedure      VERBOS ( Display detailed information to the screen)
C
      LOGICAL FUNCTION VERBOS ()
C
C$ Abstract
C
C     This routine controls whether or not detailed information is
C     written to the screen and log file.
C
C$ Required_Reading
C
C      None.
C
C$ Keywords
C
C       TESTING
C
C$ Declarations
C
      IMPLICIT NONE
 
C
C$ Brief_I/O
C
C      VARIABLE  I/O  DESCRIPTION
C      --------  ---  --------------------------------------------------
C       The function returns TRUE if details are to be displayed.
C
C$ Detailed_Input
C
C     None.
C
C$ Detailed_Output
C
C     The function returns TRUE if detailed information should be
C     written to the screen and log file.  This behavior is controlled
C     through the two entry points VERBON and VERBOFF.
C
C$ Parameters
C
C      None.
C
C$ Files
C
C      None.
C
C$ Exceptions
C
C     Error free.
C
C$ Particulars
C
C     This routines controls the writing of detailed messages to
C     the screen and log file.  The default behavior is to return
C     the value of FALSE.  You may turn on verbose output by calling
C     the entry point VERBON
C
C        ONOFF = VERBON
C
C     To turn verbose messages off call the entry point VERBOFF
C
C        ONOFF = VERBOFF
C
C$ Examples
C
C     Later.
C
C$ Restrictions
C
C     None.
C
C$ Author_and_Institution
C
C      W.L. Taber      (JPL)
C
C$ Literature_References
C
C      None.
C
C$ Version
C
C-    Testing Utilities Version 1.0.0, 21-NOV-1994 (WLT)
C
C
C-&
C
C$ Index_Entries
C
C     Determine the status of verbos output.
C
C-&
C     Entry points
C
      LOGICAL               VERBON
      LOGICAL               VERBOFF
C
C     Local Variables.
C
      LOGICAL               DISPLY
      SAVE
 
      DATA                  DISPLY / .FALSE. /
 
 
      VERBOS = DISPLY
      RETURN
 
      ENTRY VERBON
 
      DISPLY = .TRUE.
      VERBON = .TRUE.
      RETURN
 
      ENTRY VERBOFF
 
      DISPLY  = .FALSE.
      VERBOFF = .FALSE.
      RETURN
 
      END
 
 
