C$Procedure F_DDHCLU ( ZZDDHCLU Test Family )
 
      SUBROUTINE F_DDHCLU ( OK )
 
C$ Abstract
C
C     Test family to exercise the logic and code in the ZZDDHCLU
C     routine.
C
C$ Copyright
C
C     Copyright (2001), California Institute of Technology.
C     U.S. Government sponsorship acknowledged.
C
C$ Required_Reading
C
C     None.
C
C$ Keywords
C
C     TEST FAMILY
C
C$ Declarations
 
      IMPLICIT NONE
 
      INCLUDE              'zzddhman.inc'
 
      LOGICAL               OK
 
 
C$ Brief_I/O
C
C     VARIABLE  I/O  DESCRIPTION
C     --------  ---  --------------------------------------------------
C     OK         O   logical indicating test status.
C
C$ Detailed_Input
C
C     None.
C
C$ Detailed_Output
C
C     OK         is a logical that indicates the test status to the
C                caller.
C
C$ Parameters
C
C     None.
C
C$ Files
C
C     None.
C
C$ Exceptions
C
C     This routine does not generate any errors. Routines in its
C     call tree may generate errors that are either intentional and
C     trapped or unintentional and need reporting.  The test family
C     utilities manage this.
C
C$ Particulars
C
C     This routine exercises ZZDDHCLU's logic.
C
C$ Examples
C
C     None.
C
C$ Restrictions
C
C     None.
C
C$ Author_and_Institution
C
C     F.S. Turner     (JPL)
C
C$ Literature_References
C
C     None.
C
C$ Version
C
C-    TSPICE Version 1.0.0, 05-SEP-2001 (FST)
C
C-&
 
C
C     SPICELIB Functions
C
      INTEGER               ZZDDHCLU
 
C
C     Local Variables
C
      INTEGER               I
      INTEGER               NUT
      INTEGER               OUTPUT
 
      LOGICAL               UTLCK ( UTSIZE )
 
C
C     Start the test family with an open call.
C
      CALL TOPEN ( 'F_DDHCLU' )
 
C
C --- Case: ------------------------------------------------------
C
      CALL TCASE ( 'Empty table exceptional case.' )
 
C
C     Prepare the inputs and output default values.
C
      UTLCK(1) = .TRUE.
      NUT      = 0
 
      OUTPUT   = 10
 
C
C     Invoke the module.
C
      OUTPUT = ZZDDHCLU ( UTLCK, NUT )
 
C
C     Check for the absence of an exception.
C
      CALL CHCKXC ( .FALSE., ' ', OK )
 
C
C     Check outputs.
C
      CALL CHCKSI ( 'ZZDDHCLU', OUTPUT, '=', 0, 0, OK )
 
C
C --- Case: ------------------------------------------------------
C
      CALL TCASE ( 'Non-empty table, nominal case.' )
 
C
C     Prepare the inputs and output default values.
C
      NUT = 10
 
      DO I = 1, NUT
 
         UTLCK(I) = .FALSE.
 
      END DO
 
      UTLCK(NUT) = .TRUE.
      UTLCK(1)   = .TRUE.
 
      OUTPUT = 0
 
C
C     Invoke the module.
C
      OUTPUT = ZZDDHCLU ( UTLCK, NUT )
 
C
C     Check for the absence of an exception.
C
      CALL CHCKXC ( .FALSE., ' ', OK )
 
C
C     Check outputs.
C
      CALL CHCKSI ( 'ZZDDHCLU', OUTPUT, '=', 2, 0, OK )
 
C
C     Close out the test family.
C
      CALL T_SUCCESS ( OK )
      RETURN
 
      END
