C$Procedure      F_REPMX (meaning)
 
      SUBROUTINE F_REPMX ( OK )
      IMPLICIT NONE
 
      LOGICAL               OK
 
C$ Abstract
C
C     Perform a series of tests on the routine REPMC, REPMD,
C     REPMF, REPMI
C
C-&
 
 
C
C     Test Utility Functions
C
 
 
C
C     SPICELIB Functions
C
 
 
C
C     Local Variables
C
      INTEGER               LNSIZE
      PARAMETER           ( LNSIZE = 80 )
 
      INTEGER               WDSIZE
      PARAMETER           ( WDSIZE = 32 )
 
      CHARACTER*(LNSIZE)    LINE
      CHARACTER*(LNSIZE)    RESULT
      CHARACTER*(LNSIZE)    EXP
 
      CHARACTER*(WDSIZE)    WORD
      CHARACTER*(WDSIZE)    WEXP
 
 
      CHARACTER*(WDSIZE)    SUB
      INTEGER               I
      DOUBLE PRECISION      X
 
 
 
C
C     Begin every test family with an open call.
C
      CALL TOPEN ( 'F_REPMX' )
 
 
      CALL TCASE ( 'Character substitution  -- check REPMC' )
 
         LINE = 'The value is ''#''.'
         EXP  = 'The value is ''ok''.'
         SUB  = 'ok'
 
         CALL REPMC ( LINE, '#', SUB, RESULT )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSC ( 'RESULT', RESULT, '=', EXP, OK )
 
      CALL TCASE ( 'Character substitution in-place -- check REPMC' )
 
         RESULT = 'The value is ''#''.'
         EXP  = 'The value is ''ok''.'
         SUB  = 'ok'
 
         CALL REPMC ( RESULT, '#', SUB, RESULT )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSC ( 'RESULT', RESULT, '=', EXP, OK )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
 
 
      CALL TCASE ( 'Character substitution truncated -- check REPMC' )
 
         LINE  = 'The value is ''#''.'
         WEXP  = 'The value is ''a very long string indeed''.'
         SUB   = 'a very long string indeed'
 
         CALL REPMC ( LINE, '#', SUB, WORD )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSC ( 'WORD', WORD, '=', WEXP, OK )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
 
 
      CALL TCASE ( 'Character substitution inplace truncated '
     .//           '-- check REPMC' )
 
 
         WORD  = 'The value is ''#''.'
         WEXP  = 'The value is ''a very long string indeed''.'
         SUB   = 'a very long string indeed'
 
         CALL REPMC ( WORD, '#', SUB, WORD )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSC ( 'WORD', WORD, '=', WEXP, OK )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
 
 
 
 
      CALL TCASE ( 'Integer substitution -- check REPMI' )
 
         LINE = 'The value is ''#''.'
         EXP  = 'The value is ''3''.'
         I  = 3
 
         CALL REPMI ( LINE, '#', I, RESULT )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSC ( 'RESULT', RESULT, '=', EXP, OK )
 
      CALL TCASE ( 'Integer substitution in-place -- check REPMI' )
 
 
         RESULT = 'The value is ''#''.'
         EXP    = 'The value is ''3''.'
         I      = 3
 
         CALL REPMI ( RESULT, '#', I, RESULT )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSC ( 'RESULT', RESULT, '=', EXP, OK )
 
 
      CALL TCASE ('Double precision substitution (scientific) -- REPMD')
 
         LINE = 'The value is ''#''.'
         EXP  = 'The value is ''4.0E+00''.'
         X  = 4.0
 
         CALL REPMD ( LINE, '#', X, 2, RESULT )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSC ( 'RESULT', RESULT, '=', EXP, OK )
 
      CALL TCASE ( 'Double precision substitution in-place '
     .//           '(scientific) -- REPMD' )
 
         RESULT = 'The value is ''#''.'
         EXP  = 'The value is ''4.0E+00''.'
         X  = 4.0
 
         CALL REPMD ( LINE, '#', X, 2, RESULT )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSC ( 'RESULT', RESULT, '=', EXP, OK )
 
      CALL TCASE ('Double precision substitution (float) -- REPMF')
 
         LINE = 'The value is ''#''.'
         EXP  = 'The value is ''4.0''.'
         X  = 4.0
 
         CALL REPMF ( LINE, '#', X, 2, 'f',  RESULT )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSC ( 'RESULT', RESULT, '=', EXP, OK )
 
 
      CALL TCASE ( 'Double precision substitution in-place '
     .//           '(float) -- REPMD' )
 
 
         RESULT = 'The value is ''#''.'
         EXP    = 'The value is ''4.0''.'
         X      = 4.0
 
         CALL REPMF ( RESULT, '#', X, 2, 'g',  RESULT )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSC ( 'RESULT', RESULT, '=', EXP, OK )
 
 
      CALL T_SUCCESS ( OK )
      RETURN
      END
