C$Procedure      F_STR2ET ( Family of tests for STR2ET )
 
      SUBROUTINE F_STR2ET ( OK )
      IMPLICIT NONE
 
      LOGICAL               OK
 
C$ Abstract
C
C     This routine tests the routine STR2ET to make sure it
C     can handle the claimed variety of input strings.
C
C-&
      INTEGER               WDSIZE
      PARAMETER           ( WDSIZE = 32 )
 
      CHARACTER*(WDSIZE)    BEGDAT
 
C
C     SPICELIB Functions
C
      DOUBLE PRECISION      UNITIM
 
C
C     Local Variables
C
      INTEGER               LNSIZE
      PARAMETER           ( LNSIZE = 80 )
 
      INTEGER               MSGSIZ
      PARAMETER           ( MSGSIZ = 300 )
 
      INTEGER               I
      INTEGER               NLINES
 
      CHARACTER*(LNSIZE)    TSTRNG ( 24  )
      CHARACTER*(LNSIZE)    KERNEL ( 23  )
      CHARACTER*(MSGSIZ)    ERROR
 
 
      DOUBLE PRECISION      EXPDET ( 24  )
      DOUBLE PRECISION      ET
 
 
 
 
 
 
C
C     Begin every test family with an open call.
C
      CALL TOPEN ( 'F_STR2ET' )
 
      KERNEL(  1 ) = BEGDAT()
      KERNEL(  2 ) = ' '
      KERNEL(  3 ) = 'DELTET/DELTA_T_A       =   32.184'
      KERNEL(  4 ) = 'DELTET/K               =    1.657D-3'
      KERNEL(  5 ) = 'DELTET/EB              =    1.671D-2'
      KERNEL(  6 ) = 'DELTET/M               = (  6.239996D0 '
     .//             '  1.99096871D-7 )'
      KERNEL(  7 ) = ' '
      KERNEL(  8 ) = 'DELTET/DELTA_AT        = ( 10,   @1972-'
     .//             'JAN-1'
      KERNEL(  9 ) = '                           11,   @1972-'
     .//             'JUL-1'
      KERNEL( 10 ) = '                           12,   @1973-'
     .//             'JAN-1'
      KERNEL( 11 ) = '                           13,   @1974-'
     .//             'JAN-1'
      KERNEL( 12 ) = '                           14,   @1975-'
     .//             'JAN-1'
      KERNEL( 13 ) = '                           15,   @1976-'
     .//             'JAN-1'
      KERNEL( 14 ) = '                           16,   @1977-'
     .//             'JAN-1'
      KERNEL( 15 ) = '                           17,   @1978-'
     .//             'JAN-1'
      KERNEL( 16 ) = '                           18,   @1979-'
     .//             'JAN-1'
      KERNEL( 17 ) = '                           19,   @1980-'
     .//             'JAN-1'
      KERNEL( 18 ) = '                           20,   @1981-'
     .//             'JUL-1'
      KERNEL( 19 ) = '                           21,   @1982-'
     .//             'JUL-1'
      KERNEL( 20 ) = '                           22,   @1983-'
     .//             'JUL-1'
      KERNEL( 21 ) = '                           23,   @1985-'
     .//             'JUL-1'
      KERNEL( 22 ) = '                           24,   @1988-'
     .//             'JAN-1'
      KERNEL( 23 ) = '                           25,   @1990-'
     .//             'JAN-1 )'
 
      NLINES = 23
 
      CALL CLPOOL
      CALL TSTTXT ( 'testleap.ker', KERNEL, NLINES, .TRUE., .FALSE. )
 
 
      CALL TCASE ( 'Make sure that '
     .//           'an exception is generated when a component '
     .//           'of the time string is out of range. ' )
 
 
         TSTRNG(1) = '1994 JAN 32 08:43:12'
 
         CALL STR2ET ( TSTRNG(1), ET )
         CALL CHCKXC ( .TRUE., 'SPICE(BADTIMESTRING)', OK )
 
      CALL TCASE ( 'Check STR2ET against a collection of times '
     .//           'for which the outcome has been computed and '
     .//           'hardcoded in advance. ' )
 
 
 
         TSTRNG (  1  ) = ' 1/9/1986 3:12:59.2'
         EXPDET (  1  ) =  -441103565.6158334016800D+00
 
         TSTRNG (  2  ) = '9 JAN 1986 03:12:59.2'
         EXPDET (  2  ) =  -441103565.6158334016800D+00
 
         TSTRNG (  3  ) = '1 9 1986 3:12:59.2'
         EXPDET (  3  ) =  -441103565.6158334016800D+00
 
         TSTRNG (  4  ) = '9 JAN 1986 03:12:59.2'
         EXPDET (  4  ) =  -441103565.6158334016800D+00
 
         TSTRNG (  5  ) = '2 jan 1991 3:00:12.2'
         EXPDET (  5  ) =  -283942730.6160448789597D+00
 
         TSTRNG (  6  ) = '2 JAN 1991 03:00:12.2'
         EXPDET (  6  ) =  -283942730.6160448789597D+00
 
         TSTRNG (  7  ) = '1991 MAR 10 12:00:00'
         EXPDET (  7  ) =  -278121542.8144892454147D+00
 
         TSTRNG (  8  ) = '10 MAR 1991 12:00:00'
         EXPDET (  8  ) =  -278121542.8144892454147D+00
 
         TSTRNG (  9  ) = '1 March 1975 3:00'
         EXPDET (  9  ) =  -783853153.8146169185638D+00
 
         TSTRNG ( 10  ) = '1 MAR 1975 03:00:00'
         EXPDET ( 10  ) =  -783853153.8146169185638D+00
 
         TSTRNG ( 11  ) = '2010 October 29 3:58'
         EXPDET ( 11  ) =   341596737.1824791431427D+00
 
         TSTRNG ( 12  ) = '29 OCT 2010 03:58:00'
         EXPDET ( 12  ) =   341596737.1824791431427D+00
 
         TSTRNG ( 13  ) = 'dec 31 86 12:00'
         EXPDET ( 13  ) =  -410313544.8160908222198D+00
 
         TSTRNG ( 14  ) = '31 DEC 1986 12:00:00'
         EXPDET ( 14  ) =  -410313544.8160908222198D+00
 
         TSTRNG ( 15  ) = '86-365 // 12:00'
         EXPDET ( 15  ) =  -410313544.8160908222198D+00
 
         TSTRNG ( 16  ) = '31 DEC 1986 12:00:00'
         EXPDET ( 16  ) =  -410313544.8160908222198D+00
 
         TSTRNG ( 17  ) = 'JD 2451545.'
         EXPDET ( 17  ) =  57.1839272823238D+00
 
         TSTRNG ( 18  ) = '1 JAN 2000 12:00:00'
         EXPDET ( 18  ) =  57.1839272823238D+00
 
         TSTRNG ( 19  ) = 'jd 2451545.'
         EXPDET ( 19  ) =  57.1839272823238D+00
 
         TSTRNG ( 20  ) = '1 JAN 2000 12:00:00'
         EXPDET ( 20  ) =  57.1839272823238D+00
 
         TSTRNG ( 21  ) = 'JD2451545.'
         EXPDET ( 21  ) =  57.1839272823238D+00
 
         TSTRNG ( 22  ) = '1 JAN 2000 12:00:00'
         EXPDET ( 22  ) =  57.1839272823238D+00
 
         TSTRNG ( 23  ) = 'JDTDB 2451546.0'
         EXPDET ( 23  ) =  86400.0D+00
 
         TSTRNG ( 24  ) = 'JDTDB 2451545.0'
         EXPDET ( 24  ) =  0.0D+00
 
 
         DO I = 1, 24
 
            CALL TSTMSG ( '#', 'Test subcase #. #' )
            CALL TSTMSI (  I )
 
            CALL STR2ET ( TSTRNG(I), ET )
            CALL CHCKXC ( .FALSE., ' ', OK )
            IF ( I .LT. 17 ) THEN
               CALL CHCKSD ( 'ET', ET, '~/', EXPDET(I), 1.0D-13, OK )
            ELSE 
               CALL CHCKSD ( 'ET', ET, '~/', EXPDET(I), 1.0D-11, OK )
            END IF
 
         END DO
 
      CALL TCASE ( 'Step accross a leapsecond making sure that '
     .//           'ET has the expected behavior. ' )
 
 
         TSTRNG (  1  ) = '31 DEC 1989 23:59:55.01'
         EXPDET (  1  ) =  -315575948.8060699105263D+00
 
         TSTRNG (  2  ) = '31 DEC 1989 23:59:56.02'
         EXPDET (  2  ) =  -315575947.7960699200630D+00
 
         TSTRNG (  3  ) = '31 DEC 1989 23:59:57.03'
         EXPDET (  3  ) =  -315575946.7860699295998D+00
 
         TSTRNG (  4  ) = '31 DEC 1989 23:59:58.04'
         EXPDET (  4  ) =  -315575945.7760698795319D+00
 
         TSTRNG (  5  ) = '31 DEC 1989 23:59:59.05'
         EXPDET (  5  ) =  -315575944.7660698890686D+00
 
         TSTRNG (  6  ) = '31 DEC 1989 23:59:60.06'
         EXPDET (  6  ) =  -315575943.7560698986053D+00
 
         TSTRNG (  7  ) = '1  JAN 1990 00:00:00.07'
         EXPDET (  7  ) =  -315575942.7460699081421D+00
 
         TSTRNG (  8  ) = '1  JAN 1990 00:00:01.08'
         EXPDET (  8  ) =  -315575941.7360699176788D+00
 
 
         DO I = 1, 8
 
            CALL TSTMSG ( '#', 'Test subcase #.' )
            CALL TSTMSI (  I )
 
            CALL STR2ET ( TSTRNG(I), ET )
            CALL CHCKXC ( .FALSE., ' ', OK )
            CALL CHCKSD ( 'ET', ET, '~/', EXPDET(I), 1.0D-13, OK )
 
         END DO
 
 
      CALL TCASE ( 'Check to see that we can successfully '
     .//           'compute TDB based times. SubCase 1.' )
 
 
         TSTRNG(1) = 'Fri Sep 27 11:02:05 1996 TDB'
 
         CALL TPARSE ( 'Sep 27 11:02:05 1996',  EXPDET(1), ERROR )
         CALL STR2ET ( TSTRNG(1),  ET )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSD ( 'ET', ET, '=', EXPDET(1), 1.0D-13, OK )
 
      CALL TCASE ( 'Check to see that we can successfully '
     .//           'compute TDB based times. SubCase 2.' )
 
 
         TSTRNG(1) = 'Fri, Sep 27 11:02:05 1996 TDB'
 
         CALL TPARSE ( 'Sep 27 11:02:05 1996',  EXPDET(1), ERROR )
         CALL STR2ET ( TSTRNG(1),  ET )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSD ( 'ET', ET, '=', EXPDET(1), 1.0D-13, OK )
 
      CALL TCASE ( 'Check to see that we can successfully '
     .//           'compute times for various time zones. ' )
 
         CALL UTC2ET ( 'Sep 27 18:08:31 1996', EXPDET(1) )
 
         TSTRNG(1) = 'Fri Sep 27 11:08:31 PDT 1996'
         CALL STR2ET ( TSTRNG(1),  ET )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSD ( 'ET', ET, '=', EXPDET(1), 1.0D-13, OK )
 
 
         TSTRNG(1) = 'Fri Sep 27 10:08:31 PST 1996'
         CALL STR2ET ( TSTRNG(1),  ET )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSD ( 'ET', ET, '=', EXPDET(1), 1.0D-13, OK )
 
         TSTRNG(1) = 'Fri, Sep 27 10:08:31 PST 1996'
         CALL STR2ET ( TSTRNG(1),  ET )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSD ( 'ET', ET, '=', EXPDET(1), 1.0D-13, OK )
 
 
         TSTRNG(1) = 'Fri Sep 27 11:08:31 MST 1996'
         CALL STR2ET ( TSTRNG(1),  ET )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSD ( 'ET', ET, '=', EXPDET(1), 1.0D-13, OK )
 
         TSTRNG(1) = 'Fri, Sep 27 11:08:31 MST 1996'
         CALL STR2ET ( TSTRNG(1),  ET )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSD ( 'ET', ET, '=', EXPDET(1), 1.0D-13, OK )
 
 
         TSTRNG(1) = 'Fri Sep 27 12:08:31 MDT 1996'
         CALL STR2ET ( TSTRNG(1),  ET )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSD ( 'ET', ET, '=', EXPDET(1), 1.0D-13, OK )
 
         TSTRNG(1) = 'Fri Sep 27 12:08:31 CST 1996'
         CALL STR2ET ( TSTRNG(1),  ET )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSD ( 'ET', ET, '=', EXPDET(1), 1.0D-13, OK )
 
         TSTRNG(1) = 'Fri Sep 27 13:08:31 CDT 1996'
         CALL STR2ET ( TSTRNG(1),  ET )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSD ( 'ET', ET, '=', EXPDET(1), 1.0D-13, OK )
 
         TSTRNG(1) = 'Fri Sep 27 13:08:31 EST 1996'
         CALL STR2ET ( TSTRNG(1),  ET )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSD ( 'ET', ET, '=', EXPDET(1), 1.0D-13, OK )
 
 
         TSTRNG(1) = 'Fri Sep 27 14:08:31 EDT 1996'
         CALL STR2ET ( TSTRNG(1),  ET )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSD ( 'ET', ET, '=', EXPDET(1), 1.0D-13, OK )
 
 
      CALL TCASE ( 'Check to see that we can successfully '
     .//           'compute times for time zones that are offset '
     .//           'from UTC by a fractional number of hours. ' )
 
         CALL UTC2ET ( 'Sep 27 18:08:31 1996', EXPDET(1) )
 
         TSTRNG(1) = 'Fri Sep 27 13:00:31 1996  UTC-5:08'
         CALL STR2ET ( TSTRNG(1),  ET )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSD ( 'ET', ET, '=', EXPDET(1), 1.0D-13, OK )
 
      CALL TCASE ( 'Make sure that TDT labelled strings are '
     .//           'recognized and properly processed. '  )
 
         TSTRNG(1) = 'Fri Sep 27 11:02:05 1996 TDT'
 
         CALL TPARSE ( 'Sep 27 11:02:05 1996',  EXPDET(1), ERROR )
 
         EXPDET(1) = UNITIM ( EXPDET(1), 'TDT', 'TDB' )
 
         CALL STR2ET ( TSTRNG(1),  ET )
 
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSD ( 'ET', ET, '~', EXPDET(1), 1.0D-7, OK )
 
      CALL TCASE ( 'Make sure that an exception is triggered if '
     .//           'we try to put a leapsecond in the wrong '
     .//           'place on the UTC scale. ' )
 
 
         TSTRNG(1) = 'Fri Sep 27 23:59:60.1 1996'
         CALL STR2ET ( TSTRNG(1),  ET )
 
         CALL CHCKXC ( .TRUE., 'SPICE(BADTIMESTRING)',  OK )
 
      CALL TCASE ( 'Make sure that an exception is triggered if '
     .//           'we try to put a leapsecond in the wrong '
     .//           'place on a non-UTC scale. ' )
 
 
         TSTRNG(1) = 'DEC 31 23:59:60.1 1996 PDT'
         CALL STR2ET ( TSTRNG(1),  ET )
 
         CALL CHCKXC ( .TRUE., 'SPICE(BADTIMESTRING)',  OK )
 
      CALL TCASE ( 'Make sure that we get a good value for a '
     .//           'real leapsecond on a non-UTC Scale. ' )
C
C        Note we just copied the expected value of ET from a
C        previous case.
C
         TSTRNG (  1  ) = '31 DEC 1989 15:59:60.06 PST'
         EXPDET (  1  ) =  -315575943.7560698986053D+00
 
         CALL STR2ET ( TSTRNG(1), ET )
         CALL CHCKXC ( .FALSE., ' ', OK )
         CALL CHCKSD ( 'ET', ET, '~/', EXPDET(1), 1.0D-13, OK )
 
         TSTRNG (  1  ) = '31 DEC 1989 13:39:60.06 UTC-10:20'
         EXPDET (  1  ) =  -315575943.7560698986053D+00
 
         CALL STR2ET ( TSTRNG(1), ET )
         CALL CHCKXC ( .FALSE., ' ', OK )
         CALL CHCKSD ( 'ET', ET, '~/', EXPDET(1), 1.0D-13, OK )
 
 
         TSTRNG (  1  ) = '1 JAN 1990 10:19:60.06 UTC+10:20'
         EXPDET (  1  ) =  -315575943.7560698986053D+00
 
         CALL STR2ET ( TSTRNG(1), ET )
         CALL CHCKXC ( .FALSE., ' ', OK )
         CALL CHCKSD ( 'ET', ET, '~/', EXPDET(1), 1.0D-13, OK )
 
      CALL TCASE ( 'Make sure that leap seconds are not allowed '
     .//           'in the TDB system. ' )
 
 
         TSTRNG (  1  ) = '31 DEC 1989 23:59:60.06 TDB'
         CALL STR2ET ( TSTRNG(1),  ET )
 
         CALL CHCKXC ( .TRUE., 'SPICE(BADTIMESTRING)',  OK )
 
 
      CALL TCASE ( 'Make sure that leap seconds are not allowed '
     .//           'in the TDT system. ' )
 
 
         TSTRNG (  1  ) = '31 DEC 1989 23:59:60.06 TDT'
         CALL STR2ET ( TSTRNG(1),  ET )
 
         CALL CHCKXC ( .TRUE., 'SPICE(BADTIMESTRING)',  OK )
 
 
      CALL TCASE ( 'Change the default time system and see that '
     .//           'the change is properly reflected in the '
     .//           'behavior of STR2ET. DEFSYS = TDB ' )
 
         CALL TIMDEF ( 'SET', 'SYSTEM', 'TDB' )
 
         TSTRNG (  1  ) = '31 DEC 1989 15:59:00 '
         CALL TPARSE ( '31 DEC 1989 15:59:00 ', EXPDET(1), ERROR )
         CALL STR2ET ( TSTRNG(1), ET )
 
         CALL CHCKXC ( .FALSE., ' ', OK )
         CALL CHCKSD ( 'ET', ET, '~/', EXPDET(1), 1.0D-13, OK )
 
         CALL TIMDEF ( 'SET', 'SYSTEM', 'UTC' )
 
      CALL TCASE ( 'Change the default time system and see that '
     .//           'the change is properly reflected in the '
     .//           'behavior of STR2ET. DEFSYS = TDT ' )
 
         CALL TIMDEF ( 'SET', 'SYSTEM', 'TDT' )
 
         TSTRNG (  1  ) = '31 DEC 1989 15:59:00 '
         CALL TPARSE ( '31 DEC 1989 15:59:00 ', ET, ERROR )
         EXPDET(1) = UNITIM ( ET, 'TDT', 'TDB' )
 
         CALL STR2ET ( TSTRNG(1), ET )
 
         CALL CHCKXC ( .FALSE., ' ', OK )
         CALL CHCKSD ( 'ET', ET, '~/', EXPDET(1), 1.0D-14, OK )
 
         CALL TIMDEF ( 'SET', 'SYSTEM', 'UTC' )
 
      CALL TCASE ( 'Change the default time zone and make sure '
     .//           'the change is properly reflected in the '
     .//           'action of STR2ET. ZONE = ''PST'' ' )
 
         CALL TIMDEF ( 'SET', 'ZONE', 'PST' )
 
         TSTRNG(1) = 'Fri Sep 27 12:42:55 1996'
         CALL UTC2ET ( 'Fri Sep 27 20:42:55 1996', EXPDET(1) )
 
         CALL STR2ET ( TSTRNG(1), ET )
 
         CALL CHCKXC ( .FALSE., ' ', OK )
         CALL CHCKSD ( 'ET', ET, '~/', EXPDET(1), 1.0D-14, OK )
 
         CALL TIMDEF ( 'SET', 'SYSTEM', 'UTC' )
 
 
      CALL TCASE ( 'Change the default calendar to JULIAN and '
     .//           'make sure that we get the appropriate '
     .//           'behavior from STR2ET. ' )
 
 
         CALL TIMDEF ( 'SET', 'CALENDAR', 'JULIAN' )
 
         TSTRNG(1) = 'Sep 3 12:42:55 1752'
 
         CALL STR2ET ( TSTRNG(1), ET )
         CALL UTC2ET ( 'Sep 14 12:42:55 1752', EXPDET (1) )
 
         CALL CHCKXC ( .FALSE., ' ', OK )
         CALL CHCKSD ( 'ET', ET, '~', EXPDET(1), 1.0D-14, OK )
 
 
         TSTRNG(1) = '1752-200//12:42:55'
         CALL STR2ET ( TSTRNG(1), ET )
         CALL UTC2ET ( '1752-211//12:42:55', EXPDET (1) )
 
         CALL CHCKXC ( .FALSE., ' ', OK )
         CALL CHCKSD ( 'ET', ET, '~', EXPDET(1), 1.0D-14, OK )
 
         CALL TIMDEF ( 'SET', 'SYSTEM', 'UTC' )
         CALL TIMDEF ( 'SET', 'CALENDAR', 'GREGORIAN' )
 
 
      CALL TCASE ( 'Change the default calendar to MIXED and '
     .//           'make sure that we get the appropriate '
     .//           'behavior from STR2ET. ' )
 
         CALL TIMDEF ( 'SET', 'CALENDAR', 'MIXED' )
 
         TSTRNG(1) = 'Fri Sep 27 13:08:46 1996'
 
         CALL STR2ET ( TSTRNG(1), ET )
         CALL UTC2ET ( 'Fri Sep 27 13:08:46 1996', EXPDET (1) )
 
         CALL CHCKXC ( .FALSE., ' ', OK )
         CALL CHCKSD ( 'ET', ET, '~', EXPDET(1), 1.0D-14, OK )
 
 
         TSTRNG(1) = '1582 OCT 3, 12:42:55'
         CALL STR2ET ( TSTRNG(1), ET )
         CALL UTC2ET ( '1582 OCT 13, 12:42:55', EXPDET (1) )
 
         CALL CHCKXC ( .FALSE., ' ', OK )
         CALL CHCKSD ( 'ET', ET, '~', EXPDET(1), 1.0D-14, OK )
 
         TSTRNG(1) = '1582 OCT 13, 12:42:55'
         CALL STR2ET ( TSTRNG(1), ET )
         CALL UTC2ET ( '1582 OCT 13, 12:42:55', EXPDET (1) )
 
         CALL CHCKXC ( .FALSE., ' ', OK )
         CALL CHCKSD ( 'ET', ET, '~', EXPDET(1), 1.0D-14, OK )
 
         CALL TIMDEF ( 'SET', 'SYSTEM', 'UTC' )
         CALL TIMDEF ( 'SET', 'CALENDAR', 'GREGORIAN' )
 
 
      CALL TCASE ( 'Make sure that we can handle leap seconds on '
     .//           'the Julian calendar. ' )
 
         CALL TIMDEF ( 'SET', 'CALENDAR', 'JULIAN' )
 
         TSTRNG(1) = 'December 18, 1996 23:59:60.6'
 
         CALL STR2ET ( TSTRNG(1), ET )
         CALL UTC2ET ( 'December 31, 1996 23:59:60.6', EXPDET (1) )
 
         CALL CHCKXC ( .FALSE., ' ', OK )
         CALL CHCKSD ( 'ET', ET, '~', EXPDET(1), 1.0D-14, OK )
         CALL TIMDEF ( 'SET', 'SYSTEM', 'UTC' )
         CALL TIMDEF ( 'SET', 'CALENDAR', 'GREGORIAN' )
 
 
      CALL TCASE ( 'Make sure that we can handle leap seconds on '
     .//           'the Julian calendar in non-UTC time zones. ' )
 
         CALL TIMDEF ( 'SET', 'CALENDAR', 'JULIAN' )
         CALL TIMDEF ( 'SET', 'ZONE',     'PST' )
 
         TSTRNG(1) = 'December 18, 1996 15:59:60.6'
 
         CALL STR2ET ( TSTRNG(1), ET )
         CALL UTC2ET ( 'December 31, 1996 23:59:60.6', EXPDET (1) )
 
         CALL CHCKXC ( .FALSE., ' ', OK )
         CALL CHCKSD ( 'ET', ET, '~', EXPDET(1), 1.0D-14, OK )
         CALL TIMDEF ( 'SET', 'SYSTEM', 'UTC' )
         CALL TIMDEF ( 'SET', 'CALENDAR', 'GREGORIAN' )
 
 
      CALL TCASE ( 'Make sure that seconds out of range are '
     .//           'properly diagnosed on the Julian Calendar. ' )
 
         CALL TIMDEF ( 'SET', 'CALENDAR', 'JULIAN' )
 
         TSTRNG(1) = 'December 17, 1996 23:59:60.6'
 
         CALL STR2ET ( TSTRNG(1), ET )
 
         CALL CHCKXC ( .TRUE., 'SPICE(BADTIMESTRING)', OK )
 
      CALL TCASE ( 'Make sure that out of range seconds are '
     .//           'properly diagnosed on the Julian Calendar '
     .//           'when using a non-UTC time zone. ' )
 
 
         CALL TIMDEF ( 'SET', 'CALENDAR', 'JULIAN' )
         CALL TIMDEF ( 'SET', 'ZONE',     'PST' )
 
         TSTRNG(1) = 'December 17, 1996 15:59:60.6'
 
         CALL STR2ET ( TSTRNG(1), ET )
         CALL CHCKXC ( .TRUE., 'SPICE(BADTIMESTRING)', OK )
 
      CALL TPARCH    ( 'NO' )
      CALL T_SUCCESS (  OK  )
      RETURN
      END
