C$Procedure      F_TEXPYR ( Family of tests for TEXPYR )
 
      SUBROUTINE F_TEXPYR ( OK )
      IMPLICIT NONE
 
      LOGICAL               OK
 
C$ Abstract
C
C     This routine tests the routine TEXPYR and its companion
C     entry point TSETYR.
C
C$ Version
C
C-    TSPICE Version 2.0.0, 13-DEC-2001 (FST)
C
C        Updated this routine to restore and exercise the
C        default value of 1969 for TSETYR.
C
C-&
 
C
C     Test Utility Functions
C
 
 
C
C     SPICELIB Functions
C
 
C
C     Local Variables
C
      INTEGER               YEAR
      INTEGER               EXPYR
      INTEGER               I
 
 
C
C     Begin every test family with an open call.
C
      CALL TOPEN ( 'F_TEXPYR' )
 
      CALL TCASE ( 'Make sure that in the default case two digit '
     .//           'years range are mapped to the interval from '
     .//           '1969 to 2068.')
 
 
         DO I = 0, 99
 
            YEAR = I
            CALL TEXPYR ( YEAR )
 
            CALL CHCKXC ( .FALSE., ' ', OK )
 
            IF ( I .LE. 68 ) THEN
               EXPYR = 2000 + I
            ELSE
               EXPYR = 1900 + I
            END IF
 
            CALL CHCKSI ( 'YEAR', YEAR, '=', EXPYR, 0, OK )
 
         END DO
 
      CALL TCASE ( 'Make sure that when we set the lower bound '
     .//           'for the century that all two digit years are '
     .//           'expanded appropriately. ' )
 
 
         CALL TSETYR ( 2025 )
 
         DO I = 0, 99
 
            YEAR = I
            CALL TEXPYR ( YEAR )
 
            CALL CHCKXC ( .FALSE., ' ', OK )
 
            IF ( I .LE. 24 ) THEN
               EXPYR = 2100 + I
            ELSE
               EXPYR = 2000 + I
            END IF
 
            CALL CHCKSI ( 'YEAR', YEAR, '=', EXPYR, 0, OK )
 
         END DO
C
C        Reset the lowerbound and re-do the first set of tests.
C
         CALL TSETYR ( 1969 )
 
         DO I = 0, 99
 
            YEAR = I
            CALL TEXPYR ( YEAR )
 
            CALL CHCKXC ( .FALSE., ' ', OK )
 
            IF ( I .LE. 68 ) THEN
               EXPYR = 2000 + I
            ELSE
               EXPYR = 1900 + I
            END IF
 
            CALL CHCKSI ( 'YEAR', YEAR, '=', EXPYR, 0, OK )
 
         END DO
 
      CALL TCASE ( 'Make sure that years outside the inclusive '
     .//           'range from 0 to 99 are not altered by '
     .//           'TEXPYR. ' )
 
 
 
         YEAR  = 1928
         EXPYR = 1928
 
         CALL TEXPYR ( YEAR )
         CALL CHCKXC ( .FALSE., ' ', OK )
         CALL CHCKSI ( 'YEAR', YEAR, '=', EXPYR, 0, OK )
 
         YEAR  = 100
         EXPYR = 100
 
         CALL TEXPYR ( YEAR )
         CALL CHCKXC ( .FALSE., ' ', OK )
         CALL CHCKSI ( 'YEAR', YEAR, '=', EXPYR, 0, OK )
 
         YEAR  = -1
         EXPYR = -1
 
         CALL TEXPYR ( YEAR )
         CALL CHCKXC ( .FALSE., ' ', OK )
         CALL CHCKSI ( 'YEAR', YEAR, '=', EXPYR, 0, OK )
 
 
      CALL T_SUCCESS ( OK )
      RETURN
      END
