C$Procedure F_ZZBODS (Family of tests for ZZBODTRN)
 
      SUBROUTINE F_ZZBODS ( OK )
      IMPLICIT NONE
 
      LOGICAL               OK

      INCLUDE              'zzbodtrn.inc'

C$ Abstract
C
C     This family of tests exercises the ZZBODTRN interfaces
C     BODN2C, BODC2N.
C
C$ Copyright
C
C     Copyright (2003), California Institute of Technology.
C     U.S. Government sponsorship acknowledged.
C
C$ Required_Reading
C
C   None.
C
C$ Keywords
C
C   N/A.
C
C$ Author_and_Institution
C
C     E.D. Wright (JPL)
C
C$ Version
C
C   TSPICE, Mon Dec 20 07:32:37 2004 (EDW)
C
C-&

C
C Local variables.
C
      INTEGER                I
      INTEGER                CODE
      INTEGER                C2NCOD(NPERM)
      INTEGER                N2CCOD(NPERM)

      CHARACTER*(MAXL)       NAME
      CHARACTER*(MAXL)       C2NNAM(NPERM)
      CHARACTER*(MAXL)       N2CNAM(NPERM)
      CHARACTER*(MAXL+64)    TSTSTR

      LOGICAL                FOUND

C
C     A script generates this file. Do not edit by hand.
C     Edit the creation script to modify the contents of
C     F_ZZBODS.FOR.
C


C
C     The data list for the NAME -> ID tests.
C

      N2CCOD(1) =   0
      N2CNAM(1) =  'SSB'

      N2CCOD(2) =   0
      N2CNAM(2) =  'SOLAR SYSTEM BARYCENTER'

      N2CCOD(3) =   1
      N2CNAM(3) =  'MERCURY BARYCENTER'

      N2CCOD(4) =   2
      N2CNAM(4) =  'VENUS BARYCENTER'

      N2CCOD(5) =   3
      N2CNAM(5) =  'EMB'

      N2CCOD(6) =   3
      N2CNAM(6) =  'EARTH MOON BARYCENTER'

      N2CCOD(7) =   3
      N2CNAM(7) =  'EARTH-MOON BARYCENTER'

      N2CCOD(8) =   3
      N2CNAM(8) =  'EARTH BARYCENTER'

      N2CCOD(9) =   4
      N2CNAM(9) =  'MARS BARYCENTER'

      N2CCOD(10) =   5
      N2CNAM(10) =  'JUPITER BARYCENTER'

      N2CCOD(11) =   6
      N2CNAM(11) =  'SATURN BARYCENTER'

      N2CCOD(12) =   7
      N2CNAM(12) =  'URANUS BARYCENTER'

      N2CCOD(13) =   8
      N2CNAM(13) =  'NEPTUNE BARYCENTER'

      N2CCOD(14) =   9
      N2CNAM(14) =  'PLUTO BARYCENTER'

      N2CCOD(15) =   10
      N2CNAM(15) =  'SUN'

      N2CCOD(16) =   199
      N2CNAM(16) =  'MERCURY'

      N2CCOD(17) =   299
      N2CNAM(17) =  'VENUS'

      N2CCOD(18) =   399
      N2CNAM(18) =  'EARTH'

      N2CCOD(19) =   301
      N2CNAM(19) =  'MOON'

      N2CCOD(20) =   499
      N2CNAM(20) =  'MARS'

      N2CCOD(21) =   401
      N2CNAM(21) =  'PHOBOS'

      N2CCOD(22) =   402
      N2CNAM(22) =  'DEIMOS'

      N2CCOD(23) =   599
      N2CNAM(23) =  'JUPITER'

      N2CCOD(24) =   501
      N2CNAM(24) =  'IO'

      N2CCOD(25) =   502
      N2CNAM(25) =  'EUROPA'

      N2CCOD(26) =   503
      N2CNAM(26) =  'GANYMEDE'

      N2CCOD(27) =   504
      N2CNAM(27) =  'CALLISTO'

      N2CCOD(28) =   505
      N2CNAM(28) =  'AMALTHEA'

      N2CCOD(29) =   506
      N2CNAM(29) =  'HIMALIA'

      N2CCOD(30) =   507
      N2CNAM(30) =  'ELARA'

      N2CCOD(31) =   508
      N2CNAM(31) =  'PASIPHAE'

      N2CCOD(32) =   509
      N2CNAM(32) =  'SINOPE'

      N2CCOD(33) =   510
      N2CNAM(33) =  'LYSITHEA'

      N2CCOD(34) =   511
      N2CNAM(34) =  'CARME'

      N2CCOD(35) =   512
      N2CNAM(35) =  'ANANKE'

      N2CCOD(36) =   513
      N2CNAM(36) =  'LEDA'

      N2CCOD(37) =   514
      N2CNAM(37) =  '1979J2'

      N2CCOD(38) =   514
      N2CNAM(38) =  'THEBE'

      N2CCOD(39) =   515
      N2CNAM(39) =  '1979J1'

      N2CCOD(40) =   515
      N2CNAM(40) =  'ADRASTEA'

      N2CCOD(41) =   516
      N2CNAM(41) =  '1979J3'

      N2CCOD(42) =   516
      N2CNAM(42) =  'METIS'

      N2CCOD(43) =   517
      N2CNAM(43) =  'CALLIRRHOE'

      N2CCOD(44) =   518
      N2CNAM(44) =  'THEMISTO'

      N2CCOD(45) =   519
      N2CNAM(45) =  'MAGACLITE'

      N2CCOD(46) =   520
      N2CNAM(46) =  'TAYGETE'

      N2CCOD(47) =   521
      N2CNAM(47) =  'CHALDENE'

      N2CCOD(48) =   522
      N2CNAM(48) =  'HARPALYKE'

      N2CCOD(49) =   523
      N2CNAM(49) =  'KALYKE'

      N2CCOD(50) =   524
      N2CNAM(50) =  'IOCASTE'

      N2CCOD(51) =   525
      N2CNAM(51) =  'ERINOME'

      N2CCOD(52) =   526
      N2CNAM(52) =  'ISONOE'

      N2CCOD(53) =   527
      N2CNAM(53) =  'PRAXIDIKE'

      N2CCOD(54) =   528
      N2CNAM(54) =  'AUTONOE'

      N2CCOD(55) =   529
      N2CNAM(55) =  'THYONE'

      N2CCOD(56) =   530
      N2CNAM(56) =  'HERMIPPE'

      N2CCOD(57) =   531
      N2CNAM(57) =  'AITNE'

      N2CCOD(58) =   532
      N2CNAM(58) =  'EURYDOME'

      N2CCOD(59) =   533
      N2CNAM(59) =  'EUANTHE'

      N2CCOD(60) =   534
      N2CNAM(60) =  'EUPORIE'

      N2CCOD(61) =   535
      N2CNAM(61) =  'ORTHOSIE'

      N2CCOD(62) =   536
      N2CNAM(62) =  'SPONDE'

      N2CCOD(63) =   537
      N2CNAM(63) =  'KALE'

      N2CCOD(64) =   538
      N2CNAM(64) =  'PASITHEE'

      N2CCOD(65) =   699
      N2CNAM(65) =  'SATURN'

      N2CCOD(66) =   601
      N2CNAM(66) =  'MIMAS'

      N2CCOD(67) =   602
      N2CNAM(67) =  'ENCELADUS'

      N2CCOD(68) =   603
      N2CNAM(68) =  'TETHYS'

      N2CCOD(69) =   604
      N2CNAM(69) =  'DIONE'

      N2CCOD(70) =   605
      N2CNAM(70) =  'RHEA'

      N2CCOD(71) =   606
      N2CNAM(71) =  'TITAN'

      N2CCOD(72) =   607
      N2CNAM(72) =  'HYPERION'

      N2CCOD(73) =   608
      N2CNAM(73) =  'IAPETUS'

      N2CCOD(74) =   609
      N2CNAM(74) =  'PHOEBE'

      N2CCOD(75) =   610
      N2CNAM(75) =  '1980S1'

      N2CCOD(76) =   610
      N2CNAM(76) =  'JANUS'

      N2CCOD(77) =   611
      N2CNAM(77) =  '1980S3'

      N2CCOD(78) =   611
      N2CNAM(78) =  'EPIMETHEUS'

      N2CCOD(79) =   612
      N2CNAM(79) =  '1980S6'

      N2CCOD(80) =   612
      N2CNAM(80) =  'HELENE'

      N2CCOD(81) =   613
      N2CNAM(81) =  '1980S13'

      N2CCOD(82) =   613
      N2CNAM(82) =  'TELESTO'

      N2CCOD(83) =   614
      N2CNAM(83) =  '1980S25'

      N2CCOD(84) =   614
      N2CNAM(84) =  'CALYPSO'

      N2CCOD(85) =   615
      N2CNAM(85) =  '1980S28'

      N2CCOD(86) =   615
      N2CNAM(86) =  'ATLAS'

      N2CCOD(87) =   616
      N2CNAM(87) =  '1980S27'

      N2CCOD(88) =   616
      N2CNAM(88) =  'PROMETHEUS'

      N2CCOD(89) =   617
      N2CNAM(89) =  '1980S26'

      N2CCOD(90) =   617
      N2CNAM(90) =  'PANDORA'

      N2CCOD(91) =   618
      N2CNAM(91) =  'PAN'

      N2CCOD(92) =   619
      N2CNAM(92) =  'YMIR'

      N2CCOD(93) =   620
      N2CNAM(93) =  'PAALIAQ'

      N2CCOD(94) =   621
      N2CNAM(94) =  'TARVOS'

      N2CCOD(95) =   622
      N2CNAM(95) =  'IJIRAQ'

      N2CCOD(96) =   623
      N2CNAM(96) =  'SUTTUNG'

      N2CCOD(97) =   624
      N2CNAM(97) =  'KIVIUQ'

      N2CCOD(98) =   625
      N2CNAM(98) =  'MUNDILFARI'

      N2CCOD(99) =   626
      N2CNAM(99) =  'ALBIORIX'

      N2CCOD(100) =   627
      N2CNAM(100) =  'SKADI'

      N2CCOD(101) =   628
      N2CNAM(101) =  'ERRIAPO'

      N2CCOD(102) =   629
      N2CNAM(102) =  'SIARNAQ'

      N2CCOD(103) =   630
      N2CNAM(103) =  'THRYM'

      N2CCOD(104) =   799
      N2CNAM(104) =  'URANUS'

      N2CCOD(105) =   701
      N2CNAM(105) =  'ARIEL'

      N2CCOD(106) =   702
      N2CNAM(106) =  'UMBRIEL'

      N2CCOD(107) =   703
      N2CNAM(107) =  'TITANIA'

      N2CCOD(108) =   704
      N2CNAM(108) =  'OBERON'

      N2CCOD(109) =   705
      N2CNAM(109) =  'MIRANDA'

      N2CCOD(110) =   706
      N2CNAM(110) =  '1986U7'

      N2CCOD(111) =   706
      N2CNAM(111) =  'CORDELIA'

      N2CCOD(112) =   707
      N2CNAM(112) =  '1986U8'

      N2CCOD(113) =   707
      N2CNAM(113) =  'OPHELIA'

      N2CCOD(114) =   708
      N2CNAM(114) =  '1986U9'

      N2CCOD(115) =   708
      N2CNAM(115) =  'BIANCA'

      N2CCOD(116) =   709
      N2CNAM(116) =  '1986U4'

      N2CCOD(117) =   709
      N2CNAM(117) =  'CRESSIDA'

      N2CCOD(118) =   710
      N2CNAM(118) =  '1986U6'

      N2CCOD(119) =   710
      N2CNAM(119) =  'DESDEMONA'

      N2CCOD(120) =   711
      N2CNAM(120) =  '1986U3'

      N2CCOD(121) =   711
      N2CNAM(121) =  'JULIET'

      N2CCOD(122) =   712
      N2CNAM(122) =  '1986U1'

      N2CCOD(123) =   712
      N2CNAM(123) =  'PORTIA'

      N2CCOD(124) =   713
      N2CNAM(124) =  '1986U2'

      N2CCOD(125) =   713
      N2CNAM(125) =  'ROSALIND'

      N2CCOD(126) =   714
      N2CNAM(126) =  '1986U5'

      N2CCOD(127) =   714
      N2CNAM(127) =  'BELINDA'

      N2CCOD(128) =   715
      N2CNAM(128) =  '1985U1'

      N2CCOD(129) =   715
      N2CNAM(129) =  'PUCK'

      N2CCOD(130) =   716
      N2CNAM(130) =  'CALIBAN'

      N2CCOD(131) =   717
      N2CNAM(131) =  'SYCORAX'

      N2CCOD(132) =   718
      N2CNAM(132) =  '1986U10'

      N2CCOD(133) =   718
      N2CNAM(133) =  'PROSPERO'

      N2CCOD(134) =   719
      N2CNAM(134) =  'SETEBOS'

      N2CCOD(135) =   720
      N2CNAM(135) =  'STEPHANO'

      N2CCOD(136) =   721
      N2CNAM(136) =  'TRINCULO'

      N2CCOD(137) =   899
      N2CNAM(137) =  'NEPTUNE'

      N2CCOD(138) =   801
      N2CNAM(138) =  'TRITON'

      N2CCOD(139) =   802
      N2CNAM(139) =  'NEREID'

      N2CCOD(140) =   803
      N2CNAM(140) =  'NAIAD'

      N2CCOD(141) =   804
      N2CNAM(141) =  'THALASSA'

      N2CCOD(142) =   805
      N2CNAM(142) =  'DESPINA'

      N2CCOD(143) =   806
      N2CNAM(143) =  'GALATEA'

      N2CCOD(144) =   807
      N2CNAM(144) =  'LARISSA'

      N2CCOD(145) =   808
      N2CNAM(145) =  'PROTEUS'

      N2CCOD(146) =   999
      N2CNAM(146) =  'PLUTO'

      N2CCOD(147) =   901
      N2CNAM(147) =  '1978P1'

      N2CCOD(148) =   901
      N2CNAM(148) =  'CHARON'

      N2CCOD(149) =   -1
      N2CNAM(149) =  'GEOTAIL'

      N2CCOD(150) =   -6
      N2CNAM(150) =  'P6'

      N2CCOD(151) =   -6
      N2CNAM(151) =  'PIONEER-6'

      N2CCOD(152) =   -7
      N2CNAM(152) =  'P7'

      N2CCOD(153) =   -7
      N2CNAM(153) =  'PIONEER-7'

      N2CCOD(154) =   -8
      N2CNAM(154) =  'WIND'

      N2CCOD(155) =   -12
      N2CNAM(155) =  'VENUS ORBITER'

      N2CCOD(156) =   -12
      N2CNAM(156) =  'P12'

      N2CCOD(157) =   -12
      N2CNAM(157) =  'PIONEER 12'

      N2CCOD(158) =   -13
      N2CNAM(158) =  'POLAR'

      N2CCOD(159) =   -18
      N2CNAM(159) =  'MGN'

      N2CCOD(160) =   -18
      N2CNAM(160) =  'MAGELLAN'

      N2CCOD(161) =   -20
      N2CNAM(161) =  'P8'

      N2CCOD(162) =   -20
      N2CNAM(162) =  'PIONEER-8'

      N2CCOD(163) =   -21
      N2CNAM(163) =  'SOHO'

      N2CCOD(164) =   -23
      N2CNAM(164) =  'P10'

      N2CCOD(165) =   -23
      N2CNAM(165) =  'PIONEER-10'

      N2CCOD(166) =   -24
      N2CNAM(166) =  'P11'

      N2CCOD(167) =   -24
      N2CNAM(167) =  'PIONEER-11'

      N2CCOD(168) =   -25
      N2CNAM(168) =  'LP'

      N2CCOD(169) =   -25
      N2CNAM(169) =  'LUNAR PROSPECTOR'

      N2CCOD(170) =   -27
      N2CNAM(170) =  'VK1'

      N2CCOD(171) =   -27
      N2CNAM(171) =  'VIKING 1 ORBITER'

      N2CCOD(172) =   -29
      N2CNAM(172) =  'STARDUST'

      N2CCOD(173) =   -29
      N2CNAM(173) =  'SDU'

      N2CCOD(174) =   -30
      N2CNAM(174) =  'VK2'

      N2CCOD(175) =   -30
      N2CNAM(175) =  'VIKING 2 ORBITER'

      N2CCOD(176) =   -30
      N2CNAM(176) =  'DS-1'

      N2CCOD(177) =   -31
      N2CNAM(177) =  'VG1'

      N2CCOD(178) =   -31
      N2CNAM(178) =  'VOYAGER 1'

      N2CCOD(179) =   -32
      N2CNAM(179) =  'VG2'

      N2CCOD(180) =   -32
      N2CNAM(180) =  'VOYAGER 2'

      N2CCOD(181) =   -40
      N2CNAM(181) =  'CLEMENTINE'

      N2CCOD(182) =   -41
      N2CNAM(182) =  'MEX'

      N2CCOD(183) =   -41
      N2CNAM(183) =  'MARS EXPRESS'

      N2CCOD(184) =   -44
      N2CNAM(184) =  'BEAGLE2'

      N2CCOD(185) =   -44
      N2CNAM(185) =  'BEAGLE 2'

      N2CCOD(186) =   -46
      N2CNAM(186) =  'MS-T5'

      N2CCOD(187) =   -46
      N2CNAM(187) =  'SAKIGAKE'

      N2CCOD(188) =   -47
      N2CNAM(188) =  'PLANET-A'

      N2CCOD(189) =   -47
      N2CNAM(189) =  'SUISEI'

      N2CCOD(190) =   -47
      N2CNAM(190) =  'GNS'

      N2CCOD(191) =   -47
      N2CNAM(191) =  'GENESIS'

      N2CCOD(192) =   -48
      N2CNAM(192) =  'HUBBLE SPACE TELESCOPE'

      N2CCOD(193) =   -48
      N2CNAM(193) =  'HST'

      N2CCOD(194) =   -53
      N2CNAM(194) =  'MARS PATHFINDER'

      N2CCOD(195) =   -53
      N2CNAM(195) =  'MPF'

      N2CCOD(196) =   -53
      N2CNAM(196) =  'MARS ODYSSEY'

      N2CCOD(197) =   -53
      N2CNAM(197) =  'MARS SURVEYOR 01 ORBITER'

      N2CCOD(198) =   -55
      N2CNAM(198) =  'ULYSSES'

      N2CCOD(199) =   -58
      N2CNAM(199) =  'VSOP'

      N2CCOD(200) =   -58
      N2CNAM(200) =  'HALCA'

      N2CCOD(201) =   -59
      N2CNAM(201) =  'RADIOASTRON'

      N2CCOD(202) =   -66
      N2CNAM(202) =  'VEGA 1'

      N2CCOD(203) =   -67
      N2CNAM(203) =  'VEGA 2'

      N2CCOD(204) =   -70
      N2CNAM(204) =  'DEEP IMPACT IMPACTOR SPACECRAFT'

      N2CCOD(205) =   -74
      N2CNAM(205) =  'MRO'

      N2CCOD(206) =   -74
      N2CNAM(206) =  'MARS RECON ORBITER'

      N2CCOD(207) =   -77
      N2CNAM(207) =  'GLL'

      N2CCOD(208) =   -77
      N2CNAM(208) =  'GALILEO ORBITER'

      N2CCOD(209) =   -78
      N2CNAM(209) =  'GIOTTO'

      N2CCOD(210) =   -79
      N2CNAM(210) =  'SPITZER'

      N2CCOD(211) =   -79
      N2CNAM(211) =  'SPACE INFRARED TELESCOPE FACILITY'

      N2CCOD(212) =   -79
      N2CNAM(212) =  'SIRTF'

      N2CCOD(213) =   -81
      N2CNAM(213) =  'CASSINI ITL'

      N2CCOD(214) =   -82
      N2CNAM(214) =  'CAS'

      N2CCOD(215) =   -82
      N2CNAM(215) =  'CASSINI'

      N2CCOD(216) =   -84
      N2CNAM(216) =  'PHOENIX'

      N2CCOD(217) =   -90
      N2CNAM(217) =  'CASSINI SIMULATION'

      N2CCOD(218) =   -93
      N2CNAM(218) =  'NEAR EARTH ASTEROID RENDEZVOUS'

      N2CCOD(219) =   -93
      N2CNAM(219) =  'NEAR'

      N2CCOD(220) =   -94
      N2CNAM(220) =  'MO'

      N2CCOD(221) =   -94
      N2CNAM(221) =  'MARS OBSERVER'

      N2CCOD(222) =   -94
      N2CNAM(222) =  'MGS'

      N2CCOD(223) =   -94
      N2CNAM(223) =  'MARS GLOBAL SURVEYOR'

      N2CCOD(224) =   -95
      N2CNAM(224) =  'MGS SIMULATION'

      N2CCOD(225) =   -97
      N2CNAM(225) =  'TOPEX/POSEIDON'

      N2CCOD(226) =   -107
      N2CNAM(226) =  'TROPICAL RAINFALL MEASURING MISSION'

      N2CCOD(227) =   -107
      N2CNAM(227) =  'TRMM'

      N2CCOD(228) =   -112
      N2CNAM(228) =  'ICE'

      N2CCOD(229) =   -116
      N2CNAM(229) =  'MARS POLAR LANDER'

      N2CCOD(230) =   -116
      N2CNAM(230) =  'MPL'

      N2CCOD(231) =   -127
      N2CNAM(231) =  'MARS CLIMATE ORBITER'

      N2CCOD(232) =   -127
      N2CNAM(232) =  'MCO'

      N2CCOD(233) =   -130
      N2CNAM(233) =  'MUSES-C'

      N2CCOD(234) =   -130
      N2CNAM(234) =  'HAYABUSA'

      N2CCOD(235) =   -131
      N2CNAM(235) =  'SELENE'

      N2CCOD(236) =   -135
      N2CNAM(236) =  'DRTS-W'

      N2CCOD(237) =   -140
      N2CNAM(237) =  'DEEP IMPACT FLYBY SPACECRAFT'

      N2CCOD(238) =   -142
      N2CNAM(238) =  'TERRA'

      N2CCOD(239) =   -142
      N2CNAM(239) =  'EOS-AM1'

      N2CCOD(240) =   -146
      N2CNAM(240) =  'LUNAR-A'

      N2CCOD(241) =   -150
      N2CNAM(241) =  'CASSINI PROBE'

      N2CCOD(242) =   -150
      N2CNAM(242) =  'HUYGENS PROBE'

      N2CCOD(243) =   -150
      N2CNAM(243) =  'CASP'

      N2CCOD(244) =   -151
      N2CNAM(244) =  'AXAF'

      N2CCOD(245) =   -154
      N2CNAM(245) =  'AQUA'

      N2CCOD(246) =   -159
      N2CNAM(246) =  'EUROPA ORBITER'

      N2CCOD(247) =   -164
      N2CNAM(247) =  'YOHKOH'

      N2CCOD(248) =   -164
      N2CNAM(248) =  'SOLAR-A'

      N2CCOD(249) =   -165
      N2CNAM(249) =  'MAP'

      N2CCOD(250) =   -166
      N2CNAM(250) =  'IMAGE'

      N2CCOD(251) =   -172
      N2CNAM(251) =  'SPACETECH-3 COMBINER'

      N2CCOD(252) =   -174
      N2CNAM(252) =  'PLUTO-KUIPER EXPRESS'

      N2CCOD(253) =   -175
      N2CNAM(253) =  'PLUTO-KUIPER EXPRESS SIMULATION'

      N2CCOD(254) =   -178
      N2CNAM(254) =  'PLANET-B'

      N2CCOD(255) =   -178
      N2CNAM(255) =  'NOZOMI'

      N2CCOD(256) =   -183
      N2CNAM(256) =  'CLUSTER 1'

      N2CCOD(257) =   -185
      N2CNAM(257) =  'CLUSTER 2'

      N2CCOD(258) =   -188
      N2CNAM(258) =  'MUSES-B'

      N2CCOD(259) =   -190
      N2CNAM(259) =  'SIM'

      N2CCOD(260) =   -194
      N2CNAM(260) =  'CLUSTER 3'

      N2CCOD(261) =   -196
      N2CNAM(261) =  'CLUSTER 4'

      N2CCOD(262) =   -198
      N2CNAM(262) =  'INTEGRAL'

      N2CCOD(263) =   -200
      N2CNAM(263) =  'CONTOUR'

      N2CCOD(264) =   -203
      N2CNAM(264) =  'DAWN'

      N2CCOD(265) =   -205
      N2CNAM(265) =  'SPACETECH-3 COLLECTOR'

      N2CCOD(266) =   -226
      N2CNAM(266) =  'ROSETTA'

      N2CCOD(267) =   -227
      N2CNAM(267) =  'KEPLER'

      N2CCOD(268) =   -228
      N2CNAM(268) =  'GLL PROBE'

      N2CCOD(269) =   -228
      N2CNAM(269) =  'GALILEO PROBE'

      N2CCOD(270) =   -234
      N2CNAM(270) =  'STEREO AHEAD'

      N2CCOD(271) =   -235
      N2CNAM(271) =  'STEREO BEHIND'

      N2CCOD(272) =   -236
      N2CNAM(272) =  'MESSENGER'

      N2CCOD(273) =   -238
      N2CNAM(273) =  'SMART1'

      N2CCOD(274) =   -238
      N2CNAM(274) =  'SM1'

      N2CCOD(275) =   -238
      N2CNAM(275) =  'S1'

      N2CCOD(276) =   -238
      N2CNAM(276) =  'SMART-1'

      N2CCOD(277) =   -253
      N2CNAM(277) =  'OPPORTUNITY'

      N2CCOD(278) =   -253
      N2CNAM(278) =  'MER-1'

      N2CCOD(279) =   -254
      N2CNAM(279) =  'SPIRIT'

      N2CCOD(280) =   -254
      N2CNAM(280) =  'MER-2'

      N2CCOD(281) =   -486
      N2CNAM(281) =  'HERSCHEL'

      N2CCOD(282) =   -489
      N2CNAM(282) =  'PLANCK'

      N2CCOD(283) =   -550
      N2CNAM(283) =  'MARS-96'

      N2CCOD(284) =   -550
      N2CNAM(284) =  'M96'

      N2CCOD(285) =   -550
      N2CNAM(285) =  'MARS 96'

      N2CCOD(286) =   -550
      N2CNAM(286) =  'MARS96'

      N2CCOD(287) =   50000001
      N2CNAM(287) =  'SHOEMAKER-LEVY 9-W'

      N2CCOD(288) =   50000002
      N2CNAM(288) =  'SHOEMAKER-LEVY 9-V'

      N2CCOD(289) =   50000003
      N2CNAM(289) =  'SHOEMAKER-LEVY 9-U'

      N2CCOD(290) =   50000004
      N2CNAM(290) =  'SHOEMAKER-LEVY 9-T'

      N2CCOD(291) =   50000005
      N2CNAM(291) =  'SHOEMAKER-LEVY 9-S'

      N2CCOD(292) =   50000006
      N2CNAM(292) =  'SHOEMAKER-LEVY 9-R'

      N2CCOD(293) =   50000007
      N2CNAM(293) =  'SHOEMAKER-LEVY 9-Q'

      N2CCOD(294) =   50000008
      N2CNAM(294) =  'SHOEMAKER-LEVY 9-P'

      N2CCOD(295) =   50000009
      N2CNAM(295) =  'SHOEMAKER-LEVY 9-N'

      N2CCOD(296) =   50000010
      N2CNAM(296) =  'SHOEMAKER-LEVY 9-M'

      N2CCOD(297) =   50000011
      N2CNAM(297) =  'SHOEMAKER-LEVY 9-L'

      N2CCOD(298) =   50000012
      N2CNAM(298) =  'SHOEMAKER-LEVY 9-K'

      N2CCOD(299) =   50000013
      N2CNAM(299) =  'SHOEMAKER-LEVY 9-J'

      N2CCOD(300) =   50000014
      N2CNAM(300) =  'SHOEMAKER-LEVY 9-H'

      N2CCOD(301) =   50000015
      N2CNAM(301) =  'SHOEMAKER-LEVY 9-G'

      N2CCOD(302) =   50000016
      N2CNAM(302) =  'SHOEMAKER-LEVY 9-F'

      N2CCOD(303) =   50000017
      N2CNAM(303) =  'SHOEMAKER-LEVY 9-E'

      N2CCOD(304) =   50000018
      N2CNAM(304) =  'SHOEMAKER-LEVY 9-D'

      N2CCOD(305) =   50000019
      N2CNAM(305) =  'SHOEMAKER-LEVY 9-C'

      N2CCOD(306) =   50000020
      N2CNAM(306) =  'SHOEMAKER-LEVY 9-B'

      N2CCOD(307) =   50000021
      N2CNAM(307) =  'SHOEMAKER-LEVY 9-A'

      N2CCOD(308) =   50000022
      N2CNAM(308) =  'SHOEMAKER-LEVY 9-Q1'

      N2CCOD(309) =   50000023
      N2CNAM(309) =  'SHOEMAKER-LEVY 9-P2'

      N2CCOD(310) =   1000001
      N2CNAM(310) =  'AREND'

      N2CCOD(311) =   1000002
      N2CNAM(311) =  'AREND-RIGAUX'

      N2CCOD(312) =   1000003
      N2CNAM(312) =  'ASHBROOK-JACKSON'

      N2CCOD(313) =   1000004
      N2CNAM(313) =  'BOETHIN'

      N2CCOD(314) =   1000005
      N2CNAM(314) =  'BORRELLY'

      N2CCOD(315) =   1000006
      N2CNAM(315) =  'BOWELL-SKIFF'

      N2CCOD(316) =   1000007
      N2CNAM(316) =  'BRADFIELD'

      N2CCOD(317) =   1000008
      N2CNAM(317) =  'BROOKS 2'

      N2CCOD(318) =   1000009
      N2CNAM(318) =  'BRORSEN-METCALF'

      N2CCOD(319) =   1000010
      N2CNAM(319) =  'BUS'

      N2CCOD(320) =   1000011
      N2CNAM(320) =  'CHERNYKH'

      N2CCOD(321) =   1000012
      N2CNAM(321) =  '67P/CHURYUMOV-GERASIMENKO (1969 R1)'

      N2CCOD(322) =   1000012
      N2CNAM(322) =  'CHURYUMOV-GERASIMENKO'

      N2CCOD(323) =   1000013
      N2CNAM(323) =  'CIFFREO'

      N2CCOD(324) =   1000014
      N2CNAM(324) =  'CLARK'

      N2CCOD(325) =   1000015
      N2CNAM(325) =  'COMAS SOLA'

      N2CCOD(326) =   1000016
      N2CNAM(326) =  'CROMMELIN'

      N2CCOD(327) =   1000017
      N2CNAM(327) =  'D''ARREST'

      N2CCOD(328) =   1000018
      N2CNAM(328) =  'DANIEL'

      N2CCOD(329) =   1000019
      N2CNAM(329) =  'DE VICO-SWIFT'

      N2CCOD(330) =   1000020
      N2CNAM(330) =  'DENNING-FUJIKAWA'

      N2CCOD(331) =   1000021
      N2CNAM(331) =  'DU TOIT 1'

      N2CCOD(332) =   1000022
      N2CNAM(332) =  'DU TOIT-HARTLEY'

      N2CCOD(333) =   1000023
      N2CNAM(333) =  'DUTOIT-NEUJMIN-DELPORTE'

      N2CCOD(334) =   1000024
      N2CNAM(334) =  'DUBIAGO'

      N2CCOD(335) =   1000025
      N2CNAM(335) =  'ENCKE'

      N2CCOD(336) =   1000026
      N2CNAM(336) =  'FAYE'

      N2CCOD(337) =   1000027
      N2CNAM(337) =  'FINLAY'

      N2CCOD(338) =   1000028
      N2CNAM(338) =  'FORBES'

      N2CCOD(339) =   1000029
      N2CNAM(339) =  'GEHRELS 1'

      N2CCOD(340) =   1000030
      N2CNAM(340) =  'GEHRELS 2'

      N2CCOD(341) =   1000031
      N2CNAM(341) =  'GEHRELS 3'

      N2CCOD(342) =   1000032
      N2CNAM(342) =  'GIACOBINI-ZINNER'

      N2CCOD(343) =   1000033
      N2CNAM(343) =  'GICLAS'

      N2CCOD(344) =   1000034
      N2CNAM(344) =  'GRIGG-SKJELLERUP'

      N2CCOD(345) =   1000035
      N2CNAM(345) =  'GUNN'

      N2CCOD(346) =   1000036
      N2CNAM(346) =  'HALLEY'

      N2CCOD(347) =   1000037
      N2CNAM(347) =  'HANEDA-CAMPOS'

      N2CCOD(348) =   1000038
      N2CNAM(348) =  'HARRINGTON'

      N2CCOD(349) =   1000039
      N2CNAM(349) =  'HARRINGTON-ABELL'

      N2CCOD(350) =   1000040
      N2CNAM(350) =  'HARTLEY 1'

      N2CCOD(351) =   1000041
      N2CNAM(351) =  'HARTLEY 2'

      N2CCOD(352) =   1000042
      N2CNAM(352) =  'HARTLEY-IRAS'

      N2CCOD(353) =   1000043
      N2CNAM(353) =  'HERSCHEL-RIGOLLET'

      N2CCOD(354) =   1000044
      N2CNAM(354) =  'HOLMES'

      N2CCOD(355) =   1000045
      N2CNAM(355) =  'HONDA-MRKOS-PAJDUSAKOVA'

      N2CCOD(356) =   1000046
      N2CNAM(356) =  'HOWELL'

      N2CCOD(357) =   1000047
      N2CNAM(357) =  'IRAS'

      N2CCOD(358) =   1000048
      N2CNAM(358) =  'JACKSON-NEUJMIN'

      N2CCOD(359) =   1000049
      N2CNAM(359) =  'JOHNSON'

      N2CCOD(360) =   1000050
      N2CNAM(360) =  'KEARNS-KWEE'

      N2CCOD(361) =   1000051
      N2CNAM(361) =  'KLEMOLA'

      N2CCOD(362) =   1000052
      N2CNAM(362) =  'KOHOUTEK'

      N2CCOD(363) =   1000053
      N2CNAM(363) =  'KOJIMA'

      N2CCOD(364) =   1000054
      N2CNAM(364) =  'KOPFF'

      N2CCOD(365) =   1000055
      N2CNAM(365) =  'KOWAL 1'

      N2CCOD(366) =   1000056
      N2CNAM(366) =  'KOWAL 2'

      N2CCOD(367) =   1000057
      N2CNAM(367) =  'KOWAL-MRKOS'

      N2CCOD(368) =   1000058
      N2CNAM(368) =  'KOWAL-VAVROVA'

      N2CCOD(369) =   1000059
      N2CNAM(369) =  'LONGMORE'

      N2CCOD(370) =   1000060
      N2CNAM(370) =  'LOVAS 1'

      N2CCOD(371) =   1000061
      N2CNAM(371) =  'MACHHOLZ'

      N2CCOD(372) =   1000062
      N2CNAM(372) =  'MAURY'

      N2CCOD(373) =   1000063
      N2CNAM(373) =  'NEUJMIN 1'

      N2CCOD(374) =   1000064
      N2CNAM(374) =  'NEUJMIN 2'

      N2CCOD(375) =   1000065
      N2CNAM(375) =  'NEUJMIN 3'

      N2CCOD(376) =   1000066
      N2CNAM(376) =  'OLBERS'

      N2CCOD(377) =   1000067
      N2CNAM(377) =  'PETERS-HARTLEY'

      N2CCOD(378) =   1000068
      N2CNAM(378) =  'PONS-BROOKS'

      N2CCOD(379) =   1000069
      N2CNAM(379) =  'PONS-WINNECKE'

      N2CCOD(380) =   1000070
      N2CNAM(380) =  'REINMUTH 1'

      N2CCOD(381) =   1000071
      N2CNAM(381) =  'REINMUTH 2'

      N2CCOD(382) =   1000072
      N2CNAM(382) =  'RUSSELL 1'

      N2CCOD(383) =   1000073
      N2CNAM(383) =  'RUSSELL 2'

      N2CCOD(384) =   1000074
      N2CNAM(384) =  'RUSSELL 3'

      N2CCOD(385) =   1000075
      N2CNAM(385) =  'RUSSELL 4'

      N2CCOD(386) =   1000076
      N2CNAM(386) =  'SANGUIN'

      N2CCOD(387) =   1000077
      N2CNAM(387) =  'SCHAUMASSE'

      N2CCOD(388) =   1000078
      N2CNAM(388) =  'SCHUSTER'

      N2CCOD(389) =   1000079
      N2CNAM(389) =  'SCHWASSMANN-WACHMANN 1'

      N2CCOD(390) =   1000080
      N2CNAM(390) =  'SCHWASSMANN-WACHMANN 2'

      N2CCOD(391) =   1000081
      N2CNAM(391) =  'SCHWASSMANN-WACHMANN 3'

      N2CCOD(392) =   1000082
      N2CNAM(392) =  'SHAJN-SCHALDACH'

      N2CCOD(393) =   1000083
      N2CNAM(393) =  'SHOEMAKER 1'

      N2CCOD(394) =   1000084
      N2CNAM(394) =  'SHOEMAKER 2'

      N2CCOD(395) =   1000085
      N2CNAM(395) =  'SHOEMAKER 3'

      N2CCOD(396) =   1000086
      N2CNAM(396) =  'SINGER-BREWSTER'

      N2CCOD(397) =   1000087
      N2CNAM(397) =  'SLAUGHTER-BURNHAM'

      N2CCOD(398) =   1000088
      N2CNAM(398) =  'SMIRNOVA-CHERNYKH'

      N2CCOD(399) =   1000089
      N2CNAM(399) =  'STEPHAN-OTERMA'

      N2CCOD(400) =   1000090
      N2CNAM(400) =  'SWIFT-GEHRELS'

      N2CCOD(401) =   1000091
      N2CNAM(401) =  'TAKAMIZAWA'

      N2CCOD(402) =   1000092
      N2CNAM(402) =  'TAYLOR'

      N2CCOD(403) =   1000093
      N2CNAM(403) =  'TEMPEL 1'

      N2CCOD(404) =   1000094
      N2CNAM(404) =  'TEMPEL 2'

      N2CCOD(405) =   1000095
      N2CNAM(405) =  'TEMPEL-TUTTLE'

      N2CCOD(406) =   1000096
      N2CNAM(406) =  'TRITTON'

      N2CCOD(407) =   1000097
      N2CNAM(407) =  'TSUCHINSHAN 1'

      N2CCOD(408) =   1000098
      N2CNAM(408) =  'TSUCHINSHAN 2'

      N2CCOD(409) =   1000099
      N2CNAM(409) =  'TUTTLE'

      N2CCOD(410) =   1000100
      N2CNAM(410) =  'TUTTLE-GIACOBINI-KRESAK'

      N2CCOD(411) =   1000101
      N2CNAM(411) =  'VAISALA 1'

      N2CCOD(412) =   1000102
      N2CNAM(412) =  'VAN BIESBROECK'

      N2CCOD(413) =   1000103
      N2CNAM(413) =  'VAN HOUTEN'

      N2CCOD(414) =   1000104
      N2CNAM(414) =  'WEST-KOHOUTEK-IKEMURA'

      N2CCOD(415) =   1000105
      N2CNAM(415) =  'WHIPPLE'

      N2CCOD(416) =   1000106
      N2CNAM(416) =  'WILD 1'

      N2CCOD(417) =   1000107
      N2CNAM(417) =  'WILD 2'

      N2CCOD(418) =   1000108
      N2CNAM(418) =  'WILD 3'

      N2CCOD(419) =   1000109
      N2CNAM(419) =  'WIRTANEN'

      N2CCOD(420) =   1000110
      N2CNAM(420) =  'WOLF'

      N2CCOD(421) =   1000111
      N2CNAM(421) =  'WOLF-HARRINGTON'

      N2CCOD(422) =   1000112
      N2CNAM(422) =  'LOVAS 2'

      N2CCOD(423) =   1000113
      N2CNAM(423) =  'URATA-NIIJIMA'

      N2CCOD(424) =   1000114
      N2CNAM(424) =  'WISEMAN-SKIFF'

      N2CCOD(425) =   1000115
      N2CNAM(425) =  'HELIN'

      N2CCOD(426) =   1000116
      N2CNAM(426) =  'MUELLER'

      N2CCOD(427) =   1000117
      N2CNAM(427) =  'SHOEMAKER-HOLT 1'

      N2CCOD(428) =   1000118
      N2CNAM(428) =  'HELIN-ROMAN-CROCKETT'

      N2CCOD(429) =   1000119
      N2CNAM(429) =  'HARTLEY 3'

      N2CCOD(430) =   1000120
      N2CNAM(430) =  'PARKER-HARTLEY'

      N2CCOD(431) =   1000121
      N2CNAM(431) =  'HELIN-ROMAN-ALU 1'

      N2CCOD(432) =   1000122
      N2CNAM(432) =  'WILD 4'

      N2CCOD(433) =   1000123
      N2CNAM(433) =  'MUELLER 2'

      N2CCOD(434) =   1000124
      N2CNAM(434) =  'MUELLER 3'

      N2CCOD(435) =   1000125
      N2CNAM(435) =  'SHOEMAKER-LEVY 1'

      N2CCOD(436) =   1000126
      N2CNAM(436) =  'SHOEMAKER-LEVY 2'

      N2CCOD(437) =   1000127
      N2CNAM(437) =  'HOLT-OLMSTEAD'

      N2CCOD(438) =   1000128
      N2CNAM(438) =  'METCALF-BREWINGTON'

      N2CCOD(439) =   1000129
      N2CNAM(439) =  'LEVY'

      N2CCOD(440) =   1000130
      N2CNAM(440) =  'SHOEMAKER-LEVY 9'

      N2CCOD(441) =   1000131
      N2CNAM(441) =  'HYAKUTAKE'

      N2CCOD(442) =   1000132
      N2CNAM(442) =  'HALE-BOPP'

      N2CCOD(443) =   9511010
      N2CNAM(443) =  'GASPRA'

      N2CCOD(444) =   2431010
      N2CNAM(444) =  'IDA'

      N2CCOD(445) =   2431011
      N2CNAM(445) =  'DACTYL'

      N2CCOD(446) =   2000001
      N2CNAM(446) =  'CERES'

      N2CCOD(447) =   2000004
      N2CNAM(447) =  'VESTA'

      N2CCOD(448) =   2000216
      N2CNAM(448) =  'KLEOPATRA'

      N2CCOD(449) =   2000433
      N2CNAM(449) =  'EROS'

      N2CCOD(450) =   2000253
      N2CNAM(450) =  'MATHILDE'

      N2CCOD(451) =   2009969
      N2CNAM(451) =  '1992KD'

      N2CCOD(452) =   2009969
      N2CNAM(452) =  'BRAILLE'

      N2CCOD(453) =   2004015
      N2CNAM(453) =  'WILSON-HARRINGTON'

      N2CCOD(454) =   398989
      N2CNAM(454) =  'NOTO'

      N2CCOD(455) =   398990
      N2CNAM(455) =  'NEW NORCIA'

      N2CCOD(456) =   399001
      N2CNAM(456) =  'GOLDSTONE'

      N2CCOD(457) =   399002
      N2CNAM(457) =  'CANBERRA'

      N2CCOD(458) =   399003
      N2CNAM(458) =  'MADRID'

      N2CCOD(459) =   399004
      N2CNAM(459) =  'USUDA'

      N2CCOD(460) =   399005
      N2CNAM(460) =  'DSS-05'

      N2CCOD(461) =   399005
      N2CNAM(461) =  'PARKES'

      N2CCOD(462) =   399012
      N2CNAM(462) =  'DSS-12'

      N2CCOD(463) =   399013
      N2CNAM(463) =  'DSS-13'

      N2CCOD(464) =   399014
      N2CNAM(464) =  'DSS-14'

      N2CCOD(465) =   399015
      N2CNAM(465) =  'DSS-15'

      N2CCOD(466) =   399016
      N2CNAM(466) =  'DSS-16'

      N2CCOD(467) =   399017
      N2CNAM(467) =  'DSS-17'

      N2CCOD(468) =   399023
      N2CNAM(468) =  'DSS-23'

      N2CCOD(469) =   399024
      N2CNAM(469) =  'DSS-24'

      N2CCOD(470) =   399025
      N2CNAM(470) =  'DSS-25'

      N2CCOD(471) =   399026
      N2CNAM(471) =  'DSS-26'

      N2CCOD(472) =   399027
      N2CNAM(472) =  'DSS-27'

      N2CCOD(473) =   399028
      N2CNAM(473) =  'DSS-28'

      N2CCOD(474) =   399033
      N2CNAM(474) =  'DSS-33'

      N2CCOD(475) =   399034
      N2CNAM(475) =  'DSS-34'

      N2CCOD(476) =   399042
      N2CNAM(476) =  'DSS-42'

      N2CCOD(477) =   399043
      N2CNAM(477) =  'DSS-43'

      N2CCOD(478) =   399045
      N2CNAM(478) =  'DSS-45'

      N2CCOD(479) =   399046
      N2CNAM(479) =  'DSS-46'

      N2CCOD(480) =   399049
      N2CNAM(480) =  'DSS-49'

      N2CCOD(481) =   399053
      N2CNAM(481) =  'DSS-53'

      N2CCOD(482) =   399054
      N2CNAM(482) =  'DSS-54'

      N2CCOD(483) =   399055
      N2CNAM(483) =  'DSS-55'

      N2CCOD(484) =   399061
      N2CNAM(484) =  'DSS-61'

      N2CCOD(485) =   399063
      N2CNAM(485) =  'DSS-63'

      N2CCOD(486) =   399065
      N2CNAM(486) =  'DSS-65'

      N2CCOD(487) =   399066
      N2CNAM(487) =  'DSS-66'



C
C     The data list for the ID -> NAME tests.
C     One-to-one and on-to.
C

      C2NCOD(1) =   -1
      C2NNAM(1) =  'GEOTAIL'

      C2NCOD(2) =   -107
      C2NNAM(2) =  'TRMM'

      C2NCOD(3) =   -112
      C2NNAM(3) =  'ICE'

      C2NCOD(4) =   -116
      C2NNAM(4) =  'MPL'

      C2NCOD(5) =   -12
      C2NNAM(5) =  'PIONEER 12'

      C2NCOD(6) =   -127
      C2NNAM(6) =  'MCO'

      C2NCOD(7) =   -13
      C2NNAM(7) =  'POLAR'

      C2NCOD(8) =   -130
      C2NNAM(8) =  'HAYABUSA'

      C2NCOD(9) =   -131
      C2NNAM(9) =  'SELENE'

      C2NCOD(10) =   -135
      C2NNAM(10) =  'DRTS-W'

      C2NCOD(11) =   -140
      C2NNAM(11) =  'DEEP IMPACT FLYBY SPACECRAFT'

      C2NCOD(12) =   -142
      C2NNAM(12) =  'EOS-AM1'

      C2NCOD(13) =   -146
      C2NNAM(13) =  'LUNAR-A'

      C2NCOD(14) =   -150
      C2NNAM(14) =  'CASP'

      C2NCOD(15) =   -151
      C2NNAM(15) =  'AXAF'

      C2NCOD(16) =   -154
      C2NNAM(16) =  'AQUA'

      C2NCOD(17) =   -159
      C2NNAM(17) =  'EUROPA ORBITER'

      C2NCOD(18) =   -164
      C2NNAM(18) =  'SOLAR-A'

      C2NCOD(19) =   -165
      C2NNAM(19) =  'MAP'

      C2NCOD(20) =   -166
      C2NNAM(20) =  'IMAGE'

      C2NCOD(21) =   -172
      C2NNAM(21) =  'SPACETECH-3 COMBINER'

      C2NCOD(22) =   -174
      C2NNAM(22) =  'PLUTO-KUIPER EXPRESS'

      C2NCOD(23) =   -175
      C2NNAM(23) =  'PLUTO-KUIPER EXPRESS SIMULATION'

      C2NCOD(24) =   -178
      C2NNAM(24) =  'NOZOMI'

      C2NCOD(25) =   -18
      C2NNAM(25) =  'MAGELLAN'

      C2NCOD(26) =   -183
      C2NNAM(26) =  'CLUSTER 1'

      C2NCOD(27) =   -185
      C2NNAM(27) =  'CLUSTER 2'

      C2NCOD(28) =   -188
      C2NNAM(28) =  'MUSES-B'

      C2NCOD(29) =   -190
      C2NNAM(29) =  'SIM'

      C2NCOD(30) =   -194
      C2NNAM(30) =  'CLUSTER 3'

      C2NCOD(31) =   -196
      C2NNAM(31) =  'CLUSTER 4'

      C2NCOD(32) =   -198
      C2NNAM(32) =  'INTEGRAL'

      C2NCOD(33) =   -20
      C2NNAM(33) =  'PIONEER-8'

      C2NCOD(34) =   -200
      C2NNAM(34) =  'CONTOUR'

      C2NCOD(35) =   -203
      C2NNAM(35) =  'DAWN'

      C2NCOD(36) =   -205
      C2NNAM(36) =  'SPACETECH-3 COLLECTOR'

      C2NCOD(37) =   -21
      C2NNAM(37) =  'SOHO'

      C2NCOD(38) =   -226
      C2NNAM(38) =  'ROSETTA'

      C2NCOD(39) =   -227
      C2NNAM(39) =  'KEPLER'

      C2NCOD(40) =   -228
      C2NNAM(40) =  'GALILEO PROBE'

      C2NCOD(41) =   -23
      C2NNAM(41) =  'PIONEER-10'

      C2NCOD(42) =   -234
      C2NNAM(42) =  'STEREO AHEAD'

      C2NCOD(43) =   -235
      C2NNAM(43) =  'STEREO BEHIND'

      C2NCOD(44) =   -236
      C2NNAM(44) =  'MESSENGER'

      C2NCOD(45) =   -238
      C2NNAM(45) =  'SMART-1'

      C2NCOD(46) =   -24
      C2NNAM(46) =  'PIONEER-11'

      C2NCOD(47) =   -25
      C2NNAM(47) =  'LUNAR PROSPECTOR'

      C2NCOD(48) =   -253
      C2NNAM(48) =  'MER-1'

      C2NCOD(49) =   -254
      C2NNAM(49) =  'MER-2'

      C2NCOD(50) =   -27
      C2NNAM(50) =  'VIKING 1 ORBITER'

      C2NCOD(51) =   -29
      C2NNAM(51) =  'SDU'

      C2NCOD(52) =   -30
      C2NNAM(52) =  'DS-1'

      C2NCOD(53) =   -31
      C2NNAM(53) =  'VOYAGER 1'

      C2NCOD(54) =   -32
      C2NNAM(54) =  'VOYAGER 2'

      C2NCOD(55) =   -40
      C2NNAM(55) =  'CLEMENTINE'

      C2NCOD(56) =   -41
      C2NNAM(56) =  'MARS EXPRESS'

      C2NCOD(57) =   -44
      C2NNAM(57) =  'BEAGLE 2'

      C2NCOD(58) =   -46
      C2NNAM(58) =  'SAKIGAKE'

      C2NCOD(59) =   -47
      C2NNAM(59) =  'GENESIS'

      C2NCOD(60) =   -48
      C2NNAM(60) =  'HST'

      C2NCOD(61) =   -486
      C2NNAM(61) =  'HERSCHEL'

      C2NCOD(62) =   -489
      C2NNAM(62) =  'PLANCK'

      C2NCOD(63) =   -53
      C2NNAM(63) =  'MARS SURVEYOR 01 ORBITER'

      C2NCOD(64) =   -55
      C2NNAM(64) =  'ULYSSES'

      C2NCOD(65) =   -550
      C2NNAM(65) =  'MARS96'

      C2NCOD(66) =   -58
      C2NNAM(66) =  'HALCA'

      C2NCOD(67) =   -59
      C2NNAM(67) =  'RADIOASTRON'

      C2NCOD(68) =   -6
      C2NNAM(68) =  'PIONEER-6'

      C2NCOD(69) =   -66
      C2NNAM(69) =  'VEGA 1'

      C2NCOD(70) =   -67
      C2NNAM(70) =  'VEGA 2'

      C2NCOD(71) =   -7
      C2NNAM(71) =  'PIONEER-7'

      C2NCOD(72) =   -70
      C2NNAM(72) =  'DEEP IMPACT IMPACTOR SPACECRAFT'

      C2NCOD(73) =   -74
      C2NNAM(73) =  'MARS RECON ORBITER'

      C2NCOD(74) =   -77
      C2NNAM(74) =  'GALILEO ORBITER'

      C2NCOD(75) =   -78
      C2NNAM(75) =  'GIOTTO'

      C2NCOD(76) =   -79
      C2NNAM(76) =  'SIRTF'

      C2NCOD(77) =   -8
      C2NNAM(77) =  'WIND'

      C2NCOD(78) =   -81
      C2NNAM(78) =  'CASSINI ITL'

      C2NCOD(79) =   -82
      C2NNAM(79) =  'CASSINI'

      C2NCOD(80) =   -84
      C2NNAM(80) =  'PHOENIX'

      C2NCOD(81) =   -90
      C2NNAM(81) =  'CASSINI SIMULATION'

      C2NCOD(82) =   -93
      C2NNAM(82) =  'NEAR'

      C2NCOD(83) =   -94
      C2NNAM(83) =  'MARS GLOBAL SURVEYOR'

      C2NCOD(84) =   -95
      C2NNAM(84) =  'MGS SIMULATION'

      C2NCOD(85) =   -97
      C2NNAM(85) =  'TOPEX/POSEIDON'

      C2NCOD(86) =   0
      C2NNAM(86) =  'SOLAR SYSTEM BARYCENTER'

      C2NCOD(87) =   1
      C2NNAM(87) =  'MERCURY BARYCENTER'

      C2NCOD(88) =   10
      C2NNAM(88) =  'SUN'

      C2NCOD(89) =   1000001
      C2NNAM(89) =  'AREND'

      C2NCOD(90) =   1000002
      C2NNAM(90) =  'AREND-RIGAUX'

      C2NCOD(91) =   1000003
      C2NNAM(91) =  'ASHBROOK-JACKSON'

      C2NCOD(92) =   1000004
      C2NNAM(92) =  'BOETHIN'

      C2NCOD(93) =   1000005
      C2NNAM(93) =  'BORRELLY'

      C2NCOD(94) =   1000006
      C2NNAM(94) =  'BOWELL-SKIFF'

      C2NCOD(95) =   1000007
      C2NNAM(95) =  'BRADFIELD'

      C2NCOD(96) =   1000008
      C2NNAM(96) =  'BROOKS 2'

      C2NCOD(97) =   1000009
      C2NNAM(97) =  'BRORSEN-METCALF'

      C2NCOD(98) =   1000010
      C2NNAM(98) =  'BUS'

      C2NCOD(99) =   1000011
      C2NNAM(99) =  'CHERNYKH'

      C2NCOD(100) =   1000012
      C2NNAM(100) =  'CHURYUMOV-GERASIMENKO'

      C2NCOD(101) =   1000013
      C2NNAM(101) =  'CIFFREO'

      C2NCOD(102) =   1000014
      C2NNAM(102) =  'CLARK'

      C2NCOD(103) =   1000015
      C2NNAM(103) =  'COMAS SOLA'

      C2NCOD(104) =   1000016
      C2NNAM(104) =  'CROMMELIN'

      C2NCOD(105) =   1000017
      C2NNAM(105) =  'D''ARREST'

      C2NCOD(106) =   1000018
      C2NNAM(106) =  'DANIEL'

      C2NCOD(107) =   1000019
      C2NNAM(107) =  'DE VICO-SWIFT'

      C2NCOD(108) =   1000020
      C2NNAM(108) =  'DENNING-FUJIKAWA'

      C2NCOD(109) =   1000021
      C2NNAM(109) =  'DU TOIT 1'

      C2NCOD(110) =   1000022
      C2NNAM(110) =  'DU TOIT-HARTLEY'

      C2NCOD(111) =   1000023
      C2NNAM(111) =  'DUTOIT-NEUJMIN-DELPORTE'

      C2NCOD(112) =   1000024
      C2NNAM(112) =  'DUBIAGO'

      C2NCOD(113) =   1000025
      C2NNAM(113) =  'ENCKE'

      C2NCOD(114) =   1000026
      C2NNAM(114) =  'FAYE'

      C2NCOD(115) =   1000027
      C2NNAM(115) =  'FINLAY'

      C2NCOD(116) =   1000028
      C2NNAM(116) =  'FORBES'

      C2NCOD(117) =   1000029
      C2NNAM(117) =  'GEHRELS 1'

      C2NCOD(118) =   1000030
      C2NNAM(118) =  'GEHRELS 2'

      C2NCOD(119) =   1000031
      C2NNAM(119) =  'GEHRELS 3'

      C2NCOD(120) =   1000032
      C2NNAM(120) =  'GIACOBINI-ZINNER'

      C2NCOD(121) =   1000033
      C2NNAM(121) =  'GICLAS'

      C2NCOD(122) =   1000034
      C2NNAM(122) =  'GRIGG-SKJELLERUP'

      C2NCOD(123) =   1000035
      C2NNAM(123) =  'GUNN'

      C2NCOD(124) =   1000036
      C2NNAM(124) =  'HALLEY'

      C2NCOD(125) =   1000037
      C2NNAM(125) =  'HANEDA-CAMPOS'

      C2NCOD(126) =   1000038
      C2NNAM(126) =  'HARRINGTON'

      C2NCOD(127) =   1000039
      C2NNAM(127) =  'HARRINGTON-ABELL'

      C2NCOD(128) =   1000040
      C2NNAM(128) =  'HARTLEY 1'

      C2NCOD(129) =   1000041
      C2NNAM(129) =  'HARTLEY 2'

      C2NCOD(130) =   1000042
      C2NNAM(130) =  'HARTLEY-IRAS'

      C2NCOD(131) =   1000043
      C2NNAM(131) =  'HERSCHEL-RIGOLLET'

      C2NCOD(132) =   1000044
      C2NNAM(132) =  'HOLMES'

      C2NCOD(133) =   1000045
      C2NNAM(133) =  'HONDA-MRKOS-PAJDUSAKOVA'

      C2NCOD(134) =   1000046
      C2NNAM(134) =  'HOWELL'

      C2NCOD(135) =   1000047
      C2NNAM(135) =  'IRAS'

      C2NCOD(136) =   1000048
      C2NNAM(136) =  'JACKSON-NEUJMIN'

      C2NCOD(137) =   1000049
      C2NNAM(137) =  'JOHNSON'

      C2NCOD(138) =   1000050
      C2NNAM(138) =  'KEARNS-KWEE'

      C2NCOD(139) =   1000051
      C2NNAM(139) =  'KLEMOLA'

      C2NCOD(140) =   1000052
      C2NNAM(140) =  'KOHOUTEK'

      C2NCOD(141) =   1000053
      C2NNAM(141) =  'KOJIMA'

      C2NCOD(142) =   1000054
      C2NNAM(142) =  'KOPFF'

      C2NCOD(143) =   1000055
      C2NNAM(143) =  'KOWAL 1'

      C2NCOD(144) =   1000056
      C2NNAM(144) =  'KOWAL 2'

      C2NCOD(145) =   1000057
      C2NNAM(145) =  'KOWAL-MRKOS'

      C2NCOD(146) =   1000058
      C2NNAM(146) =  'KOWAL-VAVROVA'

      C2NCOD(147) =   1000059
      C2NNAM(147) =  'LONGMORE'

      C2NCOD(148) =   1000060
      C2NNAM(148) =  'LOVAS 1'

      C2NCOD(149) =   1000061
      C2NNAM(149) =  'MACHHOLZ'

      C2NCOD(150) =   1000062
      C2NNAM(150) =  'MAURY'

      C2NCOD(151) =   1000063
      C2NNAM(151) =  'NEUJMIN 1'

      C2NCOD(152) =   1000064
      C2NNAM(152) =  'NEUJMIN 2'

      C2NCOD(153) =   1000065
      C2NNAM(153) =  'NEUJMIN 3'

      C2NCOD(154) =   1000066
      C2NNAM(154) =  'OLBERS'

      C2NCOD(155) =   1000067
      C2NNAM(155) =  'PETERS-HARTLEY'

      C2NCOD(156) =   1000068
      C2NNAM(156) =  'PONS-BROOKS'

      C2NCOD(157) =   1000069
      C2NNAM(157) =  'PONS-WINNECKE'

      C2NCOD(158) =   1000070
      C2NNAM(158) =  'REINMUTH 1'

      C2NCOD(159) =   1000071
      C2NNAM(159) =  'REINMUTH 2'

      C2NCOD(160) =   1000072
      C2NNAM(160) =  'RUSSELL 1'

      C2NCOD(161) =   1000073
      C2NNAM(161) =  'RUSSELL 2'

      C2NCOD(162) =   1000074
      C2NNAM(162) =  'RUSSELL 3'

      C2NCOD(163) =   1000075
      C2NNAM(163) =  'RUSSELL 4'

      C2NCOD(164) =   1000076
      C2NNAM(164) =  'SANGUIN'

      C2NCOD(165) =   1000077
      C2NNAM(165) =  'SCHAUMASSE'

      C2NCOD(166) =   1000078
      C2NNAM(166) =  'SCHUSTER'

      C2NCOD(167) =   1000079
      C2NNAM(167) =  'SCHWASSMANN-WACHMANN 1'

      C2NCOD(168) =   1000080
      C2NNAM(168) =  'SCHWASSMANN-WACHMANN 2'

      C2NCOD(169) =   1000081
      C2NNAM(169) =  'SCHWASSMANN-WACHMANN 3'

      C2NCOD(170) =   1000082
      C2NNAM(170) =  'SHAJN-SCHALDACH'

      C2NCOD(171) =   1000083
      C2NNAM(171) =  'SHOEMAKER 1'

      C2NCOD(172) =   1000084
      C2NNAM(172) =  'SHOEMAKER 2'

      C2NCOD(173) =   1000085
      C2NNAM(173) =  'SHOEMAKER 3'

      C2NCOD(174) =   1000086
      C2NNAM(174) =  'SINGER-BREWSTER'

      C2NCOD(175) =   1000087
      C2NNAM(175) =  'SLAUGHTER-BURNHAM'

      C2NCOD(176) =   1000088
      C2NNAM(176) =  'SMIRNOVA-CHERNYKH'

      C2NCOD(177) =   1000089
      C2NNAM(177) =  'STEPHAN-OTERMA'

      C2NCOD(178) =   1000090
      C2NNAM(178) =  'SWIFT-GEHRELS'

      C2NCOD(179) =   1000091
      C2NNAM(179) =  'TAKAMIZAWA'

      C2NCOD(180) =   1000092
      C2NNAM(180) =  'TAYLOR'

      C2NCOD(181) =   1000093
      C2NNAM(181) =  'TEMPEL 1'

      C2NCOD(182) =   1000094
      C2NNAM(182) =  'TEMPEL 2'

      C2NCOD(183) =   1000095
      C2NNAM(183) =  'TEMPEL-TUTTLE'

      C2NCOD(184) =   1000096
      C2NNAM(184) =  'TRITTON'

      C2NCOD(185) =   1000097
      C2NNAM(185) =  'TSUCHINSHAN 1'

      C2NCOD(186) =   1000098
      C2NNAM(186) =  'TSUCHINSHAN 2'

      C2NCOD(187) =   1000099
      C2NNAM(187) =  'TUTTLE'

      C2NCOD(188) =   1000100
      C2NNAM(188) =  'TUTTLE-GIACOBINI-KRESAK'

      C2NCOD(189) =   1000101
      C2NNAM(189) =  'VAISALA 1'

      C2NCOD(190) =   1000102
      C2NNAM(190) =  'VAN BIESBROECK'

      C2NCOD(191) =   1000103
      C2NNAM(191) =  'VAN HOUTEN'

      C2NCOD(192) =   1000104
      C2NNAM(192) =  'WEST-KOHOUTEK-IKEMURA'

      C2NCOD(193) =   1000105
      C2NNAM(193) =  'WHIPPLE'

      C2NCOD(194) =   1000106
      C2NNAM(194) =  'WILD 1'

      C2NCOD(195) =   1000107
      C2NNAM(195) =  'WILD 2'

      C2NCOD(196) =   1000108
      C2NNAM(196) =  'WILD 3'

      C2NCOD(197) =   1000109
      C2NNAM(197) =  'WIRTANEN'

      C2NCOD(198) =   1000110
      C2NNAM(198) =  'WOLF'

      C2NCOD(199) =   1000111
      C2NNAM(199) =  'WOLF-HARRINGTON'

      C2NCOD(200) =   1000112
      C2NNAM(200) =  'LOVAS 2'

      C2NCOD(201) =   1000113
      C2NNAM(201) =  'URATA-NIIJIMA'

      C2NCOD(202) =   1000114
      C2NNAM(202) =  'WISEMAN-SKIFF'

      C2NCOD(203) =   1000115
      C2NNAM(203) =  'HELIN'

      C2NCOD(204) =   1000116
      C2NNAM(204) =  'MUELLER'

      C2NCOD(205) =   1000117
      C2NNAM(205) =  'SHOEMAKER-HOLT 1'

      C2NCOD(206) =   1000118
      C2NNAM(206) =  'HELIN-ROMAN-CROCKETT'

      C2NCOD(207) =   1000119
      C2NNAM(207) =  'HARTLEY 3'

      C2NCOD(208) =   1000120
      C2NNAM(208) =  'PARKER-HARTLEY'

      C2NCOD(209) =   1000121
      C2NNAM(209) =  'HELIN-ROMAN-ALU 1'

      C2NCOD(210) =   1000122
      C2NNAM(210) =  'WILD 4'

      C2NCOD(211) =   1000123
      C2NNAM(211) =  'MUELLER 2'

      C2NCOD(212) =   1000124
      C2NNAM(212) =  'MUELLER 3'

      C2NCOD(213) =   1000125
      C2NNAM(213) =  'SHOEMAKER-LEVY 1'

      C2NCOD(214) =   1000126
      C2NNAM(214) =  'SHOEMAKER-LEVY 2'

      C2NCOD(215) =   1000127
      C2NNAM(215) =  'HOLT-OLMSTEAD'

      C2NCOD(216) =   1000128
      C2NNAM(216) =  'METCALF-BREWINGTON'

      C2NCOD(217) =   1000129
      C2NNAM(217) =  'LEVY'

      C2NCOD(218) =   1000130
      C2NNAM(218) =  'SHOEMAKER-LEVY 9'

      C2NCOD(219) =   1000131
      C2NNAM(219) =  'HYAKUTAKE'

      C2NCOD(220) =   1000132
      C2NNAM(220) =  'HALE-BOPP'

      C2NCOD(221) =   199
      C2NNAM(221) =  'MERCURY'

      C2NCOD(222) =   2
      C2NNAM(222) =  'VENUS BARYCENTER'

      C2NCOD(223) =   2000001
      C2NNAM(223) =  'CERES'

      C2NCOD(224) =   2000004
      C2NNAM(224) =  'VESTA'

      C2NCOD(225) =   2000216
      C2NNAM(225) =  'KLEOPATRA'

      C2NCOD(226) =   2000253
      C2NNAM(226) =  'MATHILDE'

      C2NCOD(227) =   2000433
      C2NNAM(227) =  'EROS'

      C2NCOD(228) =   2004015
      C2NNAM(228) =  'WILSON-HARRINGTON'

      C2NCOD(229) =   2009969
      C2NNAM(229) =  'BRAILLE'

      C2NCOD(230) =   2431010
      C2NNAM(230) =  'IDA'

      C2NCOD(231) =   2431011
      C2NNAM(231) =  'DACTYL'

      C2NCOD(232) =   299
      C2NNAM(232) =  'VENUS'

      C2NCOD(233) =   3
      C2NNAM(233) =  'EARTH BARYCENTER'

      C2NCOD(234) =   301
      C2NNAM(234) =  'MOON'

      C2NCOD(235) =   398989
      C2NNAM(235) =  'NOTO'

      C2NCOD(236) =   398990
      C2NNAM(236) =  'NEW NORCIA'

      C2NCOD(237) =   399
      C2NNAM(237) =  'EARTH'

      C2NCOD(238) =   399001
      C2NNAM(238) =  'GOLDSTONE'

      C2NCOD(239) =   399002
      C2NNAM(239) =  'CANBERRA'

      C2NCOD(240) =   399003
      C2NNAM(240) =  'MADRID'

      C2NCOD(241) =   399004
      C2NNAM(241) =  'USUDA'

      C2NCOD(242) =   399005
      C2NNAM(242) =  'PARKES'

      C2NCOD(243) =   399012
      C2NNAM(243) =  'DSS-12'

      C2NCOD(244) =   399013
      C2NNAM(244) =  'DSS-13'

      C2NCOD(245) =   399014
      C2NNAM(245) =  'DSS-14'

      C2NCOD(246) =   399015
      C2NNAM(246) =  'DSS-15'

      C2NCOD(247) =   399016
      C2NNAM(247) =  'DSS-16'

      C2NCOD(248) =   399017
      C2NNAM(248) =  'DSS-17'

      C2NCOD(249) =   399023
      C2NNAM(249) =  'DSS-23'

      C2NCOD(250) =   399024
      C2NNAM(250) =  'DSS-24'

      C2NCOD(251) =   399025
      C2NNAM(251) =  'DSS-25'

      C2NCOD(252) =   399026
      C2NNAM(252) =  'DSS-26'

      C2NCOD(253) =   399027
      C2NNAM(253) =  'DSS-27'

      C2NCOD(254) =   399028
      C2NNAM(254) =  'DSS-28'

      C2NCOD(255) =   399033
      C2NNAM(255) =  'DSS-33'

      C2NCOD(256) =   399034
      C2NNAM(256) =  'DSS-34'

      C2NCOD(257) =   399042
      C2NNAM(257) =  'DSS-42'

      C2NCOD(258) =   399043
      C2NNAM(258) =  'DSS-43'

      C2NCOD(259) =   399045
      C2NNAM(259) =  'DSS-45'

      C2NCOD(260) =   399046
      C2NNAM(260) =  'DSS-46'

      C2NCOD(261) =   399049
      C2NNAM(261) =  'DSS-49'

      C2NCOD(262) =   399053
      C2NNAM(262) =  'DSS-53'

      C2NCOD(263) =   399054
      C2NNAM(263) =  'DSS-54'

      C2NCOD(264) =   399055
      C2NNAM(264) =  'DSS-55'

      C2NCOD(265) =   399061
      C2NNAM(265) =  'DSS-61'

      C2NCOD(266) =   399063
      C2NNAM(266) =  'DSS-63'

      C2NCOD(267) =   399065
      C2NNAM(267) =  'DSS-65'

      C2NCOD(268) =   399066
      C2NNAM(268) =  'DSS-66'

      C2NCOD(269) =   4
      C2NNAM(269) =  'MARS BARYCENTER'

      C2NCOD(270) =   401
      C2NNAM(270) =  'PHOBOS'

      C2NCOD(271) =   402
      C2NNAM(271) =  'DEIMOS'

      C2NCOD(272) =   499
      C2NNAM(272) =  'MARS'

      C2NCOD(273) =   5
      C2NNAM(273) =  'JUPITER BARYCENTER'

      C2NCOD(274) =   50000001
      C2NNAM(274) =  'SHOEMAKER-LEVY 9-W'

      C2NCOD(275) =   50000002
      C2NNAM(275) =  'SHOEMAKER-LEVY 9-V'

      C2NCOD(276) =   50000003
      C2NNAM(276) =  'SHOEMAKER-LEVY 9-U'

      C2NCOD(277) =   50000004
      C2NNAM(277) =  'SHOEMAKER-LEVY 9-T'

      C2NCOD(278) =   50000005
      C2NNAM(278) =  'SHOEMAKER-LEVY 9-S'

      C2NCOD(279) =   50000006
      C2NNAM(279) =  'SHOEMAKER-LEVY 9-R'

      C2NCOD(280) =   50000007
      C2NNAM(280) =  'SHOEMAKER-LEVY 9-Q'

      C2NCOD(281) =   50000008
      C2NNAM(281) =  'SHOEMAKER-LEVY 9-P'

      C2NCOD(282) =   50000009
      C2NNAM(282) =  'SHOEMAKER-LEVY 9-N'

      C2NCOD(283) =   50000010
      C2NNAM(283) =  'SHOEMAKER-LEVY 9-M'

      C2NCOD(284) =   50000011
      C2NNAM(284) =  'SHOEMAKER-LEVY 9-L'

      C2NCOD(285) =   50000012
      C2NNAM(285) =  'SHOEMAKER-LEVY 9-K'

      C2NCOD(286) =   50000013
      C2NNAM(286) =  'SHOEMAKER-LEVY 9-J'

      C2NCOD(287) =   50000014
      C2NNAM(287) =  'SHOEMAKER-LEVY 9-H'

      C2NCOD(288) =   50000015
      C2NNAM(288) =  'SHOEMAKER-LEVY 9-G'

      C2NCOD(289) =   50000016
      C2NNAM(289) =  'SHOEMAKER-LEVY 9-F'

      C2NCOD(290) =   50000017
      C2NNAM(290) =  'SHOEMAKER-LEVY 9-E'

      C2NCOD(291) =   50000018
      C2NNAM(291) =  'SHOEMAKER-LEVY 9-D'

      C2NCOD(292) =   50000019
      C2NNAM(292) =  'SHOEMAKER-LEVY 9-C'

      C2NCOD(293) =   50000020
      C2NNAM(293) =  'SHOEMAKER-LEVY 9-B'

      C2NCOD(294) =   50000021
      C2NNAM(294) =  'SHOEMAKER-LEVY 9-A'

      C2NCOD(295) =   50000022
      C2NNAM(295) =  'SHOEMAKER-LEVY 9-Q1'

      C2NCOD(296) =   50000023
      C2NNAM(296) =  'SHOEMAKER-LEVY 9-P2'

      C2NCOD(297) =   501
      C2NNAM(297) =  'IO'

      C2NCOD(298) =   502
      C2NNAM(298) =  'EUROPA'

      C2NCOD(299) =   503
      C2NNAM(299) =  'GANYMEDE'

      C2NCOD(300) =   504
      C2NNAM(300) =  'CALLISTO'

      C2NCOD(301) =   505
      C2NNAM(301) =  'AMALTHEA'

      C2NCOD(302) =   506
      C2NNAM(302) =  'HIMALIA'

      C2NCOD(303) =   507
      C2NNAM(303) =  'ELARA'

      C2NCOD(304) =   508
      C2NNAM(304) =  'PASIPHAE'

      C2NCOD(305) =   509
      C2NNAM(305) =  'SINOPE'

      C2NCOD(306) =   510
      C2NNAM(306) =  'LYSITHEA'

      C2NCOD(307) =   511
      C2NNAM(307) =  'CARME'

      C2NCOD(308) =   512
      C2NNAM(308) =  'ANANKE'

      C2NCOD(309) =   513
      C2NNAM(309) =  'LEDA'

      C2NCOD(310) =   514
      C2NNAM(310) =  'THEBE'

      C2NCOD(311) =   515
      C2NNAM(311) =  'ADRASTEA'

      C2NCOD(312) =   516
      C2NNAM(312) =  'METIS'

      C2NCOD(313) =   517
      C2NNAM(313) =  'CALLIRRHOE'

      C2NCOD(314) =   518
      C2NNAM(314) =  'THEMISTO'

      C2NCOD(315) =   519
      C2NNAM(315) =  'MAGACLITE'

      C2NCOD(316) =   520
      C2NNAM(316) =  'TAYGETE'

      C2NCOD(317) =   521
      C2NNAM(317) =  'CHALDENE'

      C2NCOD(318) =   522
      C2NNAM(318) =  'HARPALYKE'

      C2NCOD(319) =   523
      C2NNAM(319) =  'KALYKE'

      C2NCOD(320) =   524
      C2NNAM(320) =  'IOCASTE'

      C2NCOD(321) =   525
      C2NNAM(321) =  'ERINOME'

      C2NCOD(322) =   526
      C2NNAM(322) =  'ISONOE'

      C2NCOD(323) =   527
      C2NNAM(323) =  'PRAXIDIKE'

      C2NCOD(324) =   528
      C2NNAM(324) =  'AUTONOE'

      C2NCOD(325) =   529
      C2NNAM(325) =  'THYONE'

      C2NCOD(326) =   530
      C2NNAM(326) =  'HERMIPPE'

      C2NCOD(327) =   531
      C2NNAM(327) =  'AITNE'

      C2NCOD(328) =   532
      C2NNAM(328) =  'EURYDOME'

      C2NCOD(329) =   533
      C2NNAM(329) =  'EUANTHE'

      C2NCOD(330) =   534
      C2NNAM(330) =  'EUPORIE'

      C2NCOD(331) =   535
      C2NNAM(331) =  'ORTHOSIE'

      C2NCOD(332) =   536
      C2NNAM(332) =  'SPONDE'

      C2NCOD(333) =   537
      C2NNAM(333) =  'KALE'

      C2NCOD(334) =   538
      C2NNAM(334) =  'PASITHEE'

      C2NCOD(335) =   599
      C2NNAM(335) =  'JUPITER'

      C2NCOD(336) =   6
      C2NNAM(336) =  'SATURN BARYCENTER'

      C2NCOD(337) =   601
      C2NNAM(337) =  'MIMAS'

      C2NCOD(338) =   602
      C2NNAM(338) =  'ENCELADUS'

      C2NCOD(339) =   603
      C2NNAM(339) =  'TETHYS'

      C2NCOD(340) =   604
      C2NNAM(340) =  'DIONE'

      C2NCOD(341) =   605
      C2NNAM(341) =  'RHEA'

      C2NCOD(342) =   606
      C2NNAM(342) =  'TITAN'

      C2NCOD(343) =   607
      C2NNAM(343) =  'HYPERION'

      C2NCOD(344) =   608
      C2NNAM(344) =  'IAPETUS'

      C2NCOD(345) =   609
      C2NNAM(345) =  'PHOEBE'

      C2NCOD(346) =   610
      C2NNAM(346) =  'JANUS'

      C2NCOD(347) =   611
      C2NNAM(347) =  'EPIMETHEUS'

      C2NCOD(348) =   612
      C2NNAM(348) =  'HELENE'

      C2NCOD(349) =   613
      C2NNAM(349) =  'TELESTO'

      C2NCOD(350) =   614
      C2NNAM(350) =  'CALYPSO'

      C2NCOD(351) =   615
      C2NNAM(351) =  'ATLAS'

      C2NCOD(352) =   616
      C2NNAM(352) =  'PROMETHEUS'

      C2NCOD(353) =   617
      C2NNAM(353) =  'PANDORA'

      C2NCOD(354) =   618
      C2NNAM(354) =  'PAN'

      C2NCOD(355) =   619
      C2NNAM(355) =  'YMIR'

      C2NCOD(356) =   620
      C2NNAM(356) =  'PAALIAQ'

      C2NCOD(357) =   621
      C2NNAM(357) =  'TARVOS'

      C2NCOD(358) =   622
      C2NNAM(358) =  'IJIRAQ'

      C2NCOD(359) =   623
      C2NNAM(359) =  'SUTTUNG'

      C2NCOD(360) =   624
      C2NNAM(360) =  'KIVIUQ'

      C2NCOD(361) =   625
      C2NNAM(361) =  'MUNDILFARI'

      C2NCOD(362) =   626
      C2NNAM(362) =  'ALBIORIX'

      C2NCOD(363) =   627
      C2NNAM(363) =  'SKADI'

      C2NCOD(364) =   628
      C2NNAM(364) =  'ERRIAPO'

      C2NCOD(365) =   629
      C2NNAM(365) =  'SIARNAQ'

      C2NCOD(366) =   630
      C2NNAM(366) =  'THRYM'

      C2NCOD(367) =   699
      C2NNAM(367) =  'SATURN'

      C2NCOD(368) =   7
      C2NNAM(368) =  'URANUS BARYCENTER'

      C2NCOD(369) =   701
      C2NNAM(369) =  'ARIEL'

      C2NCOD(370) =   702
      C2NNAM(370) =  'UMBRIEL'

      C2NCOD(371) =   703
      C2NNAM(371) =  'TITANIA'

      C2NCOD(372) =   704
      C2NNAM(372) =  'OBERON'

      C2NCOD(373) =   705
      C2NNAM(373) =  'MIRANDA'

      C2NCOD(374) =   706
      C2NNAM(374) =  'CORDELIA'

      C2NCOD(375) =   707
      C2NNAM(375) =  'OPHELIA'

      C2NCOD(376) =   708
      C2NNAM(376) =  'BIANCA'

      C2NCOD(377) =   709
      C2NNAM(377) =  'CRESSIDA'

      C2NCOD(378) =   710
      C2NNAM(378) =  'DESDEMONA'

      C2NCOD(379) =   711
      C2NNAM(379) =  'JULIET'

      C2NCOD(380) =   712
      C2NNAM(380) =  'PORTIA'

      C2NCOD(381) =   713
      C2NNAM(381) =  'ROSALIND'

      C2NCOD(382) =   714
      C2NNAM(382) =  'BELINDA'

      C2NCOD(383) =   715
      C2NNAM(383) =  'PUCK'

      C2NCOD(384) =   716
      C2NNAM(384) =  'CALIBAN'

      C2NCOD(385) =   717
      C2NNAM(385) =  'SYCORAX'

      C2NCOD(386) =   718
      C2NNAM(386) =  'PROSPERO'

      C2NCOD(387) =   719
      C2NNAM(387) =  'SETEBOS'

      C2NCOD(388) =   720
      C2NNAM(388) =  'STEPHANO'

      C2NCOD(389) =   721
      C2NNAM(389) =  'TRINCULO'

      C2NCOD(390) =   799
      C2NNAM(390) =  'URANUS'

      C2NCOD(391) =   8
      C2NNAM(391) =  'NEPTUNE BARYCENTER'

      C2NCOD(392) =   801
      C2NNAM(392) =  'TRITON'

      C2NCOD(393) =   802
      C2NNAM(393) =  'NEREID'

      C2NCOD(394) =   803
      C2NNAM(394) =  'NAIAD'

      C2NCOD(395) =   804
      C2NNAM(395) =  'THALASSA'

      C2NCOD(396) =   805
      C2NNAM(396) =  'DESPINA'

      C2NCOD(397) =   806
      C2NNAM(397) =  'GALATEA'

      C2NCOD(398) =   807
      C2NNAM(398) =  'LARISSA'

      C2NCOD(399) =   808
      C2NNAM(399) =  'PROTEUS'

      C2NCOD(400) =   899
      C2NNAM(400) =  'NEPTUNE'

      C2NCOD(401) =   9
      C2NNAM(401) =  'PLUTO BARYCENTER'

      C2NCOD(402) =   901
      C2NNAM(402) =  'CHARON'

      C2NCOD(403) =   9511010
      C2NNAM(403) =  'GASPRA'

      C2NCOD(404) =   999
      C2NNAM(404) =  'PLUTO'



      CALL TOPEN ( 'F_ZZBODS' )

C
C     Test the BODN2C call against the known body list.
C
      DO I = 1, NPERM

         TSTSTR = 'Check known name/ID code pairs, BODN2C: '//N2CNAM(I)
         CALL TCASE ( TSTSTR )
      
         CALL BODN2C ( N2CNAM(I), CODE, FOUND )
         CALL CHCKXC ( .FALSE., ' '  ,  OK )
         CALL CHCKSL ( 'FOUND', FOUND, .TRUE.,      OK )
         CALL CHCKSI ( 'CODE' , CODE , '=', N2CCOD(I), 0, OK )

      END DO

C
C     Test the BODC2N call against the known body list.
C     This body list removed duplicate ID -> NAME assignments,
C     preserving the expected mapping precedence for IDs
C     mapped to multiple names.
C
      DO I = 1, 404

         TSTSTR = 'Check known name/ID code pairs, BODC2N: #'
         CALL REPMI ( TSTSTR, '#',  C2NCOD(I), TSTSTR )
         CALL TCASE ( TSTSTR )

         CALL BODC2N ( C2NCOD(I), NAME, FOUND )
         CALL CHCKXC ( .FALSE., ' ',  OK )
         CALL CHCKSL ( 'FOUND', FOUND, .TRUE.,      OK )
         CALL CHCKSC ( 'NAME', NAME, '=', C2NNAM(I), OK )

      END DO

      CALL T_SUCCESS ( OK )
      RETURN
      END

