C$Procedure F_ZZPLAT ( Test Fortran Intrinsics )
 
      SUBROUTINE F_ZZPLAT ( OK )
 
C$ Abstract
C
C     Test family to verify that ZZPLATFM returns proper values.
C
C$ Copyright
C
C     Copyright (2001), California Institute of Technology.
C     U.S. Government sponsorship acknowledged.
C
C$ Required_Reading
C
C     None.
C
C$ Keywords
C
C     TEST FAMILY
C
C$ Declarations
 
      IMPLICIT NONE
 
      LOGICAL               OK
 
C$ Brief_I/O
C
C     VARIABLE  I/O  DESCRIPTION
C     --------  ---  --------------------------------------------------
C     OK         O   logical indicating test status.
C
C$ Detailed_Input
C
C     None.
C
C$ Detailed_Output
C
C     OK         is a logical that indicates the test status to the
C                caller.
C
C$ Parameters
C
C     None.
C
C$ Files
C
C     None.
C
C$ Exceptions
C
C     This routine does not generate any errors. Routines in its
C     call tree may generate errors that are either intentional and
C     trapped or unintentional and need reporting.  The test family
C     utilities manage this.
C
C$ Particulars
C
C     This routine checks to make certain that values returned from
C     ZZPLATFM are correct.  Not all values are checked.
C
C$ Examples
C
C     None.
C
C$ Restrictions
C
C     None.
C
C$ Author_and_Institution
C
C     F.S. Turner     (JPL)
C
C$ Literature_References
C
C     None.
C
C$ Version
C
C-    TSPICE Version 1.0.0, 18-DEC-2001 (FST)
C
C
C-&
 
C
C     SPICELIB Functions
C
      LOGICAL               EQSTR
 
C
C     Local Variables
C
      CHARACTER*(8)         BFFID
 
      DOUBLE PRECISION      DEQUIV
 
      INTEGER               IEQUIV ( 2 )
 
C
C     EQUIVALENCE statements
C
      EQUIVALENCE ( DEQUIV, IEQUIV )
 
C
C     Start the test family with an open call.
C
      CALL TOPEN ( 'F_ZZPLAT' )
 
C
C --- Case: ------------------------------------------------------
C
      CALL TCASE ( 'Binary File Format Consistency Check' )
 
C
C     Fetch the binary file format ID string.
C
      CALL ZZPLATFM ( 'FILE_FORMAT', BFFID )
 
C
C     Set the test value.
C
      DEQUIV = 1.0D0
 
C
C     Branch based on the value returned; check equivalenced
C     integers for the appropriate values.
C
      IF ( EQSTR ( BFFID, 'BIG-IEEE' ) ) THEN
 
         CALL CHCKSI ( 'IEQUIV(1)', IEQUIV(1), '=', 1072693248, 0, OK )
         CALL CHCKSI ( 'IEQUIV(2)', IEQUIV(2), '=', 0,          0, OK )
 
      ELSE IF ( EQSTR ( BFFID, 'LTL-IEEE' ) ) THEN
 
         CALL CHCKSI ( 'IEQUIV(1)', IEQUIV(1), '=', 0,          0, OK )
         CALL CHCKSI ( 'IEQUIV(2)', IEQUIV(2), '=', 1072693248, 0, OK )
 
      ELSE IF ( EQSTR ( BFFID, 'VAX-GFLT' ) ) THEN
 
         CALL CHCKSI ( 'IEQUIV(1)', IEQUIV(1), '=', 16400, 0, OK )
         CALL CHCKSI ( 'IEQUIV(2)', IEQUIV(2), '=', 0,     0, OK )
 
      ELSE IF ( EQSTR ( BFFID, 'VAX-DFLT' ) ) THEN
 
         CALL CHCKSI ( 'IEQUIV(1)', IEQUIV(1), '=', 16512, 0, OK )
         CALL CHCKSI ( 'IEQUIV(2)', IEQUIV(2), '=', 0,     0, OK )
      ELSE
         CALL TSTMSG ( '#', 'This test does not support this format.' )
         CALL CHCKSI ( 'ERROR', 0, '=', 1, 0, OK )
      END IF
 
 
C
C     Close out the test family.
C
      CALL T_SUCCESS ( OK )
      RETURN
 
      END
