
      SUBROUTINE T_CRCKDS ( SEGNO, INST, START, STOP, DESCR, GOTAV )
      IMPLICIT NONE

C$ Abstract
C
C     Create a new CK descriptor having specified ID code, angular
C     velocity flag, and time bounds.  The segment number is also 
C     encoded in the integer components of the decriptor having 
C     indices 2:NI.
C
C        18-NOV-2001 (NJB)
C
C     Support routine for TSPICE test family 
C 
C       f_ckbsr
C-&

      INTEGER               SEGNO
      INTEGER               INST
      DOUBLE PRECISION      START
      DOUBLE PRECISION      STOP
      DOUBLE PRECISION      DESCR ( * )
      LOGICAL               GOTAV

C
C     SPICELIB functions
C

C
C     Local parameters
C
      INTEGER               ND
      PARAMETER           ( ND     = 2 )

      INTEGER               NI
      PARAMETER           ( NI     = 6 )

      INTEGER               SCALE
      PARAMETER           ( SCALE  = 10000 )
 
C
C     Local variables
C
      DOUBLE PRECISION      DC ( ND )
      
      INTEGER               I
      INTEGER               IC ( NI )


      CALL CHKIN ( 'T_CRCKDS' )


      CALL CLEARI ( NI, IC )
      CALL CLEARD ( ND, DC )

      IC(1) = INST

      DO I = 2, NI
         IC(I) = SCALE * SEGNO + I
      END DO

      IF ( GOTAV ) THEN
         IC(4) = 1
      ELSE
         IC(4) = 0
      END IF

      DC(1) = START
      DC(2) = STOP

      CALL DAFPS ( ND, NI, DC, IC, DESCR )

      CALL CHKOUT ( 'T_CRCKDS' )
      END



